!***********************************************************************
!
!       SCIATRAN - Version 4.2 - Last modification: 16 Oct 2019
!       Copyright (C) - Institute of Remote Sensing,
!                       University of Bremen, Germany
!
!***********************************************************************
SUBROUTINE ARRANGE_DATA (IDS, PP_DAT)
! Called by "retrieval.f90"

  USE BRDF,        ONLY: Use_LRC, LRC
  USE DATA_RET,    ONLY: MDS, AVG_RTM, WL_MDS, PRESET_APR_NAME, N_svc
  USE INFO,        ONLY: WF_DB, STATE, RET_INFO
  USE INTERN_DIMS, ONLY: Nvs
  USE RTM_OUTPUT,  ONLY: SPEC_OUT, STOK_OUT
  USE SPHER_PARS,  ONLY: NLO => N_LOS_OUT
  USE ST_VARS,     ONLY: Pie, WL_SEGS, NSEGS, RTM_Type
  USE TOOLS,       ONLY: FIND_IDX, SMOOTH, AVERAGE
  USE TYPES,       ONLY: KND, PREPROC_DATA

  INTEGER  IDS
  TYPE (PREPROC_DATA) PP_DAT(NLO)
  ! Local variables
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'ARRANGE_DATA'
  INTEGER  NP
  LOGICAL, POINTER :: MSK_PRE(:,:), MASK(:,:)
  LOGICAL LOG_FLG, RTH_FLG, AVG_FLG
  INTEGER JSEG, J_S, J_E, I_L, R_L, JJ, N_SP, I_SBP, I_WF, NSP, I_S, K, Jsh
  INTEGER II, Isc, I_RI, IS, IE, NL, I_N, JI_S, JI_E, JS_S, JS_E, IWL, &
       N_ST, Ish, I0
  REAL (KND)  WL_S, WL_E, wl_out(1), Scal_WF, WFC, Norm
  REAL (KND), ALLOCATABLE :: MOD_LOC(:,:,:), SY_LOC(:,:,:), WF_LOC(:,:,:,:)
  REAL (KND), POINTER :: WL(:), SOL_SPEC(:)
  !==================================================================
  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE ARRANGE_DATA
