C********************************************************************C
C
C	GOMETRAN++ - Version 3.0 - Last modification: 21 Jan 2008
C
C	Copyright (C) 1995-1998, Institute of Remote Sensing,
C			         University of Bremen, Germany
C
C********************************************************************C
      SUBROUTINE BRDF_ALBEDO 
      USE BRDF_SUBRS, ONLY : BRDF_ACT
      USE BRDF,       ONLY : BRDF_PARAM
      USE NODES,      ONLY : N_PLUS, MJU_NODE,  PHI_NODE, N_MINUS, 
     $                       MJU_MINUS, PHI_MINUS, WEIGHTS, W_MINUS
      
      INTEGER             I
      DOUBLE PRECISION    SURF_REFL(N_PLUS, N_MINUS), MEAN_REFL(N_PLUS)
      DOUBLE PRECISION    NORM_1, NORM_2, ALBEDO

      CALL BRDF_ACT (BRDF_PARAM, N_PLUS, MJU_NODE(1:N_PLUS), 
     $     PHI_NODE(1:N_PLUS), N_MINUS, MJU_MINUS, PHI_MINUS, 
     $     SURF_REFL(:,1:N_MINUS))
      
      NORM_2 = DOT_PRODUCT(MJU_NODE(1:N_PLUS),WEIGHTS(1:N_PLUS))
      NORM_1 = DOT_PRODUCT(MJU_MINUS(:),W_MINUS(:))
      DO I = 1, N_PLUS
         MEAN_REFL(I) = SUM(SURF_REFL(I,:)*MJU_MINUS(:)*W_MINUS(:))
      END DO
      ALBEDO = SUM(MEAN_REFL(:)*MJU_NODE(1:N_PLUS)*WEIGHTS(1:N_PLUS))/
     $     NORM_1/NORM_2

      WRITE(6,*) '***************************************************'
      WRITE(6,*) '** Spherical albedo - ', ALBEDO 
      WRITE(6,*) '***************************************************'

      RETURN 
      END
