C********************************************************************C
C
C       SCIATRAN - Version 3.1 - Last modification: 04 Jan 2011
C
C       Copyright (C) - Institute of Remote Sensing,
C                       University of Bremen, Germany
C
C********************************************************************C
      SUBROUTINE BRDF_SETUP
c     ... Call in "general_brdf_setup.f"; "gpp_ss_stokes.f"
c                 "spher_rad.f"

      USE BRDF,     ONLY: BRDF_PARAM
      USE ST_VARS,  ONLY: BRDF_RANGE, SURF_TYPE
c     ------------------------------------------------------------------

      CHARACTER (LEN=10), PARAMETER :: R_NAME='BRDF_SETUP'
c     ==================================================================

      CALL ST_TRACK (R_NAME, 1, 'I')

      IF(BRDF_RANGE == 'UV') THEN
         SELECT CASE (TRIM(SURF_TYPE))
            CASE('spruce')  
               BRDF_PARAM(1:3) = (/0.008, -0.308, 0.554/)
            CASE('sparse erectophile') 
               BRDF_PARAM(1:3) = (/0.064, -0.001, 1.207/) 
            CASE('tropical forest') 
               BRDF_PARAM(1:3) = (/0.012, -0.169, 0.651/)
            CASE('plowed field') 
               BRDF_PARAM(1:3) = (/0.072, -0.257, 0.668/)
            CASE('grasses') 
               BRDF_PARAM(1:3) = (/0.014, -0.169, 0.810/)
            CASE('broad leaf crops') 
               BRDF_PARAM(1:3) = (/0.012, -0.281, 0.742/)
            CASE('Savannah') 
               BRDF_PARAM(1:3) = (/0.010, -0.287, 0.463/)
            CASE('leaf forest') 
               BRDF_PARAM(1:3) = (/0.022, -0.228, 0.633/)
            CASE('Conifers') 
               BRDF_PARAM(1:3) = (/0.018, -0.282, 0.364/)
            CASE('hardwood forest winter') 
               BRDF_PARAM(1:3) = (/0.028, -0.175, 0.768/)
            CASE('loam soil') 
               BRDF_PARAM(1:3) = (/0.147, -0.096, 0.839/)
            CASE('irrigated wheat') 
               BRDF_PARAM(1:3) = (/0.027, -0.078, 0.382/)
            CASE('bright') 
               BRDF_PARAM(1:3) = (/0.27, -0.0, 0.82/)
            CASE('dark') 
               BRDF_PARAM(1:3) = (/0.047, -0.2, 1.00/)
            CASE('snow') 
               BRDF_PARAM(1:6) = 
     $              (/0.728, 0.042, 0.946, -0.003, 2., -4./)
c     $              (/0.728, 0.042, 0.946, -0.003, 2., -4./)
            CASE('ocean') 
c               BRDF_PARAM(1:2) = (/5., 1.331/)
c               BRDF_PARAM(1:2) = (/5., 1.33943/) ! ref index for 0.5 mkm
               BRDF_PARAM(1:2) = (/5., 1.335/) ! for comparison to SHARM

            CASE DEFAULT 
               STOP 'Wrong surface type !'
         END SELECT
      ELSE
         SELECT CASE (TRIM(SURF_TYPE))
            CASE('spruce')  
               BRDF_PARAM(1:3) = (/0.050, -0.201, 0.581/)
            CASE('sparse erectophile') 
               BRDF_PARAM(1:3) = (/0.278, -0.006, 0.725/) 
            CASE('tropical forest') 
               BRDF_PARAM(1:3) = (/0.303, -0.034, 0.729/)
            CASE('plowed field') 
               BRDF_PARAM(1:3) = (/0.077, -0.252, 0.678/)
            CASE('grasses') 
               BRDF_PARAM(1:3) = (/ 0.242, -0.032, 0.637/)
            CASE('broad leaf crops') 
               BRDF_PARAM(1:3) = (/ 0.204, -0.089, 0.658/)
            CASE('Savannah') 
               BRDF_PARAM(1:3) = (/0.219, -0.050, 0.673/)
            CASE('leaf forest') 
               BRDF_PARAM(1:3) = (/0.285, -0.060, 0.745/)
            CASE('Conifers') 
               BRDF_PARAM(1:3) = (/0.235, -0.095, 0.758/)
            CASE('hardwood forest winter') 
               BRDF_PARAM(1:3) = (/0.066, -0.141, 0.735/)
            CASE('loam soil') 
               BRDF_PARAM(1:3) = (/0.195, -0.097, 0.850/)
            CASE('irrigated wheat') 
               BRDF_PARAM(1:3) = (/0.306, -0.008, 0.606/)
            CASE('bright') 
               BRDF_PARAM(1:3) = (/0.27, -0.0, 0.82/)
            CASE('dark') 
               BRDF_PARAM(1:3) = (/0.047, -0.2, 1.00/)
            CASE('snow') 
               BRDF_PARAM(1:6) = 
     $              (/0.728, 0.042, 0.946, -0.003, 2., -4./)
            CASE('ocean') 
               BRDF_PARAM(1:2) = (/5., 1.331/)

            CASE DEFAULT 
               STOP 'Wrong surface type !'
          END SELECT
      END IF

      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN
      END
