!***************************************************************************
!
!	SCIATRAN - Version 3.7 - Last modification: 16 Jun 2016
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE DS_FORM_2 (NLAYERS, ZZZ, Z_INT, DD_DS, IDX_ORIG_BELOW, NL, DS)
  
  USE TYPES, ONLY: KND

  INTEGER  NL, NLAYERS, IDX_ORIG_BELOW(NL)
  
  REAL (KND)  ZZZ(NLAYERS), DS(NLAYERS), DD_DS(2,NL), Z_INT(NL)
  ! Local parameters
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'DS_FORM_2'
  INTEGER   L, LL
  
  REAL (KND)  Z_E(0:NLAYERS), DS_INT(0:NLAYERS), A_UP(NL), A_DN(NL)

  !==================================================================
!  CALL ST_TRACK (R_NAME, 1, 'I')

  DS = 0.0D0
  IF(NL.EQ.1) RETURN

  Z_E(0) = ZZZ(1) + 1.0D0
  Z_E(1:NLAYERS) = ZZZ(:)
  DS_INT = 0.0D0
  
  ! Interpolation coefficients for the lower lever
  A_DN(:) = (Z_E(IDX_ORIG_BELOW(:) - 1) - Z_INT(:))/&
       (Z_E(IDX_ORIG_BELOW(:) - 1) - Z_E(IDX_ORIG_BELOW(:)))
  ! Interpolation coefficients for the upper lever
  A_UP(:) = (Z_INT(:) - Z_E(IDX_ORIG_BELOW(:)))/&
       (Z_E(IDX_ORIG_BELOW(:) - 1) - Z_E(IDX_ORIG_BELOW(:)))
  
  LL = IDX_ORIG_BELOW(1)
  DS_INT(LL) = DS_INT(LL) + A_DN(1)*DD_DS(2,1)
  DS_INT(LL - 1) = DS_INT(LL - 1) + A_UP(1)*DD_DS(2,1)

  LL = IDX_ORIG_BELOW(NL)
  DS_INT(LL) = DS_INT(LL) + A_DN(NL)*DD_DS(1,NL)
  DS_INT(LL - 1) = DS_INT(LL - 1) + A_UP(NL)*DD_DS(1,NL)

  DO L = 2, NL - 1
     LL = IDX_ORIG_BELOW(L)
     DS_INT(LL) = DS_INT(LL) + A_DN(L)*(DD_DS(1,L) + DD_DS(2,L))
     DS_INT(LL - 1) = DS_INT(LL - 1) + A_UP(L)*(DD_DS(1,L) + DD_DS(2,L))
  END DO
  
  DS(1:NLAYERS) = DS_INT(1:NLAYERS)
  
!  CALL ST_TRACK (R_NAME, 1, 'O')
  RETURN
END SUBROUTINE DS_FORM_2
