!***************************************************************************
!
!	SCIATRAN - Version 4.3 - Last modification: 05 May 2021
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
Subroutine DS_FORM_3 (ZLS, DS, IOB, NLS, A_UP, A_DN, DS_WF)
  
  Use Grids, Only: Nlayers, ZZZ
  Use Types, Only: KND

  Integer  NLS, IOB(NLS)
  Real (KND)  DS(2,NLS), ZLS(NLS)
  Real (KND), Allocatable ::  A_UP(:), A_DN(:), DS_WF(:,:)
  ! Local parameters
  Character (LEN = *), PARAMETER :: R_Name = 'DS_FORM_3'
  INTEGER   II, ILS
  !==================================================================
  Call ST_TRACK (R_NAME, 1, 'I')

  If(Allocated(A_UP)) DeAllocate(A_UP, A_DN, DS_WF)
  Allocate(A_DN(NLS), A_UP(NLS), DS_WF(0:NLS,Nlayers))

  Where(IOB(1:NLS) /= 1) 
     ! Interpolation coefficients for the lower level
     A_DN(:) = (ZZZ(IOB(:) - 1) - ZLS(:))/(ZZZ(IOB(:) - 1) - ZZZ(IOB(:)))
     ! Interpolation coefficients for the upper level
     A_UP(:) = (ZLS(:) - ZZZ(IOB(:)))/(ZZZ(IOB(:) - 1) - ZZZ(IOB(:)))
  ElseWhere
     A_DN(:) = 1.0D0
     A_UP(:) = 0.0D0
  End Where

  DS_WF (:,:) = 0.0D0
  Do ILS = 1, NLS
     II = IOB(ILS)
     DS_WF(ILS:,II) = DS_WF(ILS - 1,II) + A_DN(ILS)*(DS(1,ILS) + DS(2,ILS))
     if(II > 1) DS_WF(ILS:, II - 1) = DS_WF(ILS - 1,II - 1) + A_UP(ILS)*(DS(1,ILS) + DS(2,ILS))
  End Do
  
  Call ST_TRACK (R_NAME, 1, 'O')
  Return
End Subroutine DS_FORM_3
