C********************************************************************C
C
C       SCIATRAN - Version 4.6 - Last modification: 07 Apr 2022
C
C       Copyright (C) - Institute of Remote Sensing,
C                       University of Bremen, Germany
C
C********************************************************************C
      SUBROUTINE GENERAL_BRDF_SETUP(NSPEC, WL_INT, WL_START, WL_END, *) 
c     Call in "rtm_init.f"

      USE BRDF,        ONLY: WL_BRF, Nwl_BRF, Mh_BRF, BRDF_PARAM, 
     $                       N_OC_COMP, Path_for_BRDF, RefW_name, Nder,
     $                       RefF_name, Alph_name, Bet_name, BRF_GG_WL, 
     $                       BRF_GS_WL, Beta_ang, Beta_val, OUT_BRDF, 
     $                       Der_GG_WL, Der_GS_WL, Iref_name,
     $                       DO_OC_COMP, VS_OC_COMP, Ref_type, Foam_WL,
     $                       Leav_WL, RefF_i, AlfW, Ref_to_Abs,
     $                       RefW_r, RefW_i, RefI_r, RefI_i, 
     $                       P_yell, RefW_r0, RefW_i0, RefF_i0, Abs_pw, 
     $                       Abs_chl, N_beta, Alf0, WL0, N_svk, Wgr_svk,
     $                       Nwl_veg, WL_veg, Alb_svk, N_Sph_WL, X_brf,
     $                       Sph_OUT, Sph_WL, Ro_Li_name,
     $                       Ker_cof => IVG_cof, 
     $                       Exact_BRF, Npg, Al_veg, Al_soi, L_SOL, 
     $                       WL_refi_idx, Refi_idx, MOM_ICE, Snow_abs
      USE BRDF_SUBRS,  ONLY: BRDF_ACT_DOM, BRDF_ACT
      USE DATA_RET,    ONLY: RET_FLAG, ITERATIONS_LIMIT
      USE GT_POLYN,    ONLY: XM, AG
      USE GRIDS,       ONLY: NSOL, XSOL => SOL_GRD
      USE INFO,        ONLY: RET_INFO, PAR_INFO
      USE INTERN_DIMS, ONLY: Nvs, NNv, Ns_brf, NGb
      USE LOG_PARS,    ONLY: LUNIT, LOG_LEVEL, N_DSO, N_SSO, N_ESO, 
     $                       EU, C_UNIT, DIR_OUT
      USE PRO_SAIL,    ONLY: Nw_S, Nw_E, LAI, Cbrown, Cm, Cab, Car, Stc,
     $                       Cw, LIDFa, TypeLidf, Psoil
      USE RETR_ITER,   ONLY: ITERATION
      USE RTM_PARS,    ONLY: DATA_ITER, RTM_ST
      USE SPHER_PARS,  ONLY: ANG_OUT, ANG_SEL_FLAG, NLSA => N_LOS_ANG,
     $                       N_AZ_ANG
      USE ST_INPUT,    ONLY: PWAC_NAME
      USE ST_VARS,     ONLY: Pie, SURF_TYPE, SOLVER, BRDF_RANGE,
     $                       INT_OUT, Vec_Sca, GeoD => GeoD_Out,
     $                       NN => NSTRMS, RTM_CORE
      USE TOOLS,       ONLY: INQ_WF, CHK_STAT, SET_PTR, READ_FILE
      USE TYPE_VARS,   ONLY: KND
      USE WATER,       ONLY: N_ang_wa, Rho_wa_ang, Rho_wa, N_ang_aw, 
     $                       Rho_aw_ang, Rho_aw, ABS_COEFF_UW
c     ------------------------------------------------------------------

      INTEGER,    INTENT(IN) :: NSPEC
      REAL (KND), INTENT(IN) :: WL_INT(NSPEC), WL_START, WL_END 
c     ... Local parameters
      CHARACTER (LEN=18), PARAMETER :: R_NAME='GENERAL_BRDF_SETUP'
      LOGICAL   FLG, ERROR, STAND_WL, ADD_LOS, Lef(3), Rig(3)
      INTEGER   N_OUT, Nwl_0, Pri(3), Pli(3), Nw_PRO, N_KERN
      REAL (KND)  WL_Re, WL_Rs, WL_Te, WL_Ts
c      INTEGER, PARAMETER :: N_Phi = 100, M_max = 50
c      INTEGER, PARAMETER :: N_Phi = 180, M_max = 90
      INTEGER, PARAMETER :: N_Phi = 200, M_max = 130
      INTEGER  I, J, K, L, IA, Ii, Id, Iw, Mh, Nre, Nin, N_inc, N_ref, 
     $     Nbi, Nwl(3), N_S(3), N_E(3), M_pos, MAX_LEVEL, Ws, Ws1, IRS, 
     $     Ndb_1,  Ndb_2, Ndb_3, IS1, IS2
      REAL (KND)  DM, DUM, Area, DELTA, Uc, Vc, XS, XE,
     $     x_vect_i(3), LiD_R, mu, mu0, Phir, 
     $     X_ref(NN+Npg), X1(N_Phi), W1(N_Phi), Dc(N_Phi), 
     $     Ds(N_Phi), S1(NN+Npg,NN), S2(NN+Npg)
      REAL (KND), ALLOCATABLE :: SURF_BRF(:,:,:,:), 
     $     R1_OUT(:,:,:,:) ,R_har(:,:,:,:) ! test array
      REAL (KND), ALLOCATABLE :: WL_1(:), P1_1(:), WL_T(:,:),
     $     WL_2(:), P1_2(:), P2_2(:), WL_3(:), P1_3(:), P2_3(:), 
     $     Spher_alb(:), MuV(:), X_READ(:,:), X_inc(:), WL_PRO(:),
     $     R_dir(:,:,:,:), R_dif(:,:,:,:), S_res(:,:,:),
     $     dR_dir(:,:,:,:,:), dR_dif(:,:,:,:,:), DATA_R(:,:)
      CHARACTER (LEN=1)  VS_BRDF
      TYPE (DATA_ITER), POINTER :: RTM_PTR
c     ==================================================================
      INTERFACE
         SUBROUTINE PROSAIL( N_inc, X_inc, N_ref, X_ref, N_Phi, X1, 
     $        R_dir, R_dif, *, Nder, dR_dir, dR_dif )
         USE PRO_SAIL,  ONLY: NW_S, NW_E
         USE TYPE_VARS, ONLY: KND
         INTEGER,   INTENT(IN) :: N_inc, N_ref, N_phi, Nder
         REAL(KND), INTENT(IN) :: X_inc(N_inc), X_ref(N_ref), X1(N_Phi)
         REAL(KND)  R_dir(N_ref, N_inc, N_phi, NW_E-NW_S+1),
     $        R_dif (N_ref, N_inc, N_Phi, NW_E-NW_S+1)
         REAL(KND), ALLOCATABLE :: dR_dir(:,:,:,:,:), dR_dif(:,:,:,:,:)
         OPTIONAL :: Nder, dR_dir, dR_dif
         END SUBROUTINE
      END INTERFACE

      CALL ST_TRACK (R_NAME, 1, 'I') 
      CALL DEALLOCATE_ARRAYS ! All arrays allocated below must be 
                             ! conditionally deallocated here

      DELTA = 1.D-08  ;  MAX_LEVEL = 1000

      IF (LOG_LEVEL(1) >= N_ESO)  THEN
         WRITE(LUNIT,*) 
         WRITE(LUNIT,*) 'Number of solar zenith angles : ',NSOL
         WRITE(LUNIT,*) 'Number of wavelengths for RT calculation',NSPEC
         WRITE(LUNIT,*) 'Start and end wavelengths '
         WRITE(LUNIT,'(2x,2(2xF7.3))') WL_START, WL_END
      ENDIF
      Mh_BRF  = M_max

c     ... In the case "spher_scat" NSOL is equal to the number 
c         of solar angles grid (see "sol_grid.f")
      Ns_brf  = Nvs*NSOL

      IF( TRIM(SURF_TYPE)=='prosail') THEN
         N_inc = NSOL 
      ELSE
         N_inc = NN + NSOL
      ENDIF
      IA = 1
c     ... Additional reflection from the surface illuminated
c         under line-of-sight direction will be included 
c         in the array BRF_GS. It is used for solution of 
c         the pseudo-forward RTE in the case of observation 
c         of upward radiation.
c            ??? Case GeoD%View(IA)%S=='both' ???
      ADD_LOS = .FALSE. ;  Nbi = NSOL
      IF( SOLVER=='Solv_MIX') THEN
         IF(GeoD%View(IA)%S=='up'.OR.GeoD%View(IA)%S=='both') THEN
            ADD_LOS = .TRUE.
            Ns_brf = Ns_brf + Nvs*NLSA
            N_inc = N_inc + NLSA  ;  Nbi = Nbi + NLSA
c        ... Set line-of-sight angles in atmosphere
            ALLOCATE( MuV(NLSA) )
            SELECT CASE( ANG_SEL_FLAG )
            CASE( 'one' )
               MuV(:) = DABS( ANG_OUT(2,1:NLSA) )
            CASE( 'all' )
               MuV(:) = DABS( ANG_OUT(2,1:NLSA*N_AZ_ANG:N_AZ_ANG) )
            END SELECT
         ENDIF
      ENDIF

      ALLOCATE( X_inc(N_inc) )

c      WRITE(*,*) '  1: shape( X_inc ) ', shape( X_inc )
c      WRITE(*,*) '  1:  shape( Xsol ) ', shape( Xsol )

c     ... Additional angle corresponding to the zenith direction
c         will be introduced in the BRDF reflection angles grid 
c         to avoid extrapolation at the air-water interface for 
c         line-of-sight angles near the nadir or zenith directions

c         However, if logical INT_OUT = .TRUE. this additional angle
c         is already in the Gauss grid XM. 
c         Array X_brf is used in "solv_dom.f" to interpolate BRF
      IF( INT_OUT ) THEN
         NGb = NN    ; ALLOCATE(X_brf(NGb))
         X_brf(:) = XM(:)
      ELSE
         NGb = NN+1  ; ALLOCATE(X_brf(NGb))
         X_brf(1:NN) = XM(:) ; X_brf(NN+1) = 1.d0
      ENDIF

c     ... Local array containing cosines of reflection angles
      X_ref(1:NN) = XM(:)
      IF( Exact_BRF ) THEN
         IF( .NOT.ALLOCATED(MuV) )  ALLOCATE( MuV(NLSA) )
         SELECT CASE( ANG_SEL_FLAG )
         CASE( 'one' )
            MuV(:) = DABS( ANG_OUT(2,1:NLSA) )
         CASE( 'all' )
            MuV(:) = DABS( ANG_OUT(2,1:NLSA*N_AZ_ANG:N_AZ_ANG) )
         END SELECT
         N_ref = NN+NLSA  ;  X_ref(NN+1:N_ref) = MuV(:)
      ELSE
         N_ref = NN+1  ;  X_ref(NN+1) = 1.d0
      ENDIF

c     ... Local array containing cosines of incidence angles
      IF( TRIM(SURF_TYPE)=='prosail') THEN
c        ... Incident angles consist from solar angles and observation
c            angles (if WF should be calculated)
         X_inc(1:NSOL) = DABS( XSOL(:) )
         IF( ADD_LOS ) X_inc(NSOL+1:N_inc) = MuV(1:NLSA)
      ELSE
         !write(*,*) '  ADD_LOS  = ', ADD_LOS
         X_inc(1:NN)         = XM(:)  
         X_inc(NN+1:NN+NSOL) = DABS( XSOL(:) )
         IF( ADD_LOS ) X_inc(NN+NSOL+1:N_inc) = MuV(1:NLSA)
      ENDIF
      
c     Set wavelength grid for all BRDF parameters 
c     ===========================================
      SELECT CASE( TRIM(SURF_TYPE) )
      CASE('prosail')
         Nw_PRO = 2101 ;  ALLOCATE( WL_PRO(Nw_PRO) )
         WL_PRO(1) = 400.d0
         DO I = 2, Nw_PRO
            WL_PRO(I) = WL_PRO(I-1) + 1.d0
         ENDDO
c        Find position of start- and end-wavelengths of current net in
c        wavelength array of aerosol data
c        -------------------------------------------------------------
         IF( WL_START < WL_PRO(1) ) THEN
            NW_S = 1 
            CALL WRITE_MESSAGE(R_NAME,'WARNING',' ')
            WRITE(EU,'(A)') 
     $           '    Required wavelength range is outside of the'//
     $           ' PROSAIL database.'
            WRITE(EU,'(A,2x,F9.2)') 
     $           '    First wavelength in data base:', WL_PRO(1)
            WRITE(EU,'(A,2x,F9.2)') 
     $           '    First required wavelength    :', WL_START
            WRITE(EU,*) 
     $           '  !!! The extrapolation with constant is used !!!'
         ELSE
            CALL LIN_SEARCH(WL_START, DUM, NW_S, Nw_PRO, WL_PRO, ERROR )
            IF (ERROR) GOTO 126
         ENDIF
         CALL LIN_SEARCH( WL_END, DUM, NW_E, Nw_PRO, WL_PRO, ERROR )
         IF (ERROR) GOTO 126
         NW_E = NW_E + 1
         IF(WL_PRO(NW_E) == WL_END) NW_E = NW_E + 1
         Nwl_BRF = NW_E - NW_S + 1
         ALLOCATE( WL_BRF(Nwl_BRF) )
         WL_BRF(:) = WL_PRO(NW_S:NW_E)
c     -------> End of CASE 'prosail'
         
      CASE('white_si')
c     ... Refractive index of ice (WL input [micron])
         XS = WL_START /1.d03   !  [nm] ==> [microm] 
         XE = WL_END   /1.d03
         CALL READ_FILE(3, Iref_name, DATA_R, *880, XS, XE,
     $        NPT = 1, Skip_line = 1)
         Nwl_BRF = Size(DATA_R,1)
         ALLOCATE(WL_BRF(Nwl_BRF), RefI_r(Nwl_BRF), RefI_i(Nwl_BRF))
         WL_BRF(:) = DATA_R(:,1) ! wavelength in [micron] at this step
         RefI_r(:) = DATA_R(:,2) ! real part of water refractive index
         RefI_i(:) = DATA_R(:,3) ! imaginary part of water refractive index
         DEALLOCATE( DATA_R )
         WL_BRF(:) = WL_BRF(:) *1.d03 !  [microm] ==> [nm] 

         ALLOCATE( Snow_abs(Nwl_BRF) )
c     ... Interpolate ice refractive index
         DO I = 1, Nwl_BRF
            Snow_abs(I) = 4.d0*Pie*RefI_i(I)/WL_BRF(I)
         ENDDO

c         WRITE(*,*) '      ----- BRDF "white_si" refractive index ---'
c         DO II = 1, Nwl_BRF
c            WRITE(*,'(1x,F8.3,*(2x,es12.4))') WL_BRF(II)*1.d03,
c     $           RefI_r(II), RefI_i(II)
c         ENDDO
c         WRITE(*,*) '      -------------------------------------------'
c         Pause '  Pause in general_brdf_setup.f '
         
      CASE('melt_pond')
c        ... Refractive index of water (WL input [micron])
         XS = WL_START /1.d03 !  [nm] ==> [microm] 
         XE = WL_END   /1.d03
         CALL READ_FILE(3, RefW_name, DATA_R, *880, XS, XE,
     $        NPT = 1, Skip_line = 1)
         DO II = 1, Size(DATA_R,1)
            WRITE(*,*) DATA_R(II,1), DATA_R(II,2), DATA_R(II,3)
         ENDDO
         Nwl_BRF = Size(DATA_R,1)
         ALLOCATE(WL_BRF(Nwl_BRF), RefW_r(Nwl_BRF), RefW_i(Nwl_BRF))
         WL_BRF(:) = DATA_R(:,1)  ! wavelength in [micron] at this step
         RefW_r(:) = DATA_R(:,2)  ! real part of water refractive index
         RefW_i(:) = DATA_R(:,3)  ! imaginary part of water refractive index
         DEALLOCATE( DATA_R )
         
c        ... Refractive index of ice (WL input [micron])
         CALL READ_FILE(3, Iref_name, DATA_R, *880, XS, XE,
     $        NPT = 1, Skip_line = 1)
         Ia = Size(DATA_R,1)
c        ... Interpolate onto the wavelength grid of water refr. index
         ALLOCATE( RefI_r(Nwl_BRF), RefI_i(Nwl_BRF))
         CALL LIN_INT(Ia, DATA_R(:,1), DATA_R(:,2),
     $        Nwl_BRF, WL_BRF, RefI_r,  'C')
         CALL LIN_INT(Ia, DATA_R(:,1), DATA_R(:,3),
     $        Nwl_BRF, WL_BRF, RefI_i,  'C')
         DEALLOCATE( DATA_R )
         
c        ... Water absorption and scattering coefficients (WL input [nm])
         CALL READ_FILE(3, PWAC_NAME, DATA_R, *880, XS = WL_START, 
     $        XE = WL_END, NPT = 1)
         Ia = Size(DATA_R,1)
         WL_BRF(:) = WL_BRF(:) *1.d03 !  [microm] ==> [nm] 
         ALLOCATE( ABS_COEFF_UW(2,Nwl_BRF) )
c        ... Interpolate onto the wavelength grid of water refr. index
         CALL LIN_INT(Ia, DATA_R(:,1), DATA_R(:,2),
     $        Nwl_BRF, WL_BRF, ABS_COEFF_UW(1,:),  'C') ! absorption coeff.
         CALL LIN_INT(Ia, DATA_R(:,1), DATA_R(:,3),
     $        Nwl_BRF, WL_BRF, ABS_COEFF_UW(2,:),  'C') ! scattering coeff.
         DEALLOCATE( DATA_R )
         IF( Ref_to_Abs ) ABS_COEFF_UW(1,:) = 
     $        4.d0*Pie*RefW_i(:)/WL_BRF(:)*1.d9 

         WRITE(*,*) '      ---------------------------------  '
         DO II = 1, Nwl_BRF
            WRITE(*,'(1x,F8.3,*(2x,es12.4))') WL_BRF(II),
     $           ABS_COEFF_UW(1,II), RefW_i(II), RefI_i(II)
         ENDDO
         WRITE(*,*) '      ---------------------------------  '
c     -------> End of CASE 'melt_pond'
         
      CASE('rff','mRPV_facet')
c        ... Nwl_BRF and WL_BRF are defined already in 
c            subroutine "read_brdf.f"
      CASE('snow_artm') 
c        ... Reading of optical parameters and definition
c            of Nwl_BRF and WL_BRF
         CALL READ_ICE_OP(*880)
      CASE('user') 
         ALLOCATE( WL_BRF(Nwl_BRF) )
      CASE('Ross-Li')      ;  Nwl_BRF = 2  ;  N_KERN = 3
         IF( .NOT.ALLOCATED(WL_BRF) ) ALLOCATE( WL_BRF(Nwl_BRF) )
      CASE('Ross-Li-snow', 'snow_fasmar') ;  Nwl_BRF = 3  ;  N_KERN = 4
         IF( .NOT.ALLOCATED(WL_BRF) ) ALLOCATE( WL_BRF(Nwl_BRF) ) 
      CASE('svk')
         Nwl_BRF = 2  ;  ALLOCATE( WL_BRF(Nwl_BRF) )         
         WL_BRF(1) = 500.d0 ; WL_BRF(2) = 800.d0
      CASE('ocean') 
c         Logical array Lef(1:3) is .FALSE. if WL_DB_1 < WL_RT_1, where
c         WL_DB_1 and WL_RT_1 are the smallest wavelength in BRDF 
c         database and one required for RT calculation, respectively.
c
c         Logical array Rig(1:3) is .FALSE. if WL_DB_N > WL_RT_N, where
c         WL_DB_N and WL_RT_N are the largest wavelength in BRDF 
c         database and one required for RT calculation, respectively.
         Nwl(:) = 1  ;  Lef(:) = .FALSE. ;  Rig(:) = .FALSE.
         N_S(:) = 1 ; N_E(:) = 1
         IF( DO_OC_COMP(1) ) THEN 
            CALL SET_WHITECAPS(*880)
         ELSE  ;  ALLOCATE( WL_1(1) )  ;  ENDIF

         IF( DO_OC_COMP(2) ) THEN 
            CALL SET_FRESNEL(*880)
         ELSE  ;  ALLOCATE( WL_2(1) )  ;  ENDIF

         IF( DO_OC_COMP(3) ) THEN 
            CALL SET_WATER_LEAVING(*880)
         ELSE  ;  ALLOCATE( WL_3(1) )  ;  ENDIF

c         Combine all wavelength grids into single array
         ALLOCATE( WL_T(3,MAXVAL(Nwl(:))))
         WL_T(1,1:Nwl(1)) = WL_1(N_S(1):N_E(1))
         WL_T(2,1:Nwl(2)) = WL_2(N_S(2):N_E(2))
         WL_T(3,1:Nwl(3)) = WL_3(N_S(3):N_E(3))

c         For this component the wavelength grid has maximal sampling
         M_pos = MAXLOC( Nwl(1:3),1 )

c         WRITE(LUNIT,*) '  component for ref wl', M_pos,' ',Nwl(M_pos)
c         M_pos = 3
c         WRITE(LUNIT,*) '  test      for ref wl', M_pos,' ',Nwl(M_pos)

c         Number of infinitesimal WL which should be added to the reference
c         wavelength grid
         N_OUT = 0
         IF( Lef(M_pos) ) N_OUT = N_OUT + 1
         IF( Rig(M_pos) ) N_OUT = N_OUT + 1

c         First and last wavelength corresponding to reference WL grid
         WL_Rs = WL_T(M_pos,1)
         WL_Re = WL_T(M_pos,Nwl(M_pos))

c         WRITE(*,*) '   N_OUT for reference: ',N_OUT
c         WRITE(*,*) '   Left reference'
         DO I = 1,3
            IF( Nwl(I)==1 .OR. I==M_pos ) CYCLE
            WL_Ts = WL_T(I,1)  
            IF( WL_Ts < WL_Rs ) THEN
               Pli(I) = 
     $              MINLOC(DABS(WL_T(I,:)-WL_Rs),1,WL_T(I,:) < WL_Rs)
               N_OUT = N_OUT + Pli(I) + 1
            ELSE
               N_OUT = N_OUT + 2 
            ENDIF
         ENDDO

         DO I = 1,3
            IF( Nwl(I)==1 .OR. I==M_pos ) CYCLE
            WL_Te = WL_T(I,Nwl(I))
            IF( WL_Te > WL_Re ) THEN
               Pri(I) = 
     $              MINLOC(DABS(WL_T(I,:)-WL_Re),1,WL_T(I,:) > WL_Re)
               N_OUT = N_OUT + Nwl(I) - Pri(I) + 1 + 1
            ELSE
               N_OUT = N_OUT + 2 
            ENDIF 
         ENDDO

         Nwl_0   = Nwl(M_pos)
         Nwl_BRF = Nwl_0 + N_OUT

         IF (LOG_LEVEL(1) >= N_ESO) Then
            WRITE(LUNIT,*) '  ------->> Set general wavelength grid'
            WRITE(LUNIT,*) '  All Nwl(1:3) :', Nwl
            WRITE(LUNIT,*) '  Use Wl by component ', M_pos,' ', Nwl_BRF
            WRITE(LUNIT,*) '  Check the left and right DB wavelengths'
            DO I = 1,3
               IF( DO_OC_COMP(I) ) 
     $              WRITE(LUNIT,'(2x,I2,2x,L1,2x,L1)') I, Lef(I), Rig(i)
            ENDDO
         ENDIF

         STAND_WL = .FALSE.
         IF( Nwl_BRF > NSPEC .AND. NSPEC > 1)  THEN 
            Nwl_BRF = NSPEC
            STAND_WL = .TRUE.
            IF (LOG_LEVEL(1) >= N_ESO) Then
               WRITE(LUNIT,*) '  ------->> Optical parameters will be '
               WRITE(LUNIT,*) '   interpolated on the standard Wl grid:'
               DO I = 1, NSPEC
                  WRITE(LUNIT,'(2x,I3,2x,F8.2)') I, WL_INT(I)
               ENDDO
               WRITE(LUNIT,*) '  '
            ENDIF
         ENDIF

         IF( .NOT.ALLOCATED(WL_BRF) ) ALLOCATE( WL_BRF(Nwl_BRF),
     $        RefW_r(Nwl_BRF), RefW_i(Nwl_BRF) )
         ALLOCATE( RefF_i(Nwl_BRF), AlfW(Nwl_BRF), P_yell(Nwl_BRF) )
         
         IF( Nwl_BRF == 1 ) THEN
            RefF_i(:) = RefF_i0
            RefW_r(:) = RefW_r0 ; RefW_i(:) = Refw_i0 
            AlfW(:)   = Abs_pw  ; P_yell(:) = Abs_chl
            WL_BRF(1) = WL_START
         ELSE
c           Set single wavelength grid 
c           --------------------------
            IF( STAND_WL ) THEN
               WL_BRF(:) = WL_INT(:) 
            ELSE
               IF( M_POS == 1 ) WL_BRF(1:Nwl_0) = WL_1(N_S(1):N_E(1))
               IF( M_pos == 2 ) WL_BRF(1:Nwl_0) = WL_2(N_S(2):N_E(2))
               IF( M_pos == 3 ) WL_BRF(1:Nwl_0) = WL_3(N_S(3):N_E(3))
               CALL SET_WL_BRF
            ENDIF

            IF (LOG_LEVEL(1) >= N_ESO) Then
               WRITE(LUNIT,*) ' ------->> Optical parameters will be '
               WRITE(LUNIT,*) ' interpolated on the following Wl grid:'
               DO I = 1,NWL_BRF
                  WRITE(LUNIT,'(2x,I3,2x,F8.2)') I, WL_BRF(I)
               ENDDO
               WRITE(LUNIT,*) '  '
            ENDIF

c           Set WL-dependent parameters for foam (Whitcaps)
c           --------------------------------===============
            IF( DO_OC_COMP(1) ) THEN
               IF( TRIM(Foam_WL) == 'const' ) THEN
                  RefF_i(:) = RefF_i0
               ELSE
c                  Imaginary part of comples refractive index will be 
c                      extrapolated as zero.
                  CALL LIN_INT(Ndb_1, WL_1, P1_1, Nwl_BRF, 
     $                 WL_BRF, RefF_i, 'Z') 
               ENDIF
            ENDIF
c           Set WL-dependent parameters for glint (Fresnel)
c           --------------------------------===============
            IF( DO_OC_COMP(2) ) THEN
               IF( TRIM(Ref_type) == 'const' ) THEN
                  RefW_r(:) = RefW_r0 ; RefW_i(:) = Refw_i0 
               ELSE
c                  Real part of comples refractive index will be 
c                      extrapolated as constant.
                  CALL LIN_INT(Ndb_2, WL_2, P1_2, Nwl_BRF, 
     $                 WL_BRF, RefW_r, 'C') 
c                  Imaginary part of comples refractive index will be 
c                      extrapolated as zero.
                  CALL LIN_INT(Ndb_2, WL_2, P2_2, Nwl_BRF, 
     $                 WL_BRF, RefW_i, 'Z')
               ENDIF
            ENDIF
c           Set WL-dependent parameters for Water Leaving
c           --------------------------------=============
            IF( DO_OC_COMP(3) ) THEN
               IF( TRIM(Leav_WL) == 'const' ) THEN
                  AlfW(:) = Abs_pw ; P_yell(:) = Abs_chl
               ELSE
                  CALL LIN_INT(Ndb_3, WL_3, P1_3, Nwl_BRF, 
     $                 WL_BRF, AlfW, 'Z') 
                  CALL LIN_INT(Ndb_3, WL_3, P2_3, Nwl_BRF, 
     $                 WL_BRF, P_yell, 'Z')
               ENDIF
            ENDIF
         ENDIF
c        ---------------------------------------------------------------
      CASE DEFAULT              ! for all surfaces scalar RPV model only  
         Nwl_BRF = 1  ;  ALLOCATE( WL_BRF(Nwl_BRF) )
         SELECT CASE( BRDF_RANGE )
         CASE('UV')
            WL_BRF(1) = 450.d0
         CASE('IR')
            WL_BRF(1) = 750.d0
         END SELECT
      END SELECT
      
      ALLOCATE( 
     $     R1_OUT   (Nvs*N_ref, Nvs*N_inc, N_phi, Nwl_BRF),  ! A test array
     $     SURF_BRF (Nvs*N_ref, Nvs*N_inc, N_phi, Nwl_BRF),  ! A
     $     BRF_GG_WL(Nvs*N_ref, Nvs*NN   , M_max, Nwl_BRF),  ! A
     $     BRF_GS_WL(Nvs*N_ref, Ns_brf,    M_max, Nwl_BRF) ) ! A

c     ... Gauss grid and weights for the interval [-1,1]
      CALL GAULEG( -1.d0, 1.d0, X1, W1, N_Phi )

c     ... Transform grid to the interval [0,Pie]
      X1(:) = (Pie*X1(:) + Pie)*0.5d0

c     ... Transform weights to the integration over interval [0,1]
      W1(:) = W1(:)*0.5d0

c     ... Reading or calculating BRDF according to selected option
c     ------------------------------------------------------------
      SELECT CASE( TRIM(SURF_TYPE) )
      CASE('prosail')
         VS_BRDF = 's'
         ALLOCATE( R_dir(N_ref, N_inc, N_Phi, NW_E-NW_S+1),
     $        R_dif(N_ref, N_inc, N_Phi, NW_E-NW_S+1) )
         IF( .NOT.INQ_WF('prosail','RIT') ) THEN
            Nder = 0
            CALL PROSAIL(N_inc, X_inc, N_ref, X_ref, N_Phi, X1, 
     $           R_dir, R_dif, *880)
         ELSE
c        ... Calculations of derivatives should be done
c           ... The number of derivatives in PROSAIL
            Nder = COUNT( RET_INFO(:)%TYPE=='prosail' )
            ALLOCATE( Der_GG_WL(Nvs*N_ref,Nvs*NN,M_max,Nwl_BRF,Nder), ! A
     $           Der_GS_WL(Nvs*N_ref,Ns_brf,M_max,Nwl_BRF,Nder) )     ! A
            Der_GG_WL = 0.d0  ;  Der_GS_WL = 0.d0            
            IF( RET_FLAG.AND.ITERATION==1 ) CALL SET_PARAM
            CALL PROSAIL(N_inc, X_inc, N_ref, X_ref, N_Phi, X1, 
     $           R_dir, R_dif, *880, Nder, dR_dir, dR_dif)
         ENDIF

      CASE('rff')
c        ... NN+1 should be used
         CALL READ_FROM_FILE(NN+1, X_ref, N_Phi, X1, N_inc, X_inc,
     $        Nwl_BRF, SURF_BRF, *880 )
         VS_BRDF = 's'

      CASE('user') 
         CALL USER_BRDF( Nvs, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF )
         VS_BRDF = 's'

      CASE('ocean') 
         Area = 0.d0 ; SURF_BRF = 0.d0
c        ... Ocean reflection ==> Whitecaps
         IF( DO_OC_COMP(1) ) THEN 
            IF (LOG_LEVEL(1) >= N_DSO)  
     $           WRITE(LUNIT,*) '******* CALL "USER_WHITECAP" '
            CALL USER_WHITECAP( Nvs, N_ref, X_ref, N_Phi, X1, 
     $           N_inc, X_inc, Nwl_BRF, WL_BRF, R1_OUT, Area )
            SURF_BRF = SURF_BRF + R1_OUT
         ENDIF
c        ... Ocean reflection ==> Glint (Fresnel)
         IF( DO_OC_COMP(2) ) THEN 
            CALL BRDF_SETUP
            CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $           N_inc, X_inc, Nwl_BRF, WL_BRF, R1_OUT, 'Gauss' )
            SURF_BRF = SURF_BRF + (1.d0 - Area)*R1_OUT 
c           CALL FRESNEL_AIR_WATER_OUT
         ENDIF
c        ... Ocean reflection ==> Water leaving
         IF( DO_OC_COMP(3) ) THEN
            CALL USER_WATER( Nvs, N_ref, X_ref, N_Phi, X1, 
     $           N_inc, X_inc, Nwl_BRF, WL_BRF, R1_OUT )
            SURF_BRF = SURF_BRF + (1.d0 - Area)*R1_OUT
         ENDIF
         VS_BRDF = 's'
         DO I = 1,N_OC_COMP
            IF( DO_OC_COMP(I) .AND. VS_OC_COMP(I) == 'v' ) THEN
               VS_BRDF = 'v'  ;  EXIT
            ENDIF
         ENDDO
c     ----------- End CASE 'ocean' ------------------------------
      CASE('Ross-Li','Ross-Li-snow')
         CALL READ_KERN_COEFF(*880)
         CALL RET_COEFF(*880)
         CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF, 'both' )
         VS_BRDF = 's'

      CASE('snow_fasmar')
         CALL READ_KERN_COEFF(*880)
         CALL READ_SCM(*880)
         CALL RET_COEFF(*880)
         CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF, 'both' )
         VS_BRDF = 's'
         
      CASE('svk')
         CALL READ_SPHER_ALB(*880)
         CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF, 'both' )
         VS_BRDF = 's'

      CASE('melt_pond')
c        ... Calculation of melt pond BRF according to Malinka et al. 2018
         SURF_BRF = 0.d0
         CALL POND_BRF (N_ref, X_ref, N_Phi, X1, N_inc, X_inc,
     $        Nwl_BRF, WL_BRF, SURF_BRF )
         VS_BRDF = 's'
         
      CASE('snow_artm','white_si') 
         CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF, 'both' )
         VS_BRDF = 's'
         
      CASE('mRPV_facet')
         CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF, 'Gauss' )
         IF( Nvs > 1 ) THEN
            VS_BRDF = 'v'
         ELSE
            VS_BRDF = 's'
         ENDIF

      CASE DEFAULT   ! scalar RPV model only for all surfaces 
         CALL BRDF_SETUP
         CALL BRDF_ACT_DOM( BRDF_PARAM, N_ref, X_ref, N_Phi, X1, 
     $        N_inc, X_inc, Nwl_BRF, WL_BRF, SURF_BRF, 'Gauss' )
         VS_BRDF = 's'
      END SELECT

c  *******************************************************************
c          Fourier expansion of the reflection matrix
c  *******************************************************************
      SELECT CASE( VS_BRDF )
      CASE('v')
         IF (LOG_LEVEL(1) >= N_DSO)  
     $        WRITE(LUNIT,*) ' =======> Vector form of BRDF '

         ALLOCATE( R_har(4*N_ref,4*N_inc ,M_max,Nwl_BRF) ) ! test array
         R_har = 0.d0
c        ... Test with matrix reflection
         R1_OUT = SURF_BRF
         DO Mh = 1,M_max   
            DM = DFLOAT(Mh-1)
            Dc(:) = DCOS(DM*X1(:))*W1(:)
            Ds(:) = DSIN(DM*X1(:))*W1(:)
            DO J = 1,N_ref  ;  Nre = 4*(J-1)
               DO I = 1,N_inc  ;  Nin = 4*(I-1)
                  DO L = 1,Nwl_BRF
                     DO K = 1,4
                        R_har(Nre+K,Nin+K,Mh,L) = 
     $                       SUM(R1_out(Nre+K,Nin+K,:,L)*Dc(:))
                     ENDDO  ! over Stokes components (K)
                     R_har(Nre+1,Nin+2,Mh,L) = 
     $                    SUM(R1_out(Nre+1,Nin+2,:,L)*Dc(:))
                     R_har(Nre+2,Nin+1,Mh,L) = 
     $                    SUM(R1_out(Nre+2,Nin+1,:,L)*Dc(:))
                     DO K = 1,2
                        R_har(Nre+3,Nin+K,Mh,L) = 
     $                       SUM(R1_out(Nre+3,Nin+K,:,L)*Ds(:))
                        R_har(Nre+K,Nin+3,Mh,L) = 
     $                       -SUM(R1_out(Nre+K,Nin+3,:,L)*Ds(:))
                     ENDDO
                  ENDDO  ! over reference wavelengths (L)
               ENDDO   ! over incidence (Gauss +Sol <+LOS>) (I)
            ENDDO  ! over reflection [Gauss + 1 nadir (J)]
         ENDDO  ! over harmonic (Mh)

c        Copy entire matrix. This is full vector case
c        --------------------------------------------
         BRF_GG_WL(:,1:4*NN, :,:) = R_har(:,     1:4*NN,   :,:)
         BRF_GS_WL(:,1:4*Nbi,:,:) = R_har(:,4*NN+1:4*N_inc,:,:)

cc        Copy 1,1 matrix element only to reproduce scalar case
cc        -----------------------------------------------------
c         DO I = 1,4*(NN+1),4
c            BRF_GG_WL(I,1:4*NN: 4,:,:) = R_har(I,1:4*NN:4,:,:)
c            BRF_GS_WL(I,1:4*Nbi:4,:,:) = R_har(I,4*NN+1:4*N_inc:4,:,:)
c         ENDDO
      CASE('s')
         IF (LOG_LEVEL(1) >= N_DSO)  
     $        WRITE(LUNIT,*) ' =======> Scalar form of BRDF '

         BRF_GG_WL = 0.d0  ;  BRF_GS_WL = 0.d0
c        Fourier expansion in the scalar case
c        ------------------------------------
         IF( TRIM(SURF_TYPE)=='prosail' ) THEN
            CALL  FOURIER_PROSAIL
c            CALL CHECK_FOURIER
         ELSE
            DO Mh = 1,M_max     ! do-loop over Fourier components
               DM = DFLOAT(Mh-1)
               Dc(:) = DCOS(DM*X1(:))*W1(:)
               DO I = 1,N_Phi
                  DO K = 1,Nvs*NN,Nvs
                     BRF_GG_WL(:,K,Mh,:) = BRF_GG_WL(:,K,Mh,:) 
     $                    + SURF_BRF(:,K,I,:)*Dc(I)
                  ENDDO
                  BRF_GS_WL(:,:,Mh,:) = BRF_GS_WL(:,:,Mh,:) 
     $                 + SURF_BRF(:,Nvs*NN+1:Nvs*N_inc,I,:)*Dc(I)
               ENDDO  ! over azimuth angles (I)
            ENDDO  ! over Fourier harmonics (Mh)

c            WRITE(*,*) '   NN = ', NN
c            WRITE(*,*) '   SUM(SURF_BRF(:,1:NN,:,1)) = ',
c     $           SUM( SURF_BRF(:,1:NN,:,1) )
c            WRITE(*,*) '   SUM( BRF_GG_WL ) = ', SUM( BRF_GG_WL )
c            PAUSE '  Pause in "general_brdf_setup" '
         ENDIF
cc        ... Fourier coefficients of a constant (1.)
c         WRITE(*,*) '   Fourier coefficients of a constant: '
c         DO Mh = 1,M_max        ! do-loop over Fourier components
c            DM = DFLOAT(Mh-1) ; Dc(:) = DCOS(DM*X1(:))*W1(:) ; Uc=0.d0
c            DO I = 1,N_Phi
c               Uc = Uc  + 1.d0*Dc(I)
c            ENDDO
c            WRITE(*,*) Mh, Uc
c         ENDDO
c         write(*,*) '  End BRF_GS_WL '
      END SELECT  ! Vector/Scalar Fourier series
c      STOP
c  *******************************************************************
      
c     ... Set to zero surface reflectance if the sun below horizon
c         (more precisely: solar zenith angle larger than 89.5 deg)
      DO K = 1,NSOL
         IF( L_SOL(K) ) BRF_GS_WL(:,(K-1)*Nvs+1:K*Nvs,:,:) = 0.d0
      ENDDO

c     WRITE(*,*) '    Melt pond BRF from solar illumination'
c      WRITE(*,*) '    Ns_brf = ', Ns_brf
c      DO K = 1, N_ref
c         WRITE(*,*) K, BRF_GS_WL(K,1,1,1) 
c      ENDDO
c      PAUSE
c     Test of the Fourier expansion
c     -----------------------------
c      CALL CHECK_FOURIER_RL
c  -------------------------------------------------------------------------
c     Suma = BRF_GS_WL(NN+1,1,1,1)
c      DO Mh = 2,M_max           ! do-loop over Fourier components
c         DM = DFLOAT(Mh-1)
c         Suma = Suma + 2.0d0*BRF_GS_WL(NN+1,1,Mh,1)
c     $        *DCOS(DM*X1(Nphi))
c      ENDDO
c      WRITE(*,*) '      First harmonic BRDF:'
c      WRITE(*,'(2x,e15.7)') BRF_GS_WL(NN+1,1,1,1)
c      WRITE(*,*) '      Sum of all harmonic BRDF nadir:'
c      WRITE(*,'(2x,e15.7)') Suma
c      STOP
      
c  *******************************************************************
c          Spherical albedo corresponding to the selected BRDF
c  *******************************************************************
      ALLOCATE( Spher_alb(Nwl_BRF) )
      IF( TRIM(SURF_TYPE) /= 'prosail' ) THEN
         DO J = 1, Nwl_BRF   ; S1 = 0.d0 ; S2 = 0.d0
            DO L = 1, NN+Npg
               DO K = 1, NN
c                 ... Integration over azimuthal angle
                  DO I = 1,N_Phi
                     S1(L,K) = S1(L,K) +
     $                    SURF_BRF((L-1)*Nvs+1,(K-1)*Nvs+1,I,J)*W1(I)   
                  ENDDO  ! over azimuthal angles (I)
c              ...................................................
               ENDDO  ! over incidence angles (K)
            ENDDO  ! over reflectance angles (L)
            DO K = 1, NN+Npg
               S2(K) = SUM( S1(K,:)*AG(:)*XM(:) )
            ENDDO
            Spher_alb(J) = SUM( S2(1:NN)*AG(1:NN)*XM(1:NN) )
c           ... 4.d0*Spher_alb(J) is normalization integral  
c               in BRDF expression (see Eq.(BRF-BV) in STB)
            IF( TRIM(SURF_TYPE)=='svk' ) THEN
               N_svk(J) = 1.d0/(4.d0*Spher_alb(J))
               WRITE(*,'(A,2x,E12.4)') '     Normalization factor: ',
     $              N_svk(J)
            ENDIF
         ENDDO  ! over wavelength grid (J)
      ENDIF  ! not 'prosail' 

c     ***** Spherical albedo for selected BRDF model *******
c           -----------------------------------------
      SELECT CASE( TRIM(SURF_TYPE) )
      CASE('Ross-Li','Ross-Li-snow','snow_fasmar')
         DO I = 1,N_Sph_WL
            CALL LIN_SEARCH_NEW(Sph_WL(I), Vc, Ws, Ws1, Nwl_veg, WL_veg)
            Uc = (1.d0 - Vc)
            DUM = Uc*Ker_cof(1,Ws) + Vc*Ker_cof(1,Ws1)
            DO J = 2, N_KERN
               DUM = DUM + 4.d0*Spher_alb(J-1)
     $              *(Uc*Ker_cof(J,Ws) + Vc*Ker_cof(J,Ws1))
            ENDDO  ! over kernels (J)
            Sph_OUT(I) = DUM
         ENDDO

      CASE('svk')
         DO I = 1,N_Sph_WL
            CALL LIN_SEARCH_NEW(Sph_WL(I), Vc, Ws, Ws1, Nwl_veg, WL_veg)
            Sph_OUT(I) = (1.d0 - Vc)*Alb_svk(Ws) + Vc*Alb_svk(Ws1)
         ENDDO

      CASE('user','ocean','mRPV_facet','snow_artm','white_si')
c         write(*,*) '   Nwl_BRF ',Nwl_BRF
c         write(*,*) '    WL_BRF ', wl_BRF(:)
         IF( Nwl_BRF > 1 ) THEN
            DO I = 1,N_Sph_WL
               CALL LIN_SEARCH_NEW(Sph_WL(I),Vc,Ws,Ws1, Nwl_BRF, WL_BRF)
               Sph_OUT(I) = 4.d0*
     $              ((1.d0-Vc)*Spher_alb(Ws) + Vc*Spher_alb(Ws1))
            ENDDO
         ELSE
            Sph_OUT(:) = 4.d0*Spher_alb(1)
         ENDIF

      CASE DEFAULT  ! for all surfaces scalar RPV model only
         Sph_OUT(:) = 4.d0*Spher_alb(1)
      END SELECT

      IF (LOG_LEVEL(1) >= N_ESO) THEN
         IF( TRIM(SURF_TYPE)=='svk' ) THEN 
            WRITE(LUNIT,'(1x,a18,2x,e12.4)') '  Normalization factors'
            K = 2
         ELSE
            WRITE(LUNIT,'(1x,a18,2x,e12.4)') '  Spherical albedo'
            K = Nwl_BRF
         ENDIF
         DO J = 1, K
            WRITE(LUNIT,'(1x,F7.2,2x,e12.4)') WL_BRF(J),4.0*Spher_alb(J)
         ENDDO
         WRITE(LUNIT,*) ' '
      ENDIF
      IF( OUT_BRDF )  CALL OUTPUT_BRDF

c      STOP '   Stop in "general_brdf_setup" '

cc     ... Test for isotropic reflection function equal to 1
c      S1 = 0.d0
c      DO I = 1,N_Phi
c         S1(:,:) = S1(:,:) + W1(I)
c      ENDDO
c      FORALL( K=1:NN ) S2(K) = SUM( S1(K,1:NN)*AG(:)*XM(:) )
c      WRITE(*,'(1x,a18,2x,e12.4)') '  Spherical albedo', 
c     $     SUM( S2(1:NN)*AG(:)*XM(:) )*4.d0

      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN

 126  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'Error in LIN_SEARCH')         

 880  WRITE(EU, *) ' ---> Called by '//TRIM(R_NAME)
      RETURN 1

      CONTAINS
c **********************************************************************

      SUBROUTINE FOURIER_PROSAIL
      IF (LOG_LEVEL(1) >= N_DSO)  WRITE(LUNIT,*) 
     $           ' =======> Scalar form of BRDF for "PROSAIL"'
      DO Ii = 1,N_inc 
         DO Iw = 1, NW_E - NW_S + 1
            DO Mh = 1,M_max
               DM = DFLOAT(Mh-1) 
               Dc(:) = DCOS(DM*X1(:))*W1(:)
               DO I = 1, N_phi
                  IF( Ii==1 ) THEN
                     DO K = 1, NN
                        BRF_GG_WL(:,K,Mh,Iw) = 
     $                       BRF_GG_WL(:,K,Mh,Iw) 
     $                       + R_dif(:, Ii, I, Iw)*Dc(I)
                     ENDDO
                  ENDIF
                  BRF_GS_WL(:,Ii,Mh,Iw) = BRF_GS_WL(:,Ii,Mh,Iw) 
     $                 + R_dir(:, Ii, I, Iw)*Dc(I)
               ENDDO  ! over azimuthal angles (I)
            ENDDO   ! over Fourier components (Mh)
         ENDDO   ! over actual wavelengths (Iw)
      ENDDO   ! over incidence angles (Ii)
      IF( Nder == 0 ) RETURN
      
c     ... Fourier expansion of derivatives
      DO Id = 1, Nder
         DO Ii = 1,N_inc 
            DO Iw = 1, NW_E - NW_S + 1
               DO Mh = 1,M_max
                  DM = DFLOAT(Mh-1) 
                  Dc(:) = DCOS(DM*X1(:))*W1(:)
                  DO I = 1, N_phi
                     IF( Ii==1 ) THEN
                        DO K = 1, NN
                           Der_GG_WL(:,K,Mh,Iw,Id) = 
     $                          Der_GG_WL(:,K,Mh,Iw,Id) 
     $                          + dR_dif(:, Ii, I, Iw,Id)*Dc(I)
                        ENDDO
                     ENDIF
                     Der_GS_WL(:,Ii,Mh,Iw,Id) = 
     $                    Der_GS_WL(:,Ii,Mh,Iw,Id) 
     $                    + dR_dir(:, Ii, I, Iw, Id)*Dc(I)
                  ENDDO  ! over azimuthal angles (I)
               ENDDO  ! over Fourier components (Mh)
            ENDDO  ! over actual wavelengths (Iw)
         ENDDO  ! over incidence angles (Ii)
      ENDDO  ! over derivatives of PROSAIL(Id)
c     ... End Fourier expansion of derivatives ...
 
      RETURN
      END SUBROUTINE FOURIER_PROSAIL
c     ***************************************************************************
      
      SUBROUTINE SET_PARAM

      IF(CHK_STAT('prosail_LAI',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_LAI' )
         RTM_PTR%APR = LAI ; RTM_PTR%CRN = LAI
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Cab',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Cab' )
         RTM_PTR%APR = Cab ; RTM_PTR%CRN = Cab
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Cm',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Cm' )
         RTM_PTR%APR = Cm ; RTM_PTR%CRN = Cm
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Cbr',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Cbr' )
         RTM_PTR%APR = Cbrown ; RTM_PTR%CRN = Cbrown
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Car',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Car' )
         RTM_PTR%APR = Car ; RTM_PTR%CRN = Car
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Stc',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Stc' )
         RTM_PTR%APR = Stc ; RTM_PTR%CRN = Stc
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Cw',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Cw' )
         RTM_PTR%APR = Cw ; RTM_PTR%CRN = Cw
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Ala',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Ala' )
         RTM_PTR%APR = LIDFa ; RTM_PTR%CRN = LIDFa
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF
      IF(CHK_STAT('prosail_Pso',PAR_INFO%NAME,PAR_INFO%WF_FLG)) THEN
         CALL SET_PTR( RTM_PTR, 'prosail_Pso' )
         RTM_PTR%APR = Psoil ; RTM_PTR%CRN = Psoil
         RTM_PTR%NXT(:) = RTM_PTR%CRN(:) 
      ENDIF

      RETURN
      END SUBROUTINE SET_PARAM
c ************************************************************************

c      SUBROUTINE UPDATE_PARAM
c      II = ITERATION - 1
c      DO IRS = 1, SIZE(RTM_ST)
c         DO IS1 = 1, SIZE(RTM_ST(IRS)%SPR,1)
c            DO IS2 = 1, SIZE(RTM_ST(IRS)%SPR,2)
c               ASSOCIATE(ARR => RTM_ST(IRS)%SPR(IS1,IS2))
c               IF(.NOT.ALLOCATED(ARR%DAT(II)%NXT)) CYCLE
c               ALLOCATE(ARR%DAT(II+1)%APR(1),ARR%DAT(II+1)%CRN(1),
c     $              ARR%DAT(II+1)%NXT(1))
c               ARR%DAT(II+1)%NXT(:) = 0.0D0
c               ARR%DAT(II+1)%CRN(:) = ARR%DAT(II)%NXT(:)
c               ARR%DAT(II+1)%APR(:) = ARR%DAT(II)%APR(:)
c               END ASSOCIATE
c            ENDDO
c         ENDDO
c      ENDDO
c      RETURN
c      END SUBROUTINE UPDATE_PARAM
      
c ************************************************************************
      SUBROUTINE CHECK_FOURIER_RL
c     ... Test Fourier expansion in the scalar case of the mode 
c         'Ross-Li'
      ALLOCATE( S_res(N_ref, N_inc, N_phi) )  ;   S_res = 0.d0
      WRITE(*,*) '    N_inc = ', N_inc
      WRITE(*,*) '    N_ref = ', N_ref
      WRITE(*,*) '       NN = ', NN
      WRITE(*,*) '   SHAPE(BRF_GS_WL) ', SHAPE(BRF_GS_WL) 
      WRITE(*,*) '   SHAPE(SURF_BRF)  ', SHAPE(SURF_BRF) 
      Iw = 1
      DO Ii = 1, N_inc
         DO I = 1, N_phi
            S_res(:,Ii,I) = BRF_GS_WL(:,Ii,1,Iw)      
c            DO Mh = 2,M_max 
            DO Mh = 2,30
               DM = DFLOAT(Mh-1)
               S_res(:,Ii,I) = S_res(:,Ii,I) 
     $              + 2.d0*BRF_GS_WL(:,Ii,Mh,Iw)*DCOS( DM*X1(I) )
            ENDDO               ! over Fourier harmonics (Mh)
         ENDDO
      ENDDO
      Ii = 2
      OPEN (unit=11,file='./DATA_OUT/GS-Fourier.tes')
      DO I = 1, N_phi
         WRITE(11,'(1x,e15.7,*(2x,e15.7))') X1(I)/Pie*180.d0,
     $        ( S_res(K, Ii, I) , K = 1, N_ref )
      ENDDO
      CLOSE(11)

      OPEN (unit=11,file='./DATA_OUT/GS-orig.tes')
      DO I = 1, N_phi
         WRITE(11,'(1x,e15.7,*(2x,e15.7))') X1(I)/Pie*180.d0,
     $        ( SURF_BRF(K, NN+Ii, I, Iw), K = 1, N_ref )
      ENDDO
      CLOSE(11)

      OPEN (unit=11,file='./DATA_OUT/Ref_ang.dat')
      DO I = 1, N_ref
         WRITE(11,'(2(2x,e15.7))') X_ref(I), 
     $        DACOS( X_ref(I) )/Pie*180.d0
      ENDDO
      CLOSE(11)

      STOP  '  Stop in "CHECK_FOURIER_RL" '

      RETURN
      END SUBROUTINE CHECK_FOURIER_RL

c ************************************************************************
      SUBROUTINE CHECK_FOURIER
c     ... Test Fourier expansion in the scalar case of the mode 
c         'prosail'
c          I - be-directional reflection 
      ALLOCATE( S_res(N_ref, N_inc, N_phi) )  ;   S_res = 0.d0
      Iw = 1
      DO Ii = 1, N_inc
         DO I = 1, N_phi
            S_res(:,Ii,I) = BRF_GS_WL(:,Ii,1,Iw)      
            DO Mh = 2,M_max 
               DM = DFLOAT(Mh-1)
               S_res(:,Ii,I) = S_res(:,Ii,I) 
     $              + 2.d0*BRF_GS_WL(:,Ii,Mh,Iw)*DCOS( DM*X1(I) )
            ENDDO               ! over Fourier harmonics (Mh)
         ENDDO
      ENDDO

      OPEN (unit=11,file='./DATA_OUT/Ref_ang.dat')
        DO I = 1, N_ref
           WRITE(11,'(2(2x,e15.7))') X_ref(I), 
     $          DACOS( X_ref(I) )/Pie*180.d0
        ENDDO
      CLOSE(11)

      WRITE(*,*) '  N_ref = ', N_ref
      Ii = 1                    !  First incident angle
      OPEN (unit=11,file='./DATA_OUT/R_dir.dat')
        DO I = 1, N_phi
           WRITE(11,'(1x,e15.7,20(2x,e15.7))') X1(I)/Pie*180.d0,
     $          ( R_dir(K, Ii, I, iw) , K = 1, N_ref )
        ENDDO
      CLOSE(11)
      OPEN (unit=11,file='./DATA_OUT/R_dir.tes')
        DO I = 1, N_phi
           WRITE(11,'(1x,e15.7,20(2x,e15.7))') X1(I)/Pie*180.d0,
     $          ( S_res(K, Ii, I) , K = 1, N_ref )
        ENDDO
      CLOSE(11)
      DEALLOCATE( S_res )
c          II - directional reflection of diffuse component
      ALLOCATE( S_res(N_ref, NN, N_phi) )  ;   S_res = 0.d0

      Iw = 2
      DO I = 1, N_ref
         WRITE(*,'(2x,I3,10(e15.7))') 
     $        I, (BRF_GG_WL(I, Ii, 1, Iw), Ii = 1,4)
      ENDDO
      WRITE(*,*) '   R_dif at first wavelength '
      DO I = 1,N_ref
         WRITE(*,'(2x,I3,10(e15.7))') 
     $        I, (R_dif(I, Ii, 1, Iw), Ii = 1,N_inc)
      ENDDO

      DO Ii = 1, NN
         DO I = 1, N_phi
            S_res(:,Ii,I) = BRF_GG_WL(:,Ii,1,Iw)      
            DO Mh = 2,M_max 
               DM = DFLOAT(Mh-1)
               S_res(:,Ii,I) = S_res(:,Ii,I) 
     $              + 2.d0*BRF_GG_WL(:,Ii,Mh,Iw)*DCOS( DM*X1(I) )
            ENDDO               ! over Fourier harmonics (Mh)
         ENDDO
      ENDDO
      Ii = 1                    !  First incident angle
      OPEN (unit=11,file='./DATA_OUT/R_dif.dat')
        DO I = 1, N_phi
           WRITE(11,'(1x,e15.7,20(2x,e15.7))') X1(I)/Pie*180.d0,
     $          ( R_dif(K, Ii, I, iw) , K = 1, N_ref )
        ENDDO
      CLOSE(11)
      OPEN (unit=11,file='./DATA_OUT/R_dif.tes')
        DO I = 1, N_phi
           WRITE(11,'(1x,e15.7,20(2x,e15.7))') X1(I)/Pie*180.d0,
     $          ( S_res(K, Ii, I) , K = 1, N_ref )
        ENDDO
      CLOSE(11)

      RETURN
      END SUBROUTINE CHECK_FOURIER
c ************************************************************************

      SUBROUTINE READ_FROM_FILE(N_REF, COSR, N_AZM, PHI_REF, 
     $        N_INC, COSI, Nwl_Inp, SURF_REFL, *)

      USE BRDF,     ONLY: INP_BRDF
c     ------------------------------------------------------------------
      CHARACTER (LEN=14), PARAMETER :: R_NAME='READ_FROM_FILE'
      INTEGER,     INTENT(IN) :: N_REF, N_AZM, N_INC, Nwl_Inp
      REAL (KND),  INTENT(IN) :: COSR(N_REF), PHI_REF(N_AZM), 
     $     COSI(N_INC)
      REAL (KND)   SURF_REFL(Nvs*N_REF,Nvs*N_INC,N_AZM,Nwl_Inp)
c     ... Local variables
      INTEGER  I, Iwl, Iref, Iazm, Ince, Ihh, I_max
      REAL (KND)  TT, COSI_f(N_INC), COSR_f(N_REF), AZM_f(N_AZM)

      SURF_REFL = 0.d0
      
      OPEN(C_UNIT, file=TRIM(INP_BRDF), STATUS='OLD' )
      CALL SKIP_HEADER (C_UNIT)
c         open(44,file='./DATA_OUT/Gauss-64.dat')
c         DO I = 1, N_INC
c         write(44,'(2x,I3,2x,f8.3)') I, DACOS(COSI(I))/Pie*180. 
c         ENDDO
c         CLOSE(44)
c     ... Number of incidence angles and test of coincidence
      READ(C_UNIT,*,ERR=400) Ihh
c            IF( Ihh/=N_INC ) GOTO 401
c            READ(C_UNIT,*,ERR=400) (COSI_f(I), I=1,N_INC)
      IF( (Ihh-1)/=(N_INC-Nsol) ) GOTO 401
      READ(C_UNIT,*,ERR=400) (COSI_f(I), I=1,Ihh)

c     ... Solar angles are excluded from comparison
      I_max = MAXLOC( DABS(COSI_f(1:NN)-DACOS(COSI(1:NN))/Pie*180.),1 ) 
      TT = DABS(COSI_f(I_max)-DACOS(COSI(I_max))/Pie*180.)
      IF( TT > 0.1d0 ) GOTO 402
c     ... Solar angles are included
c          I_max = MAXLOC( DABS(COSI_f(:)-DACOS(COSI(:))/Pie*180.),1 ) 
c          TT = DABS(COSI_f(I_max)-DACOS(COSI(I_max))/Pie*180.)
c          IF( TT > 0.1d0 ) GOTO 402

c   ================================================================     
c     ... Number of reflected angles and test of coincidence
c          DO I = 1, N_REF
c            write(*,'(2x,I3,2x,f8.3)') I, DACOS(COSR(I))/Pie*180. 
c          ENDDO
      READ(C_UNIT,*,ERR=400) Ihh
      IF( Ihh/=N_REF ) GOTO 403
      READ(C_UNIT,*,ERR=400) (COSR_f(I), I=1,N_REF)

      I_max = MAXLOC( DABS(COSR_f(:)-DACOS(COSR(:))/Pie*180.),1 ) 
      TT = DABS(COSR_f(I_max)-DACOS(COSR(I_max))/Pie*180.)
      IF( TT > 0.1d0 ) GOTO 404

c     ================================================================     
cc     ... Number of azimuth angles and test of coincidence
cc     ... Number of azimuthal angles and test of coincidence
c      OPEN( 44, file = './DATA_OUT/AZM-200.dat' )
c      DO I = 1, N_AZM
c         write(44,'(2x,I3,2x,f8.3)') I, PHI_REF(I)/Pie*180.
c      ENDDO
c      CLOSE( 44 )
      READ(C_UNIT,*,ERR=400) Ihh
      IF( Ihh/=N_AZM ) GOTO 405
      READ(C_UNIT,*,ERR=400) (AZM_f(I), I=1,N_AZM)
      I_max = MAXLOC( DABS(AZM_f(:)-PHI_REF(:)/Pie*180.),1 ) 
      TT = DABS(AZM_f(I_max)-PHI_REF(I_max)/Pie*180.)
      IF( TT > 0.1d0 ) GOTO 406

      DO Iwl = 1, Nwl_Inp
c         DO Ince = 1, N_INC
         DO Ince = 1, NN + 1
            DO Iref = 1, N_REF
               READ(C_UNIT,*,ERR=400,END=407) (AZM_f(Iazm),Iazm=1,N_AZM)
               SURF_REFL(Iref,Ince,:,Iwl) = AZM_f(N_AZM:1:-1)
            ENDDO
         ENDDO
      ENDDO
      CLOSE(C_UNIT)

cc     ... Select for test purpose single azimuthal angle
cc         and single wavelength         
c      Ince = N_INC  ! Solar angle
c      Iwl = 8       ! 335 nm
c      Iazm = 50
c      WRITE(*,*) '  Two azimuthal angles', Iazm, Iazm + 1
c      WRITE(*,*) PHI_REF(Iazm)/Pie*180., PHI_REF(Iazm+1)/Pie*180.
c      OPEN( 44, file='./DATA_OUT/Orig_BRF.dat' )
c        DO Iref = 1, N_REF
c           WRITE(44,*) DACOS(COSR(Iref))/Pie*180.,
c     $         SURF_REFL(Iref,Ince,Iazm,Iwl),  
c     $         SURF_REFL(Iref,Ince,Iazm+1,Iwl)
c        ENDDO
c      CLOSE(44)

      RETURN

 400  CALL WRITE_MESSAGE (R_NAME,'ERROR','Error reading')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      RETURN 1

 401  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Number of incident angles are different')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      WRITE(EU,'(a,I3)') '       In file:', Ihh
      WRITE(EU,'(a,I3)') '    In program:', N_INC
      RETURN 1
 402  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Incident angles are different')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      WRITE(EU,'(a,F7.3)') '      In file:', COSI_f(I_max)
      WRITE(EU,'(a,F7.3)') '   In program:', DACOS(COSI(I_max))/Pie*180.
      RETURN 1

 403  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Number of reflection angles are different')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      WRITE(EU,'(a,I3)') '       In file:', Ihh
      WRITE(EU,'(a,I3)') '    In program:', N_REF
      RETURN 1
 404  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Reflection angles are different')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      WRITE(EU,'(a,F7.3)') '      In file:', COSR_f(I_max)
      WRITE(EU,'(a,F7.3)') '   In program:', DACOS(COSR(I_max))/Pie*180.
      RETURN 1

 405  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Number of azimuthal angles are different')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      WRITE(EU,'(a,I3)') '       In file:', Ihh
      WRITE(EU,'(a,I3)') '    In program:', N_AZM
      RETURN 1
 406  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Azimuthal angles are different')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      WRITE(EU,'(a,F8.3)') '       In file:', AZM_f(I_max)
      WRITE(EU,'(a,F8.3)') '    In program:', PHI_REF(I_max)/Pie*180.
      RETURN 1

 407  CALL WRITE_MESSAGE (R_NAME,'ERROR','End of file by reading.')
      WRITE(EU,*) '    File name : ', TRIM(INP_BRDF) 
      RETURN 1

      END SUBROUTINE READ_FROM_FILE
c ************************************************************************

      SUBROUTINE READ_ICE_OP(*)
c     -------------------------------------------------------------------
      USE BRDF,  ONLY: IOP_name, Iref_name, NIce, Nmom_ICE, Ref_ip
      USE INTERN_DIMS, ONLY: Nm_vs
c     -------------------------------------------------------------------
c     ... Local variables
      CHARACTER (LEN=11), PARAMETER :: R_NAME='READ_ICE_OP'
      INTEGER, PARAMETER :: MAXMOM_LOC = 10000
      INTEGER J1, J2, N_FUL, N_WL, WLS, WLE, Ws, Ws1, R_start, 
     $     R_end, I_tmp
      INTEGER, ALLOCATABLE:: N_momi(:)
      REAL (KND) DUM, DUM1, DD1, WL_MIN, WL_MAX, TMP2(Nm_vs), WLO, DC
      REAL (KND), ALLOCATABLE:: WL(:), MOM_LOC(:,:,:)
c     ==================================================================

      CALL ST_TRACK (R_NAME, 1, 'I')

      WL_MIN = WL_START - 0.5d0
      WL_MAX = WL_END   + 0.5d0

c     ... Open file for ice refractive index
      OPEN(C_UNIT,FILE = TRIM(Iref_name), STATUS='old')
         Read(C_UNIT,*) N_FUL
         J1 = 0 ; J2 = 0
         DO I = 1, N_FUL
            READ(C_UNIT,*) DD1
            DD1 = DD1*1000.0d0 ! Transform [mkm] => [nm]
            IF( DD1 >= WL_MIN .AND. J1 == 0) J1 = I
            IF( DD1 >  WL_MAX .AND. J2 == 0) THEN 
               J2 = I ; EXIT
            ENDIF
         ENDDO
         IF( J1 > 1 ) J1 = J1 - 1
         IF( J2 == 0 ) GOTO 320
         NIce =  J2 - J1 + 1
         ALLOCATE( WL_refi_idx(Nice), Refi_idx(Nice) )
         DO I = 1,Nice ; BACKSPACE(C_UNIT) ; ENDDO
c       ... Reading albedo of vegetation in actual spectral range
         DO I = 1,Nice 
            READ(C_UNIT,*,ERR=222) WL_refi_idx(I), DUM, Refi_idx(I)
         ENDDO
      CLOSE(C_UNIT)
      WL_refi_idx(:) = WL_refi_idx(:)*1000.0d0 ! Transform [mkm] => [nm]
               WRITE(*,*) '    Wl_start', WL_START
               WRITE(*,*) '      Wl_end', WL_END
               DO I = 1, Nice
                  WRITE(*,*) WL_refi_idx(I), Refi_idx(I)
               ENDDO
c     ... Read local wavelength grid for ice particles databases
      OPEN(C_UNIT,FILE = IOP_name//'_wvl.dbs',STATUS='OLD')
        READ(C_UNIT,*) N_WL ;  ALLOCATE( WL(N_WL))
        DO K = 1, N_WL
           READ(C_UNIT,*) WL(K)
        ENDDO
        WL(:) = WL(:)*1.D+03    ! Convert to [nm]
      CLOSE( C_UNIT )

      ALLOCATE( N_momi(N_WL) )

c     ... Find position of start- and end-wavelengths of "main" grid 
c         in wavelength array of a local grid for ice DB
c     ----------------------------------------------------------------
      CALL LIN_SEARCH_NEW(WL_MIN, DUM, WLS, Ws1, N_WL, WL)
      CALL LIN_SEARCH_NEW(WL_MAX, DUM, Ws,  WLE, N_WL, WL)
c     ... Total number of "ice" actual wavelengths 
c     --------------------------------------------
      Nwl_BRF = WLE - WLS + 1

c     ... Reading number of expnsion coefficients from DB
c     --------------------------------------------------------------
      OPEN( C_UNIT,FILE = IOP_name//'_ssa.dbs',STATUS='OLD' )
      DO K = 1,N_WL
         READ(C_UNIT,'(2(D14.7),I5)') DUM, DUM1, N_momi(K)
      ENDDO
      CLOSE( C_UNIT ) 

      NMOM_ICE = MAXVAL( N_momi(WLS:WLE) )

      WRITE(*,*) '   NMOM_ICE ', NMOM_ICE

      ALLOCATE( MOM_ICE(Nwl_BRF,NMOM_ICE,Nm_vs), WL_BRF(Nwl_BRF) )
      MOM_ICE = 0.d0
      WL_BRF(1:Nwl_BRF) = WL(WLS:WLE)

c     ... Reading moments of the phase matrixes for ice particles
c     -----------------------------------------------------------
      OPEN(C_UNIT,FILE=IOP_name//'_moms.dbs' ,STATUS='OLD',RECL=500000)         
      R_start = SUM( N_momi(1:WLS-1) )
      R_end   = SUM( N_momi(1:WLE) )
c     ... Skip moments for all wavelengths before actual
c     --------------------------------------------------
      DO K = 1,R_start ; READ( C_UNIT,* ) ; ENDDO            
      II = 0
      DO K = WLS, WLE  ;  II = II + 1
         IF( N_momi(K) > MAXMOM_LOC ) THEN
            WRITE(*,*) '  ******* MAXMOM_LOC is too small ******* '
            CALL WRITE_MESSAGE(R_NAME, 'ERROR', 
     $           'Actual number of phase function moments '//
     $           'read from database is too large')
            WRITE(EU,*) 
     $           '  Actual number of moments  : ', N_momi(K)
            WRITE(EU,*) 
     $           '  Maximal number of moments : ', MAXMOM_LOC
            WRITE(EU,*) 
     $           '  Increase parameter MAXMOM_LOC in ', R_NAME
            RETURN 1
         ENDIF
         DO I = 1,N_momi(K)
            READ(C_UNIT,'(D11.4,I5,6(D14.7))') 
     $           DUM, I_tmp, (TMP2(J), J=1,Nm_vs)
            MOM_ICE(II,I,1:Nm_vs) = Tmp2(1:Nm_vs)
            IF( I == 1 ) THEN
               IF( I_tmp /= 1 ) THEN
                  STOP 'Error reading of ice database'
               ENDIF
            ENDIF
         ENDDO  ! over number of moments (I)
      ENDDO  ! over actual wavelengths (K)
      IF( Nm_vs > 1 ) THEN
         MOM_ICE(:,:,5) = -MOM_ICE(:,:,5)
         MOM_ICE(:,:,6) = -MOM_ICE(:,:,6)
      ENDIF
      CLOSE( C_UNIT ) 
             WRITE(*,*) '    Selected WL_BRF '
             K = WLS
             DO I = 1, Nwl_BRF
                WRITE(*,*) I, wl_BRF(I), N_momi(K)
                K = K + 1
             ENDDO
      ALLOCATE( Snow_abs(Nwl_BRF) )
c     ... Interpolate ice refractive index
      DO I = 1, Nwl_BRF
         WLO = WL_BRF(I)
         CALL LIN_SEARCH_NEW(WLO, DC, Ws, Ws1, Nice, WL_refi_idx)
         DUM = (1.d0 - DC)*Refi_idx(Ws) + DC*Refi_idx(Ws1)
         Snow_abs(I) = DSQRT( 4.d0*Pie*DUM/WLO*2.d0*Ref_ip )
      ENDDO

      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN

 222  CALL WRITE_MESSAGE (R_NAME, 'ERROR','Error reading data file!')
      WRITE(EU,*) '    File name : ', TRIM(Iref_name) 
      RETURN 1

 320  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Refr. index  does not cover required spectral range')
      WRITE(EU,*) '    File name : ', TRIM(Iref_name) 
      WRITE(EU,'(a,F8.3,a,F8.3)') '    Required spectral range:',
     $     WL_MIN,' - ',WL_MAX
      RETURN 1

      END SUBROUTINE READ_ICE_OP
c ************************************************************************

      SUBROUTINE READ_SPHER_ALB(*)

      USE BRDF,     ONLY: Spha_veg, Spha_soi, Cfr_v, NDVI, Al_veg,  
     $                    Al_soi, AB_DB
      USE INFO,     ONLY: RET_INFO
      USE ST_VARS,  ONLY: RTM_MODE
c     ------------------------------------------------------------------

      CHARACTER (LEN=14), PARAMETER :: R_NAME='READ_SPHER_ALB'
      CHARACTER (LEN=80) Name_OUT
      INTEGER Nwl_v, Nwl_soi, J1, J2, Ws, Ws1
      REAL (KND) WL_MIN, WL_MAX, DD1, Dx, A_865, A_675, DUM
c     ... Two wavelength used to calculate NDVI
      REAL (KND), PARAMETER :: WLL=675.d0, WLR=865.d0, A_MIN = 0.005d0
      REAL (KND), ALLOCATABLE :: WL_soi(:), Alb_soi(:), Alb_int(:)
c     ==================================================================

      CALL ST_TRACK (R_NAME, 1, 'I')

      WL_MIN = DMIN1(WL_START,WLL)
      WL_MAX = DMAX1(WL_END,WLR)

c     ... Reading file containing vegetation albedo
      Name_OUT = Spha_veg
c      WRITE(*,*)  '   1 - ', TRIM(Spha_veg)
      IF( .NOT.AB_DB ) THEN
c        *****  Reading vegetation spectrum *****
         OPEN(C_UNIT, FILE = TRIM(Spha_veg), STATUS='old')
         CALL SKIP_HEADER (C_UNIT)           
c       ... Number of wavelength in the file
         READ(C_UNIT,*) Nwl_v
         J1 = 0 ; J2 = 0
         DO I = 1, Nwl_v
            READ(C_UNIT,*) DD1
            IF( DD1 >= WL_MIN .AND. J1 == 0) J1 = I
            IF( DD1 >  WL_MAX .AND. J2 == 0) THEN 
               J2 = I ; EXIT
            ENDIF
         ENDDO
         IF( J1 > 1 ) J1 = J1 - 1
         IF( J2 == 0 ) GOTO 120
         Nwl_veg =  J2 - J1 + 1
         ALLOCATE( WL_veg(Nwl_veg), Alb_svk(Nwl_veg), Alb_int(Nwl_veg) )
         DO I = 1,Nwl_veg ; BACKSPACE(C_UNIT) ; ENDDO
c       ... Reading albedo of vegetation in actual spectral range
         DO I = 1,Nwl_veg 
            READ(C_UNIT,*,ERR=222) WL_veg(I), Alb_svk(I)
         ENDDO
         CLOSE(C_UNIT) 
c        ****************************************
c        ... Check spectral range coverage for vegetation albedo
         DD1 = WL_veg(1)       ; IF( DD1 > WL_MIN ) GOTO 121
         DD1 = WL_veg(Nwl_veg) ; IF( DD1 < WL_MAX ) GOTO 122
         IF( INQ_WF('albedo', 'RIN') ) THEN
            Dx = MINVAL( Alb_svk(:) )
            IF( Dx < A_MIN  ) THEN
               Dx = A_MIN - Dx
               WRITE(*,*) '   Alb vegetation before :', Alb_svk(1)
               Alb_svk(:) = Alb_svk(:) + Dx
               WRITE(*,*) '    Alb vegetation after :', Alb_svk(1)
            ENDIF
            ALLOCATE( Al_veg(Nwl_veg) ) 
            Al_veg(:) = Alb_svk(:)
         ENDIF
c        ... Reading file containing soil albedo (or B coefficients)
         Name_OUT = Spha_soi
c        *********  Reading soil spectrum ********
         OPEN(C_UNIT, FILE = TRIM(Spha_soi), STATUS='old')
         CALL SKIP_HEADER (C_UNIT)           
c        ... Number of wavelength in the file
         READ(C_UNIT,*) Nwl_v
         J1 = 0 ; J2 = 0
         DO I = 1, Nwl_v
            READ(C_UNIT,*) DD1
            IF( DD1 >= WL_MIN .AND. J1 == 0) J1 = I
            IF( DD1 >  WL_MAX .AND. J2 == 0) THEN 
               J2 = I ; EXIT
            ENDIF
         ENDDO
         IF( J1 > 1 ) J1 = J1 - 1
         IF( J2 == 0 ) GOTO 120
         Nwl_soi =  J2 - J1 + 1
         ALLOCATE( WL_soi(Nwl_soi), Alb_soi(Nwl_soi) )
         DO I = 1,Nwl_soi ; BACKSPACE(C_UNIT) ; ENDDO
c          ... Reading albedo of soil in actual spectral range
         DO I = 1,Nwl_soi 
            READ(C_UNIT,*,ERR=222) WL_soi(I), Alb_soi(I)
         ENDDO
         CLOSE(C_UNIT) 
c        ****************************************************
c        ... Check spectral range coverage for soil albedo
         DD1 = WL_soi(1)       ; IF( DD1 > WL_MIN ) GOTO 121
         DD1 = WL_soi(Nwl_soi) ; IF( DD1 < WL_MAX ) GOTO 122

c        ... Interpolation of soil albedo on the wavelength grid of 
c            vegetation (extrapolation as constant)
         CALL LIN_INT(Nwl_soi, WL_soi, Alb_soi, Nwl_veg, 
     $        WL_veg, Alb_int, 'C') 
         IF( INQ_WF('albedo', 'RIN') ) THEN
            Dx = MINVAL( Alb_int(:) )
            IF( Dx < A_MIN  ) THEN
               Dx = A_MIN - Dx
               WRITE(*,*) '   Alb soil before :', Alb_int(1)
               Alb_int(:) = Alb_int(:) + Dx
               WRITE(*,*) '    Alb soil after :', Alb_int(1)
            ENDIF
            ALLOCATE( Al_soi(Nwl_veg) ) 
            Al_soi(:) = Alb_int(:)
         ENDIF
c        ... Weighting of vegetation and soil albedo
         Alb_svk(:) = Cfr_v*Alb_svk(:) + (1.d0 - Cfr_v)*Alb_int(:)
      ELSE
c        ... Use A and B spectral surface coefficients
c        ================================================
         OPEN(C_UNIT, FILE = TRIM(Spha_veg), STATUS='old')
         CALL SKIP_HEADER (C_UNIT)           
c       ... Number of wavelength in the file
         READ(C_UNIT,*) Nwl_veg
         ALLOCATE( WL_veg(Nwl_veg), Alb_svk(Nwl_veg), Alb_int(Nwl_veg) )
c       ... Reading  of A and B coefficient for all discrete wavelengths
         DO I = 1,Nwl_veg 
            READ(C_UNIT,*,ERR=222) WL_veg(I), Alb_svk(I), Alb_int(I)
         ENDDO
         CLOSE(C_UNIT) 
c        ... In this option Cfr_v is SAVI parameter     
         Alb_svk(:) = Cfr_v*Alb_svk(:) + Alb_int(:)
         Dx = Alb_svk(Nwl_veg)
c          WRITE(*,*) '   Albedo for last WL : ', Dx
         Alb_svk(1:9) = Alb_svk(1:9)*Dx
         DUM = MINVAL( Alb_svk(:) )
         IF( DUM <= 0.d0 ) 
     $        STOP '  Negative albedo in "general_brdf_setup.f" ' 
      ENDIF

      OPEN( 47,FILE='./DATA_OUT/SVK-albedo.dat' )
        WRITE(47,'(A)') '# Albedo corresponds to the soil + vegetation'
        WRITE(47,'(A,2x,f6.3)') 
     $       '#    with vegetation fraction', Cfr_v
        WRITE(47,*) Nwl_veg
        DO I = 1, Nwl_veg
           WRITE(47,'(2(2x,e15.7))')  WL_veg(I), Alb_svk(I)
        ENDDO
      CLOSE(47)

c      WRITE(*,*) ' Alb AB-brdf: '
c      WRITE(*,*) Alb_svk
c      OPEN( 47,FILE='Paris-ref.dat',STATUS='OLD' )
c        DO I = 1,3
c           READ(47,*) 
c        ENDDO
c        DO I = 1,13
c           READ(47,*) DUM, DM, Alb_svk(I)
c        ENDDO
c      CLOSE(47)
c      WRITE(*,*) ' Alb AB-brdf: '
c      WRITE(*,*) Alb_svk
c      PAUSE

c     ... Calculate NDVI corresponding to the weighted 
c         vegetation-soil albedo
      CALL LIN_SEARCH_NEW(WLL, DD1, Ws, Ws1, Nwl_veg, WL_veg)
      A_675 = (1.d0 - DD1)*Alb_svk(Ws) + DD1*Alb_svk(Ws1)
      CALL LIN_SEARCH_NEW(WLR, DD1, Ws, Ws1, Nwl_veg, WL_veg)
      A_865 = (1.d0 - DD1)*Alb_svk(Ws) + DD1*Alb_svk(Ws1)
      NDVI = (A_865 - A_675)/(A_865 + A_675)
      WRITE(*,*) '   NDVI = ',NDVI

c      WRITE(*,*) '   !!!! Test perturbation BRDF !!!! '
c      Alb_svk(:) = 1.01*Cfr_v*(Al_veg(:) - Al_soi(:)) + Al_soi(:)
c      Alb_svk(:) = 1.1*Alb_svk(:)

      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN

 120  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Spherical albedo does not cover required spectral range')
      WRITE(EU,*) '    File name : ', TRIM(Name_OUT) 
      WRITE(EU,'(a,F8.3,a,F8.3)') '    Required spectral range:',
     $     WL_MIN,' - ',WL_MAX
      RETURN 1

 121  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Spherical albedo does not cover required spectral range')
      WRITE(EU,*) '    File name : ', TRIM(Name_OUT) 
      WRITE(EU,'(a,F8.3,a,F8.3)') '    Required spectral range:',
     $     WL_MIN,' - ',WL_MAX
      WRITE(EU,'(a,F8.3)')       '    Minimal wavelength in file:',
     $     DD1
      RETURN 1

 122  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Spherical albedo does not cover required spectral range')
      WRITE(EU,*) '    File name : ', TRIM(Name_OUT) 
      WRITE(EU,'(a,F8.3,a,F8.3)') '    Required spectral range:',
     $     WL_MIN,' - ',WL_MAX
      WRITE(EU,'(a,F8.3)')       '    Maximal wavelength in file:',
     $     DD1
      RETURN 1

 222  CALL WRITE_MESSAGE (R_NAME, 'ERROR','Error reading data file!')
      WRITE(EU,*) '    File name : ', TRIM(Name_OUT) 
      RETURN 1

      END SUBROUTINE READ_SPHER_ALB
c ***********************************************************************
      SUBROUTINE READ_KERN_COEFF(*)
      USE BRDF,    ONLY: Nwl_RLi
c     --------------------------------------------------------------------
      CHARACTER (LEN = *), PARAMETER :: R_NAME = 'READ_KERN_COEFF'
c     ====================================================================      
      CALL ST_TRACK (R_NAME, 1, 'I')
c     ... Reading file containing coefficients of BRDF kernels model
      OPEN(C_UNIT, FILE = TRIM(Ro_Li_name), STATUS='old')
        CALL SKIP_HEADER (C_UNIT)           
c       ... Number of wavelength in the file
        READ(C_UNIT,*) Nwl_RLi
        IF( Nwl_RLi == 1 ) THEN
           Nwl_veg = 2
        ELSE
           Nwl_veg = Nwl_RLi
        ENDIF
        ALLOCATE( WL_veg(Nwl_veg), Ker_cof(N_KERN,Nwl_veg) )
c     ... Reading coefficients
        DO I = 1,Nwl_RLi
           READ(C_UNIT,*,ERR=222) WL_veg(I), (Ker_cof(K,I),K=1,N_KERN)
        ENDDO
        CLOSE(C_UNIT)

c        DO K = 2,3
c           Ker_cof(K,:) = Ker_cof(K,:)/Ker_cof(1,:)
c        ENDDO
c     ... If input file contains only single wavelength then an additional 
c         wavelength will be introduced with the same coefficients
c         to perform linear interpolation of these coefficients
      IF( Nwl_RLi == 1 ) THEN
         WL_veg(2) = WL_veg(1) + 10.d0
         Ker_cof(:,2) = Ker_cof(:,1)
      ENDIF

      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN
      
 222  CALL WRITE_MESSAGE(R_NAME,'ERROR','Error reading data file!')
      WRITE(EU,*) '    File name : ', TRIM(Ro_Li_name) 
      RETURN 1
      
      END SUBROUTINE READ_KERN_COEFF
c ***********************************************************************

      SUBROUTINE READ_SCM(*)
      USE BRDF,    ONLY: SCM_name, SCM_WL, SCA_ANG, SCA_MAT, Ref_ip,
     $                   Yang_DB
      USE CLD_INP, ONLY: Ydb_ang
c     --------------------------------------------------------------------
      CHARACTER (LEN=*), PARAMETER :: R_NAME='READ_SCM'
      CHARACTER (LEN=400)  FULL_PATH
      INTEGER  J, Nwl_x, Wls, Ws1, R_start
      REAL (KND) DUM
      REAL (KND), ALLOCATABLE :: WL_x(:), DUMI(:)

c     ... Reading wavelength grid [nm] from Yang DB
c     ------------------------------------------------------------------
      FULL_PATH = Yang_DB//'droxtal/050/droxtal_wavelength.dat'
      OPEN(C_UNIT, FILE = TRIM(FULL_PATH), STATUS = 'OLD')
         CALL SKIP_HEADER( C_UNIT )
         READ(C_UNIT,*) Nwl_x  ;  ALLOCATE( WL_x(Nwl_x) )
         DO J = 1, Nwl_x 
            READ(C_UNIT,*) WL_x(J)
         ENDDO
      CLOSE(C_UNIT)
c     ------------------------------------------------------------------
      CALL LIN_SEARCH_NEW(SCM_WL, DUM, Wls, Ws1, Nwl_x, WL_x)
c      WRITE(*,*) '  Scat. matr. for wavelength: '
c      WRITE(*,*) WL_x(Wls)
      IF( .NOT.ALLOCATED(SCA_ANG) ) ALLOCATE(SCA_ANG(Ydb_ang),
     $     SCA_MAT(Ydb_ang) )
      R_start = (Wls-1)*Ydb_ang
      OPEN(C_UNIT,FILE = TRIM(SCM_name),STATUS='OLD')
         DO K = 1,R_start ; READ( C_UNIT,* ) ; ENDDO 
         DO K = 1, Ydb_ang
            READ(C_UNIT,*)  SCA_ANG(K), SCA_MAT(K)
         ENDDO
      CLOSE(C_UNIT)
c     ... Check reading results:
      IF( SCA_ANG(1)       /= 0.d0   ) GOTO 133
      IF( SCA_ANG(Ydb_ang) /= 180.d0 ) GOTO 134

      SCA_MAT(:) = SCA_MAT(:)/MAXVAL(SCA_MAT(:))      
c      WRITE(*,*) SCA_ANG(1), SCA_MAT(1)
c      WRITE(*,*) SCA_ANG(Ydb_ang), SCA_MAT(Ydb_ang)

      XS = WL_START /1.d03      !  [nm] ==> [microm] 
      XE = WL_END   /1.d03
c     ... Refractive index of ice (WL input [micron])
      CALL READ_FILE(3, Iref_name, DATA_R, *880, XS, XE,
     $     NPT = 1, Skip_line = 1)
      DATA_R(:,1) = DATA_R(:,1)*1.d3 !  [microm] ==> [nm]
      WRITE(*,*) '  DATA_R(:,1)  ', DATA_R(:,1)
      Ia = Size(DATA_R,1)
      ALLOCATE( Snow_abs(Nwl_veg), DUMI(Nwl_veg) )
c     ... Interpolation imaginary part of refractive index
      CALL LIN_INT(Ia, DATA_R(:,1), DATA_R(:,3),
     $     Nwl_veg, WL_veg, DUMI,  'C')      
      DEALLOCATE( DATA_R )
c      WRITE(*,*) '    Refr index  ', DUMI
c      WRITE(*,*) '    WLs for BRDF ', WL_veg(:)
      Snow_abs(:) = DSQRT( 4.d0*Pie*DUMI(:)/WL_veg(:)*2.d0*Ref_ip )

      RETURN      
 133  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $     '    First scattering angle is not equal to 0.d0')
      RETURN 1
 134  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $     '    Last scattering angle is not equal to 180.d0')
      RETURN 1
 880  WRITE(EU, *) ' ---> Called by '//TRIM(R_NAME)
      RETURN 1

      END SUBROUTINE READ_SCM
c ***********************************************************************
      
      SUBROUTINE RET_COEFF(*)
      USE BRDF,    ONLY: Nwl_RLi, Use_LRC, LRC, D_LRC, RLC_RET, ERR_RL,
     $                   B_RL, Err_RLC_name, B_RLC_name, Sep_IR
      Use Info,    Only: RET_INFO, WF_DB
      USE ST_VARS, ONLY: WF_FLAG, RET_CORE
      USE Tools,   Only: Find_Idx, ReInitPar
c     ------------------------------------------------------------------
      CHARACTER (LEN=*), PARAMETER :: R_NAME='RET_COEFF'
      CHARACTER (LEN=80) INP_NAME
      INTEGER  K, J, II, I_RI, I_PAR, I_SBP, N_GAUSS
      LOGICAL  ADD_NOISE
      REAL (KND) Xac, DEL, TMP, cgauss
      REAL (KND), ALLOCATABLE :: NOISE(:), ERR_COF(:,:)

      EXTERNAL  CGAUSS
c     ==================================================================
      INTERFACE
         SUBROUTINE RLC_TO_BRF(NSP, WL_INT)
         USE BRDF, ONLY: BRDF_PARAM, IVG_cof, WL_BRF, Nwl_BRF, Nwl_veg,
     $        WL_veg
         USE BRDF_SUBRS, ONLY: BRDF_ACT_DOM
         USE DATA_RET,   ONLY: MDS
         USE I_DIMS,     ONLY: Nvs
         USE LOG_PARS,   ONLY: DIR_OUT, C_UNIT
         USE SPHER_PARS, ONLY: NSZA => N_SOL_ANG, N_AZ_ANG,
     $        NLSA => N_LOS_ANG, NLO => N_LOS_OUT, ANG_OUT 
         USE ST_VARS,    ONLY: SURF_TYPE, Pie
         USE TYPE_VARS,  ONLY: KND
         INTEGER    NSP
         REAL (KND) WL_INT(:)
         OPTIONAL :: NSP, WL_INT
         END SUBROUTINE RLC_TO_BRF
      END INTERFACE

      CALL ST_TRACK (R_NAME, 1, 'I')

      IF( ITERATION==1 ) CALL RLC_TO_BRF(NSPEC, WL_INT)
      
      IF( Use_LRC.AND.ITERATION==1 ) THEN
c     ... Specific case of the usage linear regression coefficients
c         in retrieval of surface BRDF in the form of Ross-Li model
         IF( Nwl_veg /= 4 ) GOTO 223
c        ... Ross-Li coefficients will be recalculated 
c            at wavelengths less than 870 nm using empirical
c            linear regression relationship:
         DO I = 1, N_Kern ; Xac = Ker_cof(I,Nwl_veg)
            DO K = 1, Nwl_veg-1
               Ker_cof(I,K) = LRC(I,K,1)*Xac + LRC(I,K,2)
            ENDDO
         ENDDO
c        ... Add random error to LRC --------
         ALLOCATE( ERR_COF(N_Kern,Nwl_veg) ) ; ERR_COF = 0.d0 
c         ADD_NOISE = .TRUE.
         ADD_NOISE = .FALSE.
         IF( ADD_NOISE ) THEN
            N_GAUSS = 0 ; ALLOCATE(NOISE(Nwl_veg*N_Kern))
            DO I = 1, N_GAUSS
               TMP = cgauss()
            ENDDO
            DO I = 1, Nwl_veg*N_Kern
               NOISE(I) = cgauss()
            END DO
            J = 1 
            DO I = 1, N_Kern ; Xac = Ker_cof(I,Nwl_veg)
               DO K = 1, Nwl_veg-1
                  DEL = D_LRC(I,K,1)*Xac + D_LRC(I,K,2)
                  ERR_COF(I,K) = DEL*NOISE(J)
                  Ker_cof(I,K) = Ker_cof(I,K) + DEL*NOISE(J)
                  J = J + 1
               ENDDO
            ENDDO
         ENDIF  ! ADD_NOISE
c        -------------------------------------------------
         OPEN(C_UNIT, FILE='./DATA_OUT/LRC_forward.dat')
            write(C_UNIT,'(A)') '#  ----- Used for forward model  ----'
            write(C_UNIT,'(A)') '#  first line  - Iso '
            write(C_UNIT,'(A)') '#  second line - Vol '
            write(C_UNIT,'(A)') '#  third line  - Geo '
            write(C_UNIT,'(*(1x,ES12.4))') Ker_cof(1,:),
     $           ERR_COF(1,:)/(Ker_cof(1,:)-ERR_COF(1,:))*100.
            write(C_UNIT,'(*(1x,ES12.4))') Ker_cof(2,:),
     $           ERR_COF(2,:)/(Ker_cof(2,:)-ERR_COF(2,:))*100.
            write(C_UNIT,'(*(1x,ES12.4))') Ker_cof(3,:),
     $           ERR_COF(3,:)/(Ker_cof(3,:)-ERR_COF(3,:))*100.
         CLOSE(C_UNIT)
         write(*,'(A)') '  ----- Used for forward model  ----'
         write(*,'(2x,A,*(1x,ES12.4))')  'Iso ',Ker_cof(1,:) 
         write(*,'(2x,A,*(1x,ES12.4))')  'Vol ',Ker_cof(2,:) 
         write(*,'(2x,A,*(1x,ES12.4))')  'Geo ',Ker_cof(3,:) 
         write(*,*) '       --------------------------------  '
c     ... End specific case of the usage linear regression coefficients
      ENDIF  ! Use_LRC.AND.ITERATION==1 

      IF( .NOT.RET_FLAG.AND.WF_FLAG ) THEN
         I_RI = Find_Idx('albedo', RET_INFO%Name)
         IF( I_RI > 0 ) RET_INFO(I_RI)%N_SBP = N_KERN
      ENDIF

      IF( RET_FLAG.AND.INQ_WF('albedo','RIN') ) THEN
         I_RI = Find_Idx('albedo', RET_INFO%Name)
         IF( ITERATION==1 ) THEN
c            WRITE(*,*) '  I_RI = ', I_RI
c            WRITE(*,*) '  Use_LRC  ', Use_LRC
c            WRITE(*,*) '  SHAPE(Wl_veg) ', SHAPE(Wl_veg)
c            WRITE(*,*) '  Nwl_Rli  ', Nwl_RLi            
            IF( Use_LRC.OR. RET_CORE == 'ci' ) THEN
c           ... Specific case of linear regression 
c               INP_NAME='../data/surface/Ross-Li_ERR.dat'
               ALLOCATE( ERR_RL(N_KERN,Nwl_veg) )
               OPEN(C_UNIT, FILE=TRIM(Err_RLC_name),STATUS='old')
               CALL SKIP_HEADER (C_UNIT)           
c              ... Reading errors of linear regression relationship
c                  or Ross-li coefficients
               DO I = 1, Nwl_veg
                  READ(C_UNIT,*,ERR=222) DUM, (ERR_RL(K,I),K=1,N_KERN)
               ENDDO
               CLOSE(C_UNIT)
               IF( Sep_IR ) ERR_RL(:,Nwl_veg) = 1.d-04
c              ... Read bound constrains of RL coefficients
               ALLOCATE( B_RL(N_KERN,Nwl_veg,2) )
               OPEN(C_UNIT, FILE=TRIM(B_RLC_name),STATUS='old')
               CALL SKIP_HEADER (C_UNIT)
               READ(C_UNIT,*) II
               DO I = 1, Nwl_veg
                  READ(C_UNIT,*,ERR=222) DUM,
     $                 (B_RL(K,I,1), B_RL(K,I,2),K=1,N_KERN)
               ENDDO
               CLOSE(C_UNIT) 
c           ... End specific case of linear regression 
            ENDIF
            RET_INFO(I_RI)%N_SBP = N_KERN
            RET_INFO(I_RI)%N_PARS = Nwl_RLi
            Call ReInitPar('albedo')
            ALLOCATE(RET_INFO(I_RI)%WL_MIN(Nwl_RLi),
     $           RET_INFO(I_RI)%WL_MAX(Nwl_RLi))
            IF( .NOT.ALLOCATED(RLC_RET) )
     $           ALLOCATE( RLC_RET(ITERATIONS_LIMIT,N_KERN,Nwl_veg) )
            RLC_RET(ITERATION,:,:)   = Ker_cof(:,:)
            RET_INFO(I_RI)%WL_MIN(:) = WL_veg(1:Nwl_RLi) - 1.0D-5
            RET_INFO(I_RI)%WL_MAX(:) = WL_veg(1:Nwl_RLi) + 1.0D-5
            RET_INFO(I_RI)%WL_SEL = .TRUE.
            DO I_SBP = 1, RET_INFO(I_RI)%N_SBP ! Kernels
               DO I_PAR = 1, RET_INFO(I_RI)%N_PARS ! Spectral sub-parameters
                  CALL SET_PTR( RTM_PTR, RET_INFO(I_RI)%NAME,ISSP=I_PAR,
     $                 IASP=I_SBP)
                  RTM_PTR%APR(1) = Ker_cof(I_SBP,I_PAR)
                  RTM_PTR%CRN(1) = RTM_PTR%APR(1)
                  WRITE(*,'(2(2x,I3),2x,2(1x,ES12.4))') I_SBP, I_PAR,
     $                 RTM_PTR%APR(1), RTM_PTR%CRN(1)
               End Do
            End Do
         ELSE  ! ITERATION > 1
            write(*,*) '  ------ For next iteration  -----'
            DO I_SBP = 1, RET_INFO(I_RI)%N_SBP 
               DO I_PAR = 1, RET_INFO(I_RI)%N_PARS
                  CALL SET_PTR( RTM_PTR, RET_INFO(I_RI)%NAME,ISSP=I_PAR,
     $                 IASP=I_SBP)
                  Ker_cof(I_SBP,I_PAR) = RTM_PTR%CRN(1)
                  WRITE(*,'(2(2x,I3),2x,2(1x,ES12.4))') I_SBP, I_PAR,
     $                 RTM_PTR%APR(1), RTM_PTR%CRN(1)
               End Do  ! over altitude sub-parameters (I_SBP)
            End Do  ! over spectral sub-parameters (I_PAR)
            RLC_RET(ITERATION,:,:) = Ker_cof(:,:)
c            DO I = 1, N_KERN
c               write(*,'(2x,I2,*(1x,ES12.4))')  I, Ker_cof(I,:) 
c            ENDDO
            write(*,*) '    --------------------------------  '
c     -----------------------------------------------------------------
         ENDIF  ! ITERATION > 1
      ENDIF  ! RET_FLAG
      
      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN

 222  CALL WRITE_MESSAGE(R_NAME,'ERROR','Error reading data file!')
      WRITE(EU,*) '    File name : ', TRIM(Ro_Li_name) 
      RETURN 1

 223  CALL WRITE_MESSAGE(R_NAME,'ERROR','Error of linear regression!')
      WRITE(EU,*) '    Nwl_veg = ', Nwl_veg
      WRITE(EU,*) '    Nwl_veg should be equal 4 '
      RETURN 1

      END SUBROUTINE RET_COEFF

c ************************************************************************
      SUBROUTINE SET_WHITECAPS(*)
      CHARACTER (LEN=13), PARAMETER :: R_NAME='SET_WHITECAPS'

      CALL ST_TRACK (R_NAME, 1, 'I') 

        IF (LOG_LEVEL(1) >= N_ESO)  THEN
           WRITE(LUNIT,*) 
           WRITE(LUNIT,*) '   -->  "SET_WHITECAPS"'
        ENDIF
        SELECT CASE ( TRIM(Foam_WL) )
        CASE ('const') 
           ALLOCATE( WL_1(1) ) ; Nwl(1) = 1
           IF (LOG_LEVEL(1) >= N_ESO) 
     $          WRITE(LUNIT,* ) ' ..... Independent on wavelength'
        CASE('wl_dep')
           IF (LOG_LEVEL(1) >= N_ESO)  
     $          WRITE(LUNIT,*) ' Reading file: ', TRIM(RefF_name)
 14        CONTINUE
           ALLOCATE( X_READ(2,MAX_LEVEL) ) ! A

c           Open file for reading:
c           ----------------------
           OPEN(C_UNIT,FILE = TRIM(RefF_name), STATUS='old')
             CALL SKIP_HEADER (C_UNIT)           
             DO I = 1, MAX_LEVEL
                READ(C_UNIT,*,END=28,ERR=29) X_READ(1,I), X_READ(2,I)
             END DO
             MAX_LEVEL = 2*MAX_LEVEL
             CLOSE(C_UNIT) ; DEALLOCATE(X_READ) ; GOTO 14

 29          CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $            'Error reading data file !')
             WRITE(EU,*) '    File name : ', TRIM(RefF_name) 

             CALL ST_TRACK (R_NAME, 1, 'O')
             RETURN 1

 28          CONTINUE
             Ndb_1 = I - 1
           CLOSE(C_UNIT)

           ALLOCATE ( WL_1(Ndb_1), P1_1(Ndb_1) )
           WL_1(:) = X_READ(1,1:Ndb_1)*1000.0d0 ! Transform [mkm] => [nm]
           P1_1(:) = X_READ(2,1:Ndb_1)
           DEALLOCATE(X_READ)
c           WRITE(*,*) '  ***** End of reading ***** '
c           WRITE(*,*) '  Ndb_1 =  ',Ndb_1
c           WRITE(*,*) WL_1(1), WL_1(Ndb_1)
c         Are there data in the required spectral range?
          IF( WL_1(1) > WL_END .OR. WL_1(Ndb_1) < WL_START ) THEN
             CALL WRITE_MESSAGE(R_NAME, 'ERROR', 
     $            'Reading error :')
             WRITE(EU,*) '    Input file: ', TRIM(RefF_name)
             WRITE(EU,*) 
     $            '    contains data in the spectral range:'
             WRITE(EU,'(5x,2(2x,F8.3))') WL_1(1), WL_1(Ndb_1)
             WRITE(EU,*) '    the required spectral range:'
             WRITE(EU,'(5x,2(2x,F8.3))') WL_START, WL_END

             CALL ST_TRACK (R_NAME, 1, 'O')
             RETURN 1
          ENDIF
          IF( WL_START < WL_1(1)) THEN
             N_S(1) = 1 ; Lef(1) = .TRUE.
          ELSE
             CALL LIN_SEARCH (WL_START, DUM, N_S(1), Ndb_1, WL_1, ERROR)
             IF( ERROR ) THEN 
                CALL ST_TRACK (R_NAME, 1, 'O')                
                RETURN 1
             ENDIF
          ENDIF

          IF( WL_END > WL_1(Ndb_1) ) THEN
             N_E(1) = Ndb_1 ; Rig(1) = .TRUE.
          ELSE
             CALL LIN_SEARCH (WL_END, DUM, N_E(1), Ndb_1, WL_1, ERROR)
             N_E(1) = N_E(1) + 1
             IF( WL_1(N_E(1)) == WL_END ) N_E(1) = N_E(1) + 1
          ENDIF
          Nwl(1) = N_E(1) - N_S(1) + 1

          IF (LOG_LEVEL(1) >= N_ESO) THEN
             WRITE(LUNIT,* ) ' ..... Start and End WL ...... ', Nwl(1)
             WRITE(LUNIT,'(5x,2(2x,F8.3))' ) WL_1(N_S(1)), WL_1(N_E(1))
             WRITE(LUNIT,*) ' '
          ENDIF

          IF( Lef(1) ) THEN
             CALL WRITE_MESSAGE(R_NAME, 'WARNING', 
     $            'Whitecap reflection is extrapolated as zero')
             WRITE(EU,'(A,1x,F7.3,1x,A)') 
     $            '    for wavelength smaller than ', WL_1(N_S(1)),'nm'
          ENDIF
          IF( Rig(1) ) THEN
             CALL WRITE_MESSAGE(R_NAME, 'WARNING', 
     $            'Whitecap reflection is extrapolated as zero')
             WRITE(EU,'(A,1x,F7.3,1x,A)') 
     $            '    for wavelength greater than ', WL_1(N_E(1)),'nm'
          ENDIF

       END SELECT

       CALL ST_TRACK (R_NAME, 1, 'O')
      END SUBROUTINE SET_WHITECAPS 
c *********************************************************************

      SUBROUTINE SET_FRESNEL(*)
      CHARACTER (LEN=11), PARAMETER :: R_NAME='SET_FRESNEL'
c                                      Correction for real part of 
c     refractive index for salinity equal to 34.32 
      REAL (KND), PARAMETER:: DN_salin=0.006, Salin1=34.32
      REAL (KND)  SALINITY
c     ==================================================================

      CALL ST_TRACK (R_NAME, 1, 'I')  

        IF (LOG_LEVEL(1) >= N_ESO) THEN
           WRITE(LUNIT,*) 
           WRITE(LUNIT,*) '   -->  "SET_FRESNEL"'
        ENDIF
        SELECT CASE ( TRIM(Ref_type) )
        CASE ('const') 
           ALLOCATE( WL_2(1) ) ; Nwl(2) = 1
           IF (LOG_LEVEL(1) >= N_ESO) THEN
              WRITE(LUNIT,*) ' ..... Independent on wavelength'
              WRITE(LUNIT,*) ' '
           ENDIF
        CASE('wl_dep')
           IF(LOG_LEVEL(1) >= N_ESO)  
     $          WRITE(LUNIT,*) ' Reading file: ', TRIM(RefW_name)

 13        CONTINUE
           ALLOCATE( X_READ(3,MAX_LEVEL) ) ! A

c          File contains wavelength [mkm] and real and imaginary part 
c               of the refraction index 
c           Open file for reading:
c           ----------------------
           OPEN(C_UNIT,FILE = TRIM(RefW_name), STATUS='old')
             CALL SKIP_HEADER (C_UNIT)           
             DO I = 1, MAX_LEVEL
                READ(C_UNIT,*,END=26,ERR=27) 
     $               X_READ(1,I), X_READ(2,I), X_READ(3,I)
             END DO
             MAX_LEVEL = 2*MAX_LEVEL
             CLOSE(C_UNIT) ; DEALLOCATE(X_READ) ; GOTO 13
 27          CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $            'Error reading data file !')
             WRITE(EU,*) '    File name : ', TRIM(RefW_name) 

             CALL ST_TRACK (R_NAME, 1, 'O')
             RETURN 1
 26          CONTINUE
             Ndb_2 = I - 1
           CLOSE(C_UNIT)
           SALINITY = 37.d0
           ALLOCATE ( WL_2(Ndb_2), P1_2(Ndb_2), P2_2(Ndb_2) )
           WL_2(:) = X_READ(1,1:Ndb_2)*1000.0d0 ! Transform [mkm] => [nm]
           P1_2(:) = X_READ(2,1:Ndb_2)
c          ... Real part of refractive index with salinity
c              correction factor
           P1_2(:) = P1_2(:) + DN_salin/Salin1*SALINITY
c          ... Imaginary part refractive index 
           P2_2(:) = X_READ(3,1:Ndb_2)
           DEALLOCATE(X_READ)

c         Are there data in the required spectral range?
          IF( WL_2(1) > WL_END .OR. WL_2(Ndb_2) < WL_START ) THEN
             CALL WRITE_MESSAGE(R_NAME, 'ERROR', 
     $            'Reading error :')
             WRITE(EU,*) '    Input file: ', TRIM(RefW_name)
             WRITE(EU,*) 
     $            '    contains data in the spectral range:'
             WRITE(EU,'(5x,2(2x,F8.3))') WL_2(1), WL_2(Ndb_2)
             WRITE(EU,*) '    the required spectral range:'
             WRITE(EU,'(5x,2(2x,F8.3))') WL_START, WL_END

             CALL ST_TRACK (R_NAME, 1, 'O')
             RETURN 1
          ENDIF

          IF( WL_START < WL_2(1)) THEN
             N_S(2) = 1 ; Lef(2) = .TRUE.
          ELSE
             CALL LIN_SEARCH (WL_START, DUM, N_S(2), Ndb_2, WL_2, ERROR)
             IF( ERROR ) THEN
                CALL ST_TRACK (R_NAME, 1, 'O')
                RETURN 1
             ENDIF
          ENDIF

          IF( WL_END > WL_2(Ndb_2) ) THEN
             N_E(2) = Ndb_2  ;  Rig(2) = .TRUE.
          ELSE
             CALL LIN_SEARCH (WL_END,   DUM, N_E(2), Ndb_2, WL_2, ERROR)
             N_E(2) = N_E(2) + 1
             IF( WL_2(N_E(2)) == WL_END ) N_E(2) = N_E(2) + 1
          ENDIF
          Nwl(2) = N_E(2) - N_S(2) + 1
           
          IF (LOG_LEVEL(1) >= N_ESO)  THEN
             WRITE(LUNIT,* ) ' ..... Start and End WL ...... ', Nwl(2)
             WRITE(LUNIT,'(5x,2(2x,F8.3))' ) WL_2(N_S(2)), WL_2(N_E(2))
          ENDIF

          IF( Lef(2) ) THEN
             CALL WRITE_MESSAGE(R_NAME, 'WARNING', 
     $            'Fresnel reflection is extrapolated as constant')
             WRITE(EU,'(A,1x,F7.3,1x,A)') 
     $            '    for wavelength smaller than ', WL_2(N_S(2)),'nm'
          ENDIF
          IF( Rig(2) ) THEN
             CALL WRITE_MESSAGE(R_NAME, 'WARNING', 
     $            'Fresnel reflection is extrapolated as constant')
             WRITE(EU,'(A,1x,F7.3,1x,A)') 
     $            '    for wavelength greater than ', WL_2(N_E(2)),'nm'
          ENDIF

       END SELECT

       CALL ST_TRACK (R_NAME, 1, 'O')       
      END SUBROUTINE SET_FRESNEL
c *********************************************************************

      SUBROUTINE SET_WATER_LEAVING(*) 
      USE BRDF,     ONLY: RG_name
      USE WATER,    ONLY: W_speed
c     ==================================================================

      CHARACTER (LEN=17), PARAMETER :: R_NAME='SET_WATER_LEAVING'
c      CHARACTER (LEN=80)  RG_name
      INTEGER     K, M
      REAL (KND)  Ws_Tab(4), G
c              Standard wind speed values in the file "R_water_air.dat"
      DATA Ws_Tab  /0.d0, 4.d0, 10.d0, 16.d0/
c     ==================================================================

      CALL ST_TRACK (R_NAME, 1, 'I')  

      IF (LOG_LEVEL(1) >= N_ESO) THEN
         WRITE(LUNIT,*) 
         WRITE(LUNIT,*) '   -->  "SET_WATER_LEAVING"'
      ENDIF

c     Reading the function which includes the reflection 
c     coefficient on the water-air interface:
c     ---------------------------------------------------
c      WRITE(*,*) '  ***** TRIM(RG_name(1)) ', TRIM(RG_name(1))
      ALLOCATE( X_READ(5,MAX_LEVEL) ) ! A
      OPEN(C_UNIT,FILE = TRIM(RG_name(1)),STATUS = 'OLD')
        CALL SKIP_HEADER (C_UNIT)           
        DO I = 1, MAX_LEVEL
           READ(C_UNIT,*,END=32,ERR=33) ( X_READ(K,I), K=1,5 )
        END DO
 33     CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Error reading data file !')
        WRITE(EU,*) '    File name : ', TRIM(RG_name(1)) 

        CALL ST_TRACK (R_NAME, 1, 'O')
        RETURN 1
 32     CONTINUE
      CLOSE (C_UNIT)

      N_Ang_wa = I - 1
      ALLOCATE( Rho_wa_ang(N_Ang_wa), Rho_wa(N_ang_wa) )

c     Save cosine of the viewing angle in the air
c     -------------------------------------------
      Rho_wa_ang(:) = X_READ(1,1:N_ang_wa)

c     Interpolation on the given wind speed
c     -------------------------------------
      CALL LIN_SEARCH_NEW(W_speed, G, I, K, 4, Ws_Tab)
      Rho_wa(:) = 
     $     (1.D0-G)*X_READ(I+1,1:N_ang_wa) + G*X_READ(K+1,1:N_ang_wa)

c        WRITE(*,*) '  Interpolation control of water-air Fresnel coeff:'
c        DO L = 1,N_ang_wa
c           WRITE(*,'(2x,f7.3,2x,2(E14.6))') 
c     $          X_READ(1,L), X_READ(I+1,L), X_READ(K+1,L)
c           WRITE(*,'(6x,F7.3,e14.6)') Rho_wa_ang(L), Rho_wa(L)
c        ENDDO

c     Reading the function which includes the reflection coefficient
c     on the air-water interface:
c     ---------------------------------------------------------------
c      WRITE(*,*) '  ***** TRIM(RG_name(2)) ', TRIM(RG_name(2))
      OPEN(C_UNIT,FILE = TRIM(RG_name(2)),STATUS = 'OLD')
      CALL SKIP_HEADER (C_UNIT)           
      DO I = 1, MAX_LEVEL
         READ(C_UNIT,*,END=42,ERR=43) ( X_READ(K,I), K=1,5 )
      END DO
 43   CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $     'Error reading data file !')
      WRITE(EU,*) '    File name : ', TRIM(RG_name(2)) 

      CALL ST_TRACK (R_NAME, 1, 'O')
      RETURN 1
 42   CONTINUE
      CLOSE (C_UNIT)

      N_Ang_aw = I - 1
      ALLOCATE( Rho_aw_ang(N_Ang_aw), Rho_aw(N_ang_aw) )
      
c     Save cosine of the viewing angle in the air
c     -------------------------------------------
      Rho_aw_ang(:) = X_READ(1,1:N_ang_aw)

c     Interpolation on the given wind speed
c     ----------------------------------------------
      CALL LIN_SEARCH_NEW(W_speed, G, I, K, 4, Ws_Tab)
      Rho_aw(:) = 
     $     (1.d0-G)*X_READ(I+1,1:N_ang_aw) + G*X_READ(K+1,1:N_ang_aw)
c        WRITE(*,*) '  Interpolation control of air-water Fresnel coeff:'
c        DO L = 1,N_ang_aw
c           WRITE(*,'(2x,f7.3,2x,2(E14.6))') 
c     $          X_READ(1,L), X_READ(I+1,L), X_READ(K+1,L)
c           WRITE(*,'(6x,F7.3,e14.6)') Rho_aw_ang(L), Rho_aw(L)
c        ENDDO
      DEALLOCATE( X_READ )

c     Reading of the water angular scattering coefficient
c     -------------------------------------------------------
      IF(LOG_LEVEL(1) >= N_ESO) THEN
         WRITE(LUNIT,*) '     Phase function of water '
         WRITE(LUNIT,*) ' *** Reading: ', TRIM(Bet_name)
      ENDIF

 12   CONTINUE
      ALLOCATE( X_READ(2,MAX_LEVEL) ) ! A

c     Open file for reading:
c     ----------------------
      OPEN(C_UNIT,FILE = TRIM(Bet_name),STATUS = 'OLD')
        CALL SKIP_HEADER (C_UNIT)           
        DO I = 1, MAX_LEVEL
           READ(C_UNIT,*,END=22,ERR=23) X_READ(1,I), X_READ(2,I)
        END DO
        MAX_LEVEL = 2*MAX_LEVEL
        CLOSE(C_UNIT) ; DEALLOCATE(X_READ) ; GOTO 12
 23     CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $       'Error reading data file !')
        WRITE(EU,*) '    File name : ', TRIM(Bet_name) 

        CALL ST_TRACK (R_NAME, 1, 'O')
        RETURN 1
 22     CONTINUE
      CLOSE (C_UNIT)

      N_Beta = I - 1
      ALLOCATE( Beta_ang(N_beta),Beta_val(N_beta) )
      Beta_ang(:) = X_READ(1,1:N_Beta)
      Beta_val(:) = X_READ(2,1:N_Beta)
      DEALLOCATE( X_READ )
c        DO I = 1,N_beta
c           WRITE(*,'(2x,F8.3,2x,e12.4)') beta_ang(i),beta_val(i)
c        ENDDO

c     Set wavelength depending parameters
c     ===================================
      SELECT CASE ( TRIM(Leav_WL) )
      CASE ('const') 
         ALLOCATE( WL_3(1) ) ; Nwl(3) = 1
         IF (LOG_LEVEL(1) >= N_ESO) THEN
            WRITE(LUNIT,*) ' ..... Independent on wavelength'
            WRITE(LUNIT,*) ' ' 
         ENDIF
      CASE('wl_dep')
 11      CONTINUE
         ALLOCATE( X_READ(3,MAX_LEVEL) ) ! A
         IF(LOG_LEVEL(1) >= N_ESO)  
     $        WRITE(LUNIT,*) ' Reading file: ', TRIM(Alph_name)

c        Open file for reading:
c        ----------------------
         OPEN(C_UNIT,FILE = TRIM(Alph_name), STATUS='old')
           CALL SKIP_HEADER (C_UNIT)           
           DO I = 1, MAX_LEVEL
              READ(C_UNIT,*,END=25,ERR=24) 
     $             X_READ(1,I), X_READ(2,I), X_READ(3,I)
           END DO
           MAX_LEVEL = 2*MAX_LEVEL
           CLOSE(C_UNIT) ; DEALLOCATE(X_READ) ; GOTO 11
 24        CALL WRITE_MESSAGE (R_NAME, 'ERROR', 
     $          'Error reading data file !')
           WRITE(EU,*) '    File name : ', TRIM(Alph_name) 

           CALL ST_TRACK (R_NAME, 1, 'O')
           RETURN 1             
 25        CONTINUE
           Ndb_3 = I - 1
         CLOSE(C_UNIT)
         
         ALLOCATE ( WL_3(Ndb_3), P1_3(Ndb_3), P2_3(Ndb_3) )
         WL_3(:) = X_READ(1,1:Ndb_3)
         P1_3(:) = X_READ(2,1:Ndb_3)
         P2_3(:) = X_READ(3,1:Ndb_3)

c         Are there data in the required spectral range?
         IF( WL_3(1) > WL_END .OR. WL_3(Ndb_3) < WL_START ) THEN
            CALL WRITE_MESSAGE(R_NAME, 'ERROR', 
     $            'Reading error :')
            WRITE(EU,*) '    Input file: ', TRIM(Alph_name)
            WRITE(EU,*) 
     $            '    contains data in the spectral range:'
            WRITE(EU,'(5x,2(2x,F8.3))') WL_3(1), WL_3(Ndb_3)
            WRITE(EU,*) '    the required spectral range:'
            WRITE(EU,'(5x,2(2x,F8.3))') WL_START, WL_END

            CALL ST_TRACK (R_NAME, 1, 'O')
            RETURN 1
         ENDIF

c        Interpolate water abs. coefficient on the reference wavelength
         M = 1
         CALL LIN_INT(Ndb_3, WL_3, P1_3, M, [WL0], [Alf0], 'Z')

         IF( WL_START < WL_3(1)) THEN
            N_S(3) = 1 ; Lef(3) = .TRUE.
         ELSE
            CALL LIN_SEARCH (WL_START, DUM, N_S(3), Ndb_3, WL_3, ERROR)
            IF( ERROR ) RETURN 1
         ENDIF

         IF( WL_END > WL_3(Ndb_3) ) THEN
            N_E(3) = Ndb_3 ;  Rig(3) = .TRUE.
         ELSE
            CALL LIN_SEARCH (WL_END, DUM, N_E(3), Ndb_3, WL_3, ERROR)
            N_E(3) = N_E(3) + 1
            IF( WL_3(N_E(3)) == WL_END ) N_E(3) = N_E(3) + 1
         ENDIF
         Nwl(3) = N_E(3) - N_S(3) + 1

         IF(LOG_LEVEL(1) >= N_ESO)  THEN
            WRITE(LUNIT,* ) ' ..... Start and End WL ...... ', Nwl(3)
            WRITE(LUNIT,'(5x,2(2x,F8.3))' ) WL_3(N_S(3)), WL_3(N_E(3))
            WRITE(LUNIT,*) ' '
         ENDIF

         IF( Lef(3) ) THEN
            CALL WRITE_MESSAGE(R_NAME, 'WARNING', 
     $           'Water leaving reflection is extrapolated as zero')
            WRITE(EU,'(A,1x,F7.3,1x,A)') 
     $           '    for wavelength smaller than ', WL_3(N_S(3)),'nm'
         ENDIF
         IF( Rig(3) ) THEN
            CALL WRITE_MESSAGE(R_NAME, 'WARNING', 
     $           'Water leaving reflection is extrapolated as zero')
            WRITE(EU,'(A,1x,F7.3,1x,A)') 
     $           '    for wavelength greater than ', WL_3(N_E(3)),'nm'
         ENDIF

      END SELECT

      CALL ST_TRACK (R_NAME, 1, 'O')      
      END SUBROUTINE SET_WATER_LEAVING
c *********************************************************************
c
c      SUBROUTINE FRESNEL_AIR_WATER_OUT
c      INTEGER        K1, K2, I_WL
c      DOUBLE PRECISION     STe(NN+1,NN+NSOL), R_aw(NN+NSOL)
c        K1 = Nvs*(NN+1)  ;   K2 = Nvs*(NN+NSOL)
c        DUM = 2.d0*SUM(W1(:))*SUM( AG(:)*XM(:) )
cc       For which wavelength will be calculated the Fresnel reflection 
cc       coefficient at the interface air-water
c        I_WL = 5
c        DO J = I_WL,I_WL
c           STe = 0.0d0 
c           DO I = 1,N_Phi
c              STe(:,:) = STe(:,:) 
c     $             + 2.d0*R1_OUT(1:K1:Nvs,1:K2:Nvs,I,J)*W1(I)
c           ENDDO
c           DO K = 1,NN+NSOL
c              R_aw(K) = SUM( STe(1:NN,K)*AG(:)*XM(:) )
c           ENDDO               
c        ENDDO
c        WRITE(*,'(A,2x,F7.3)') '   Integration control:', DUM
c        WRITE(*,*) '    Output for the wavelength: ', WL_BRF(I_WL)
c
c        OPEN(91,file=DIR_OUT//'/Fre_wa.dat')
c        DO K = 1, NN+NSOL
c           WRITE(91,'(2(2x,e12.4))') X_INC(K), R_aw(K)
c        ENDDO
c        CLOSE(91)
c        stop
c      END SUBROUTINE FRESNEL_AIR_WATER_OUT
c *********************************************************************

      SUBROUTINE OUTPUT_BRDF
      INTEGER     Nwl_OUT, K_OUT, Ws, Ws1, KK, Naz_out
      REAL (KND)  OUT_BRF(Nvs*(NN+1),N_phi), DC, Aveg, Cof(N_KERN),
     $     OUT_BRF_ZA(Nvs*(NN+1))

c      WRITE(*,*) '  Output of BRDF in ',TRIM(Path_for_BRDF)
      OPEN(C_UNIT, file = TRIM(Path_for_BRDF), RECL=15000)
         WRITE(C_UNIT,'(a)') 
     $        '#    The surface BRDF is given for:'
         WRITE(C_UNIT,'(a,F6.2)') 
     $        '#        solar zenith angle equal to ', 
     $        DACOS( DABS(XSOL(1)) )/Pie*180.
         WRITE(C_UNIT,'(a,F11.7,a)') 
     $        '#                wavelength equal to ', WL_START,' nm'
         WRITE(C_UNIT,'(a)') '#  First line contains: '
         WRITE(C_UNIT,'(a)') '#     number of zenith angles Nz '
         WRITE(C_UNIT,'(a)') '#     number of azimuthal angleg Na '
         WRITE(C_UNIT,'(a)') '#     the solar zenith angle (SZA) [Deg] '
         WRITE(C_UNIT,'(a)') 
     $        '#  Second line contains Na azimuthal angles [Deg]'
         WRITE(C_UNIT,'(a)') 
     $        '#  First column contains for all subsequent lines:'
         WRITE(C_UNIT,'(a)') '#     Nz zenith angles [Deg]'
         WRITE(C_UNIT,'(a)') '#  BRDF is represented as Nz*Na matrix'
         WRITE(C_UNIT,'(a,2x,a2,3x,a2,4x,a3)') '#','Nz','Na','SZA'
         WRITE(C_UNIT,'(2(1x,I4),1x,f7.3)') NN+1, N_Phi,
     $        DACOS(DABS(XSOL(1)))/Pie*180.
         WRITE(C_UNIT,'(*(1x,f7.3))')  (X1(I)/Pie*180., I=1,N_Phi)
         K_out = NN+1  

         SELECT CASE( TRIM(SURF_TYPE) )
         CASE('svk')
            Nwl_OUT = 1
            IF( WL_START >= Wgr_svk ) Nwl_OUT = Nwl_OUT + 1
            CALL LIN_SEARCH_NEW(WL_START, DC, Ws, Ws1, Nwl_veg, WL_veg)
            Aveg = (1.d0 - DC)*Alb_svk(Ws) + DC*Alb_svk(Ws1)
            DUM = Aveg*N_svk(Nwl_OUT)
            DO K = 1,NN+1
               OUT_BRF((K-1)*Nvs+1,:) = DUM
     $              *SURF_BRF((K-1)*Nvs+1,(K_out-1)*Nvs+1,:,Nwl_OUT)
            ENDDO
         CASE('Ross-Li','Ross-Li-snow','snow_fasmar')
            CALL LIN_SEARCH_NEW(WL_START, DC, Ws, Ws1, Nwl_veg, WL_veg)
            Uc = 1.d0 - Dc
            Cof(:) = Uc*Ker_cof(:,Ws) + Dc*Ker_cof(:,Ws1)
            DO K = 1,NN+1 ; KK = (K-1)*Nvs+1
               OUT_BRF(KK,:) = Cof(1)
               DO J = 2,N_KERN
                  OUT_BRF(KK,:) = OUT_BRF(KK,:) 
     $                 + Cof(J)*SURF_BRF(KK,(K_out-1)*Nvs+1,:,J-1)
               ENDDO
            ENDDO  
         CASE DEFAULT
            Nwl_OUT = 2
            write(*,'(A,2x,F7.2)') '    Output for wavelength ',
     $           WL_BRF(Nwl_OUT)
c         Dimension: SURF_BRF(N_ref, N_inc, N_phi, Nwl_BRF)
            IF( Nwl_BRF == 1 ) Nwl_OUT = 1
            DO K = 1,NN+1
               OUT_BRF((K-1)*Nvs+1,:) = 
     $              SURF_BRF((K-1)*Nvs+1,(K_out-1)*Nvs+1,:,Nwl_OUT)
            ENDDO
c           Output azimuth angle
            Naz_out = 1
c            Naz_out = N_phi
            DO K = 1,NN+1
               OUT_BRF_ZA((K-1)*Nvs+1) = 
     $            SURF_BRF((K-1)*Nvs+1,(K_out-1)*Nvs+1,Naz_out,Nwl_OUT)
            ENDDO
            
         END SELECT
c        ... Write into output file
         DO K = 1,NN+1
            WRITE(C_UNIT,'(1x,f7.3,300(1x,e12.4E3))')  
     $           DACOS(X_ref(K))/Pie*180.,
     $           (OUT_BRF((K-1)*Nvs+1,I), I=1,N_Phi)
         ENDDO
         CLOSE(C_UNIT)
c ***********************************************************************
         OPEN(C_UNIT, file ='./DATA_OUT/BRF_ZA.dat')
         WRITE(C_UNIT,'(a,F7.2)') 
     $        '#        wavelength equal to ', WL_BRF(Nwl_OUT)
         WRITE(C_UNIT,'(a,F6.2)') 
     $        '#        solar zenith angle equal to ', 
     $        DACOS( DABS(XSOL(1)) )/Pie*180.
         WRITE(C_UNIT,'(a,F7.3)') 
     $        '#        azimuth angle equal to ', 
     $        X1(Naz_out)/Pie*180.
         DO K = 1,NN+1
            WRITE(C_UNIT,'(1x,f7.3,*(1x,e12.4E3))')  
     $           DACOS(X_ref(K))/Pie*180., OUT_BRF_ZA((K-1)*Nvs+1)
         ENDDO
         CLOSE(C_UNIT)
      END SUBROUTINE OUTPUT_BRDF
c *************************************************************************

      SUBROUTINE SET_WL_BRF
      INTEGER      II, N_ADD, N_TES
        N_TES = 0
        II = 1
        IF( Lef(M_Pos) ) THEN
           WL_BRF(Nwl_0 + II) = WL_T(M_Pos,1) - Delta
           II = II + 1
           N_TES = II - 1
        ENDIF
        IF( Rig(M_pos) ) THEN
           WL_BRF(Nwl_0 + II) = WL_T(M_Pos,Nwl(M_Pos)) + Delta
           II = II + 1
           N_TES = II - 1
        ENDIF

        DO I = 1,3
           IF( Nwl(I)==1 .OR. I == M_pos ) CYCLE
           WL_Ts = WL_T(I,1)  ;  WL_Te = WL_T(I,Nwl(I))
           IF( WL_Te > WL_Re ) THEN
              N_ADD = Nwl(I) - Pri(I) + 1
              WL_BRF(Nwl_0 + II:Nwl_0 + II + N_ADD - 1) = 
     $             WL_T(I,Pri(I):Nwl(I))
              II = II + N_ADD
              WL_BRF(Nwl_0 + II) =  WL_T(I,Nwl(I)) + Delta
              II = II + 1
           ELSE
              WL_BRF(Nwl_0 + II)   = WL_T(I,Nwl(I))
              WL_BRF(Nwl_0 + II+1) = WL_T(I,Nwl(I)) + Delta
              II = II + 2
           ENDIF

           IF( WL_Ts < WL_Rs ) THEN
              WL_BRF(Nwl_0+II:Nwl_0+II+Pli(I)-1) = WL_T(I,1:Pli(I))
              II = II + Pli(I)
              WL_BRF(Nwl_0 + II)   = WL_T(I,1) - Delta
              II = II + 1  ;  N_TES = II - 1
           ELSE
              WL_BRF(Nwl_0 + II)   = WL_T(I,1) - Delta
              WL_BRF(Nwl_0 + II+1) = WL_T(I,1)
              II = II + 2  ;  N_TES = II - 1
           ENDIF
        ENDDO

        IF( LOG_LEVEL(1) >= N_ESO) THEN
           WRITE(LUNIT,*)  ' '
           WRITE(LUNIT,*)  '     Check full number of wavelength: ',
     $         Nwl_0+N_tes, Nwl_0+N_OUT
        ENDIF

      END SUBROUTINE SET_WL_BRF
c **********************************************************************
      SUBROUTINE DEALLOCATE_ARRAYS

      IF( ALLOCATED(X_brf) )  DEALLOCATE( X_brf )
c      IF( ALLOCATED(WL_brf) ) DEALLOCATE( WL_brf )
c      IF( ALLOCATED(RefW_r) ) DEALLOCATE( RefW_r,RefW_i )
      IF( ALLOCATED(RefF_i) ) DEALLOCATE( RefF_i )
      IF( ALLOCATED(AlfW) )   DEALLOCATE( AlfW )
      IF( ALLOCATED(P_yell) ) DEALLOCATE( P_yell )
      IF( ALLOCATED(BRF_GG_WL) ) DEALLOCATE( BRF_GG_WL,BRF_GS_WL )
      IF( ALLOCATED(WL_veg) )  DEALLOCATE( WL_veg )
      IF( ALLOCATED(Alb_svk) ) DEALLOCATE( Alb_svk )
      IF( ALLOCATED(Al_veg) )  DEALLOCATE( Al_veg,Al_soi )
      IF( ALLOCATED(Ker_cof) ) DEALLOCATE( Ker_cof )
      IF( ALLOCATED(Rho_wa) )  DEALLOCATE( Rho_wa,Rho_wa_ang )
      IF( ALLOCATED(Rho_aw) )  DEALLOCATE( Rho_aw,Rho_aw_ang )
      IF( ALLOCATED(Beta_ang) ) DEALLOCATE( Beta_ang,Beta_val )
      IF( ALLOCATED(Der_GG_WL) ) DEALLOCATE( Der_GG_WL,Der_GS_WL )
      IF( ALLOCATED(Refi_idx) ) DEALLOCATE( Refi_idx, WL_refi_idx, 
     $     MOM_ICE )
      IF( ALLOCATED(Snow_abs) ) DEALLOCATE( Snow_abs )
      IF(ALLOCATED(ABS_COEFF_UW)) DEALLOCATE(ABS_COEFF_UW)

      RETURN
      END SUBROUTINE DEALLOCATE_ARRAYS

      END
c ***************************************************************************      
c      **********************************************************      
c         ************************************************     
      SUBROUTINE POND_BRF (N_ref, X_ref, N_Phi, X1, N_inc, X_inc,
     $     Nwl_Inp, WL_INP, SURF_BRF )

      USE BRDF,        ONLY: WL_BRF, Nwl_BRF, MP_gp, MP_bub, MP_bri,  
     $                       RefW_r, RefW_i, RefI_r, RefI_i, Pond_type,
     $                       Sig_t
      USE INTERN_DIMS, ONLY: Nvs
      USE ST_VARS,     ONLY: Pie, NN => NSTRMS
      USE TYPE_VARS,   ONLY: KND
      USE WATER,       ONLY: ABS_COEFF_UW
c     --------------------------------------------------------------------
      
      INTEGER,  INTENT(IN) :: N_ref, N_Phi, N_inc, Nwl_Inp
      REAL (KND)  X_ref(N_REF), X1(N_phi), WL_Inp(Nwl_Inp), X_inc(N_inc)
      REAL (KND)  SURF_BRF(Nvs*N_ref, Nvs*N_inc, N_phi, Nwl_Inp)
c     ... Local parameters      
c     -------------------------------------------------------------------
      INTEGER, PARAMETER :: Nga = 25, Nan = 2*Nga
      INTEGER  I, II, K, I1, K1
      REAL (KND), PARAMETER :: Step = 1.d0
      REAL (KND)  alpha, tp, tau_ice, A0, Hel, gam, Cca, Ewz,
     $     Ref2, F_in, Ref_ind
      REAL (KND)  Ab(Nwl_inp), Ref_inp(2), XMg(Nga), AGg(Nga),
     $     HH(Nan), FTv(N_inc,1,1), RTi(N_inc), RTr(N_ref),
     $     Pr_exp(N_ref), Pi_exp(N_inc)
      REAL (KND), ALLOCATABLE:: Ang(:), R_in(:)
      REAL (KND), TARGET:: He1(4)
      REAL (KND), POINTER :: P_abs(:), P_sca(:), Pw_refr(:), Pi_refi(:)
c     -----------------------------------------------------------------------
cc     ... Test arrays
c      REAL (KND) Muw, Rf1, F_out, RFd, Rfg(Nga), Xmg_w(Nga), HHg(Nga),
c     $     A_bs(Nwl_inp), A_ws(Nwl_inp)
c     -----------------------------------------------------------------------
c     ... Scattering transport coefficient of bubbles plus brine
      SELECT CASE(Pond_type)
      CASE('imp')
         Sig_t = 1.5d0*MP_bub(1)/MP_bub(2)*(1.d0 - MP_bub(3))
     $        + 1.5d0*MP_bri(1)/MP_bri(2)*(1.d0 - MP_bri(3)) ! [m-1]
         WRITE(*,*) '   ----< Transport coefficients >--------'
         WRITE(*,*) MP_bub(1), MP_bub(2), (1.d0 - MP_bub(3))
         WRITE(*,'(*(2x,e12.4))')
     $        1.5d0*MP_bub(1)/MP_bub(2)*(1.d0 - MP_bub(3)),
     $        1.5d0*MP_bri(1)/MP_bri(2)*(1.d0 - MP_bri(3))
      CASE('tsc')
         Sig_t = MP_bub(1)
      END SELECT

      WRITE(*,*) '   Transport opt. thickness of under-pond ice'
      WRITE(*,*) '   ===> ', Sig_t 
      
      IF( Nwl_inp == 1 .AND. Nwl_BRF > 1) THEN
         CALL LIN_SEARCH_NEW( WL_inp(1), Gam, I, K, Nwl_BRF, WL_BRF )
         He1(1) = (1.d0-Gam)*ABS_COEFF_UW(1,I) + Gam*ABS_COEFF_UW(1,K)
         P_abs => He1(1:1)
         He1(2) = (1.d0-Gam)*ABS_COEFF_UW(2,I) + Gam*ABS_COEFF_UW(2,K)
         P_sca => He1(2:2)
         He1(3) = (1.d0-Gam)*RefW_r(I) + Gam*RefW_r(K)
         Pw_refr => He1(3:3)
         He1(4) = (1.d0-Gam)*RefI_i(I) + Gam*RefI_i(K)
         Pi_refi => He1(4:4)
      ELSE
         P_abs => ABS_COEFF_UW(1,:) ; P_sca => ABS_COEFF_UW(2,:)
         Pw_refr => RefW_r(:)       ; Pi_refi => RefI_i(:)
      ENDIF

      DO II = 1, Nwl_inp
         alpha = 4.d0*Pie*Pi_refi(II)/WL_BRF(II)*1.e9 ! ice absorption [m-1]
         tp = 8.d0/3.d0* alpha/Sig_t
         tau_ice = (Sig_t + alpha)* MP_gp(1)
         gam = 3.d0/4.d0*Sig_t/(Sig_t + alpha)*SQRT(tp*(tp + 2.d0))
         A0 = 1.d0 + tp - SQRT(tp*(tp + 2.d0))
         Hel = DEXP(-2.d0*gam*tau_ice)
c        ... Bottom albedo of melt pond
         Ab(II) = A0*(1.d0 - Hel)/(1.d0 - A0*A0*Hel)
c         WRITE(*,'(2x,F8.3,*(2x,Es12.4))') WL_inp(II), Ab(II), tau_ice
      ENDDO

      ALLOCATE( Ang(Nan), R_in(Nan) ) 
      CALL GAULEG( 0.d0, 1.d0, Xmg, AGg, Nga )      
      
      DO II = 1, Nwl_inp
         Ref_inp(1) = Pw_refr(II) ;  Ref_ind = Ref_inp(1)
         Ewz = ( P_abs(II) + P_sca(II) )*MP_gp(2)      
c         Ewz = ( 4.d0*Pie*RefW_i(II)/WL_BRF(II)*1.d9 +
c     $        P_sca(II) )*MP_gp(2)      
         Ref2 = Pw_refr(II)**2         
c        ... Cosine of critical angle
         Cca = DSQRT( Ref_inp(1)**2 - 1.d0 )/Ref_inp(1)      
c         WRITE(*,'(A,2x,F8.3)') '  Critical angle ', DACOS(Cca)/Pie*180.
         Ang(1:Nga)       = Xmg(:)*Cca
         Ang(Nga+1:2*Nga) = Xmg(:)*(1.d0 - Cca) + Cca
c        ...  Internal reflectance of the water surface
         CALL Fre_REF (Nan, R_in, Ang, Ref_inp, 'ww')
         HH(:) = R_in(:)*DEXP(-2.d0*Ewz/Ang(:))*Ang(:)
c        ... Auxiliary function f_in
         F_in = 2.d0*( Cca*SUM( HH(1:Nga)*AGg(:) ) +
     $        (1.d0 - Cca)*SUM( HH(Nga+1:2*Nga)*AGg(:) ) )
         CALL Fre_REF (N_ref, RTr, X_ref, Ref_inp, 'aa')
         CALL Fre_REF (N_inc, RTi, X_inc, Ref_inp, 'aa')
         Pr_exp(:) = DSQRT( X_ref(:)**2 + Ref_ind**2 - 1.d0 )/Ref_ind
         Pr_exp(:) = DEXP(-Ewz/Pr_exp(:) )
         Pi_exp(:) = DSQRT( X_inc(:)**2 + Ref_ind**2 - 1.d0 )/Ref_ind
         Pi_exp(:) = DEXP(-Ewz/Pi_exp(:) )
         Hel = Ab(II)/Ref2/( 1.d0 - Ab(II)*F_in )
c        ... Fresnel reflection from air-water interface is not included
c            into SURF_BRF
         DO I = 1, N_REF    ;  I1 = (I-1)*Nvs+1
            DO K = 1, N_INC ;  K1 = (K-1)*Nvs+1
               SURF_BRF(I1,K1,:,II) = (1.d0 - RTr(I))*(1.d0 - RTi(K))
     $              *Hel*Pr_exp(I)*Pi_exp(K)
            ENDDO  ! over incidence angles (K)
         ENDDO  ! over reflectance angles (I)
cc -------- Check expressions for black and white sky albedo ---------
c         CALL Fre_REF(Nga, Rfg, Xmg, Ref_inp, 'aa')
c         Xmg_w(:) = DSQRT( Xmg(:)**2 + Ref_ind**2 - 1.d0 )/Ref_ind
c         HHg(:) = (1.d0 - Rfg(:))*DEXP(-Ewz/Xmg_w(:))*Xmg(:)
c         F_out = 2.d0*SUM( HHg(1:Nga)*AGg(:) )
c         CALL Fre_REF (1, Rf1, X_inc(NN+1), Ref_inp, 'aa')
c         Muw = DSQRT( X_inc(NN+1)**2 + Ref_ind**2 - 1.d0 )/Ref_ind
cc        ... Black-sky albedo
c         A_bs(II) = Rf1 + (1.d0 - Rf1)*Hel*F_out*DEXP(-Ewz/Muw)
cc        ... White-sky albedo
c         Rfd = 2.d0*SUM( Rfg(:)*Xmg(:)*AGg(:) )
c         A_ws(II) = Rfd + Hel*F_out**2
cc -------- End check expressions for black and white sky albedo ------
      ENDDO  ! over wavelengths (II)

c      WRITE(*,*) '  Sol. angle ', DACOS( X_inc(NN+1) )/Pie*180.
c      OPEN( 47, FILE = './DATA_OUT/Alb_bs-ws.dat' )
c      WRITE(47,'(A)') '#   Black and white sky albedo  '
c      DO I = 1, Nwl_inp
c         WRITE(47,'(2x,f8.3,*(2x,e12.4))')  WL_inp(I), A_bs(I), A_ws(I) 
c      ENDDO
c      CLOSE( 47 )
c      WRITE(*,*) '     N_inc = ', N_inc
c      DO I = 1, N_REF
c         WRITE(*,*)  I, SURF_BRF(I,NN+1,1,1)
c      ENDDO
c      PAUSE
c      STOP
      END SUBROUTINE POND_BRF
      
c ***********************************************************************
c     Li Sparse- Ross model 
c Physical description can be found in the papers:
c 1.    Pavel Litvinov, Otto Hasekamp, Brian Cairns. 
c  Models for surface reflection of radiance and polarized radiance: 
c Comparison with airborne multi-angle photopolarimetric measurements and implications 
c for modeling top-of-atmosphere measurements. Remote Sensing of Environment (2011), 115, 781–792

c 2.	Pavel Litvinov, Otto Hasekamp, Brian Cairns, Michael Mishchenko. 
c Semi-empirical BRDF and BPDF models applied to the problem of aerosol retrievals over land: 
c testing an airborne data and implications for modeling of top-of-atmosphere measurements.
c In book: Polarimetric Detection, Characterization, and Remote Sensing. Springer, 2011.

!     x_vect_i(3): geometric kernel
!     x_vect_i(2): volumatric kernel
!     x_vect_i(1): isotropic kernel
!     n_par_i=3
!     mu0,muv: cosinus of solar and viewing zenith angles
!     phi0,Phir:   azimuth angles of solar and viewing directions (in degrees)
!     LiD_R: calculated BRDF

! 	  Examples.
!     Banizoumbou (440 nm, jan.-Febr. 2008):
!     x_vect_i(1)=0.06
!     x_vect_i(2)=0.3
!     x_vect_i(3)=0.08	  

!     Mongu (440 nm, August, 2008):
!     x_vect_i(1)=0.025
!     x_vect_i(2)=0.43
!     x_vect_i(3)=0.12
c      Subroutine LiSp_Ross(n_par_i, mu0, phi0, mu, Phir, x_vect_i, 
c     $     LiD_R)
c      Implicit none
c
c      Real(8), parameter :: dl_par1=2.d0, alpha0=1.5d0
c      Integer, intent(in):: n_par_i
c      Real(8), intent(in):: phi0, Phir, x_vect_i(1:n_par_i)
c      Real(8),intent(out):: LiD_R
c      Real(8) :: cos_scat,sin_scat,tet_sc,Ross_K,LiD_K,mu0,mu
c      Integer :: i
c      Real(8) :: pr_t1,tan_i,tan_v,phi,D,sec_i_v,cos_t,sin_t,t,O,
c     $     muv_lim,mu0_lim
c      Real(8) :: ni_x,ni_y,ni_z, nv_x,nv_y,nv_z, phi_inc, phi_v, 
c     $     sin_v,sin_inc,del_phi1
c      Real(8) :: Hot_Sp,alpha
c      Real(8) :: Lid_R_limit
c!------------------------------------------------------
c      Real(8), parameter :: dpi=3.141592653589793 
c      Real(8), parameter :: dpi2=dpi*dpi
c      Real(8), parameter :: d180_pi=180.d0/dpi
c      Real(8), parameter :: dpi_180=dpi/180.d0
c!------------------------------------------------------
c
c      tan_i=dsqrt(1.d0-mu0*mu0)/mu0
c      tan_v=dsqrt(1.d0-mu*mu)/mu
c
c      phi_v=Phir*dpi_180
c      phi_inc=phi0*dpi_180
c
c      sin_inc=dsqrt(1.d0-mu0*mu0)
c      ni_x=sin_inc*dcos(phi_inc)
c      ni_y=sin_inc*dsin(phi_inc)
c      ni_z=mu0 !(cos of solar zenith angle)
c
c      sin_v=dsqrt(1.d0-mu*mu)
c      nv_x=sin_v*dcos(phi_v)
c      nv_y=sin_v*dsin(phi_v)
c      nv_z=mu !(cos of viewing zenith angle)
c
c      del_phi1=phi_v-phi_inc
c      cos_scat=-(ni_x*nv_x+ni_y*nv_y+ni_z*nv_z)
c
c      if (cos_scat .lt. -1.d0) then
c         cos_scat=-1.d0
c         sin_scat=0.d0
c         tet_sc=dpi
c      else if (cos_scat .gt. 1.d0) then
c         cos_scat=1.d0
c         sin_scat=0.d0
c         tet_sc=0.d0
c      else
c         sin_scat=dsqrt(1.d0-cos_scat*cos_scat)
c         tet_sc=dacos(cos_scat)
c      end if
c
c      alpha=(dpi-tet_sc)*d180_pi
c!PL   hot-spot effect is introduced
c      Hot_Sp=(1.d0+1.d0/(1.d0+alpha/alpha0))
c
c      Ross_K = Hot_Sp*((dpi*0.5d0-tet_sc)*cos_scat+sin_scat)/(mu+mu0) 
c     $     - dpi*0.25d0  
c      sec_i_v=(1.d0/mu+1.d0/mu0)
c      D=dsqrt(tan_i*tan_i+tan_v*tan_v-2.d0*tan_i*tan_v*dcos(del_phi1))
c  
c      cos_t=dsqrt(D*D+(tan_i*tan_v*dsin(del_phi1))**2)/sec_i_v*dl_par1
c      If (dabs(cos_t) .gt. 1.d0) cos_t=1.d0
c
c      sin_t=dsqrt(1.d0-cos_t*cos_t)
c      t=dacos(cos_t)
c      O=1.d0/dpi*(t-sin_t*cos_t)*sec_i_v
c 
c      LiD_K = O - sec_i_v + (1.d0-cos_scat)/mu/mu0*0.5d0
c
c      Lid_R_limit=(1.d0-x_vect_i(1))*0.5d0
c!PL   Surface albedo should be less than 1
c      If (LiD_K*x_vect_i(3)*x_vect_i(1)*mu .gt. Lid_R_limit ) THEN
c         WRITE(*,*) '   Replace because > Lid_R_limit '
c         LiD_K = Lid_R_limit/x_vect_i(3)/x_vect_i(1)/mu
c      ENDIF
c
c      LiD_R = (LiD_K*x_vect_i(3) + Ross_K*x_vect_i(2) + 1.d0)
c     $     *x_vect_i(1)
c
c!PL   Surface albedo should be greater  than 0
c      if (LiD_R .lt. 0.d0) THEN
c         WRITE(*,*) '   Replace because < 0 '
c         LiD_R=0.d0
c      ENDIF
c
c      End Subroutine LiSp_Ross
cC********************************************************************C
cc       This subroutine returns 
cc       the modified Bessel function I1(x) for any real x. 
c      SUBROUTINE BESSI_1( N,X,ANS ) 
c      INTEGER            N
c      DOUBLE PRECISION   X(N), ANS(N)
c      INTEGER            I
c      DOUBLE PRECISION   AX, Y
c      DO I = 1,N
c         AX = DABS(X(I))
c         IF( AX < 3.75d0 ) THEN
c            Y = ( X(I)/3.75d0 )**2
c            ANS(I) = AX*(0.5d0 
c     $           + Y*(0.87890594d0 + Y*(0.51498869d0 
c     $           + Y*(0.15084934d0 + Y*(0.2658733d-01
c     $           + Y*(0.301532d-02 + Y*0.32411d-03) )))))
c         ELSE  
c            Y = 3.75d0/AX
c            ANS(I) = 0.2282967d-01 
c     $           + Y*( -0.2895312d-01 
c     $           + Y*(0.1787654d-01 - Y*0.420059d-02) )
c            ANS(I) = 0.39894228 
c     $           + Y*( -0.3988024d-01 
c     $           + Y*( -0.362018d-02 + Y*( 0.163801d-02 
c     $           + Y*(-0.1031555d-01 + Y*ANS(I)) )))
cc            ANS(I) = ANS(I)*dexp(AX)/dsqrt(AX)
c         ENDIF
c         IF( X(I) < 0.0d0 ) ANS(I) = -ANS(I)
c      ENDDO
c      RETURN 
c      END
cc ************************************************************************
cc       This subroutine returns 
cc       the modified Bessel function I0(x) for any real x. 
c      SUBROUTINE BESSI_0( N,X,ANS ) 
c      INTEGER            N
c      DOUBLE PRECISION   X(N), ANS(N)
c      INTEGER            I
c      DOUBLE PRECISION   AX, Y
c      DO I = 1,N
c         AX = DABS(X(I))
c         IF( AX < 3.75d0 ) THEN
c            y = (X(I)/3.75)**2
c            ANS(I) = 1.0 + Y*(3.5156229 + Y*(3.0899424 
c     $           + Y*(1.2067492 + Y*(0.2659732 
c     $           + Y*(0.360768d-01 + Y*0.45813d-02)))))
c         ELSE  
c            Y = 3.75d0/AX
cc            ANS(I) = (DEXP(AX)/DSQRT(AX))*
c            ANS(I) = 
c     $           (0.39894228 + Y*(0.1328592d-01 
c     $            + Y*(0.225319d-02 + Y*(-0.157565d-02 + Y*(0.916281d-02 
c     $             + Y*(-0.2057706d-01 + Y*(0.2635537d-01  
c     $              + Y*(-0.1647633d-01 + Y*0.392377d-02) ))))))) 
c         ENDIF
c      ENDDO
c
c      RETURN
c      END
