!*********************************************************************
!
!	SCIATRAN - Version 4.1 - Last modification: 19 Feb 2019
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!*********************************************************************
SUBROUTINE GENERATE_SA (XVec, RegM)
  ! Called by "retrieval.f90"

  USE DATA_RET,  ONLY: TIH_FLAG, RCOR, PRESET_APR_NAME, MDS, &
                       TihRegMode
  USE GRIDS,     ONLY: NLAYERS, ZZZ
  USE INFO,      ONLY: RET_INFO, STATE
  USE LOG_PARS,  ONLY: LUNIT, LOG_LEVEL, N_ESO
  USE PROFILES,  ONLY: AIR_DENSITY
  USE RETR_ITER, ONLY: ITERATION
  USE ST_VARS,   ONLY: TP_HEIGHT
  USE TOOLS,      ONLY: UPPER_LOWER_CASE, MatrInvers
  USE TYPES,    ONLY: KND, XVecType, RegMatrs
  !------------------------------------------------------------------
  Type (RegMatrs) RegM
  Type (XVecType), Allocatable :: XVec(:)

  ! Local parameters
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'GENERATE_SA'
  CHARACTER (LEN = :), ALLOCATABLE :: STRING
  LOGICAL  SMART_APR, SMART_TIH, TS_FLG
  INTEGER, PARAMETER :: NP_MAX = 10
  INTEGER  N_PAR, N_X, I, J, K, II, LL, I_RI, NP, I_S, I_E, NL_RET,I_SBP, KK,&
       NN, NWL, n_a, I_RLI
  INTEGER, ALLOCATABLE :: NUM_TS(:)
  REAL (KND) Min_Val, S1, R_COR, Z_MAX
  REAL (KND) ALT(NP_MAX), VAL(NP_MAX), S_A(Size(Xvec),Size(Xvec))
  REAL (KND), POINTER :: Z_RET(:), WL(:), PTR(:)
  REAL (KND), ALLOCATABLE :: TMP_APR(:), APR_N(:), TMP_TIH(:), TIH_N(:), &
       MaxApr(:), MaxTih(:)
  !==================================================================
  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE GENERATE_SA
