!***************************************************************************
!
!	SCIATRAN - Version 3.8 - Last modification: 13 Sept 2017
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
Subroutine Global_Settings 
  Use Aerosols, Only: AerExC_DB
  Use St_Input, Only: S_N_D, SND_WL, SND_NAME, HOME_DIR
  Use St_Vars,  Only: CI_FLG
  Use Tools,    Only: ErrMsg, Set_Path, Cut_Str, Split_String, Read_Input,&
                      Upper_Lower_Case
  USE Types,    Only: KND, DYN_CHAR
  ! Local  parameters
  Character (Len=*), Parameter :: R_NAME='Global_Settings'
  Character (Len=:), Allocatable :: STR_INP
  TYPE (DYN_CHAR), ALLOCATABLE :: Msg(:), READ_ARR(:), STR_ARR(:)
  !==================================================================
  if(.NOT.CI_FLG)  Return
  
  CALL READ_INPUT_FILES (.TRUE., *100)
100 Continue

  STR_INP = 'Home directory'
  CALL Read_Input (STR_INP, READ_ARR, *880, OutputType='delayed')
  HOME_DIR = CUT_STR(READ_ARR(1)%S)
  STR_INP = 'Use reference extinction coefficient profile'
  CALL Read_Input (STR_INP, READ_ARR, *880, OutputType='delayed')
  CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
  S_N_D = CUT_STR(STR_ARR(1)%S)
  CALL UPPER_LOWER_CASE (S_N_D,'L2U')
  SELECT CASE (S_N_D)
  CASE ('SCIA_3D')
     READ(STR_ARR(2)%S,*,ERR=101) SND_WL
     SND_NAME = SET_PATH( STR_ARR(3)%S )
!     Call Scia_Aer_ExC (.TRUE., *880)
  CASE ('FILE')
     READ(STR_ARR(2)%S,*,ERR=101) SND_WL
     SND_NAME = SET_PATH( STR_ARR(3)%S )
  END SELECT

  Return
  
880 continue
  call ErrMsg(R_Name, 't', DelayedOutput=.TRUE.)
  Return
  
101 Continue
  Allocate(Msg(2))
  Msg(1)%S = 'Reading error'
  Msg(2)%S = '    Parameter to read: '//STR_INP
  call ErrMsg(R_Name, 'e', Msg, .TRUE.)
  Return
!***************************************************************************
End Subroutine Global_Settings
!***************************************************************************
