!***************************************************************************
!
!	SCIATRAN - Version 4.7 - Last modification: 16 Oct 2023
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE GT_FILEREAD (DO_NEAR_NADIR, NEAR_NADIR_DEFINITION, &
     HITRAN_DIR, N_COL_WL, WL_DATA_FILE, WL_GRID_FLAG, *)
! Called by "gt_iface.f" 

  USE ABSORBERS,   ONLY: N_ST_MOL, N_ESFT_MOL, AMF_IDX, N_XSEC_MOL, &
                         LINE_ABS_MODE, MIX_ABS_START, N_MIX_MOL
  USE AEROSOLS,    ONLY: ECSTRA_FLAG, ECSTRA_DM, AER_SHIFT, LAY_A, OUT_A_SCM, &
                         WEL_A, NSCA_A, GE_A, PATH_TO_SCM, Rtau_aer, &
                         AER_SCALING, AOT_out_LOG, L_scal, Scal_aer, Rwl_aer, &
                         EXA_FLG, EXA_NAME, AER_PARAM, NOWL_AER, OWL_AER, &
                         COMPAT_MODE, AER_ADD_LEV, AER_FACT, ZS1, ZS2, V_PAP, &
                         Dwr_mi, N_Dwr, Plus_mi, N_AOT, AOT_MAL, Bi_PSD, &
                         MODIS_AP, MODIS_LO, Use_der, SHARP_EDGES, Use_AP, &
                         AerExC_DB, Aer_ext_lin, RT_AG
  USE AER_MIE,     ONLY: M_AC, Rm_log
  USE ALB_PARS,    ONLY: ALBEDO_CONST, DO_SPECTRAL_ALBEDO, SCAL_ALB, Nc_ALB, &
                         ALB_WEI, INF_ALB
  USE ALT_INPUT,   ONLY: ALIN_ACT, ALIN_NWL, ALIN_WL, ALIN_Z, ALIN_NZ, ALIN_ABS, &
                         ALIN_RAY, ALIN_RAY_EC, ALIN_AER_A, ALIN_AER_S, &
                         ALIN_AER_EC, NC_AER, ALIN_CLD_A, ALIN_CLD_S, &
                         ALIN_CLD_EC, NC_CLD
  USE ALT_INPUT,   ONLY: ALIN_FLAG, ALIN_ACT, SOUT_FLAG, SOUT_TAU, DIR_SOUT, &
                         IPRT_ALIN, IPRT
  USE ANISOTROPY,  ONLY: DO_DEPOL_WAVELENGTH, DEPOL_INPUT, DEPOL_FILENAME
  USE BRDF,        ONLY: Ref_type, Nder, Sep_IR
  USE CLD_INP,     ONLY: Use_Dim
  USE CLOUDS,      ONLY: DO_CLOUD, Red_WL_Ydb
  USE CLOUDS_SS,   ONLY: DO_SSRCA, DO_RAY_DEP, RAY_DEP, DO_RAY_TAU, RAY_TAU_INP
  USE CIA_VARS,    ONLY: CIA_INIT, CIA_INFO, CIA_DIR, CIA_VMR_MODE, &
                         CIA_VMR_VAL, N_CIA_G, CIA_GAS, N2_Air_Corr
  USE CS_TABLE
  USE DATA_RET,    ONLY: RET_FLAG
  USE DELTA_M,     ONLY: AER_TRUNC_IDX, D_MF_AER, AER_DM_FLG
  USE ESFT,        ONLY: DO_ESFT, DO_ESFT_ANTI_CORRELATION, ESFT_DB_PATH
  USE FLU_LAND,    ONLY: FLU_L, FLU_NAME, FLU_SCAL, DGF_PAR, USE_DGF 
  USE GRIDS,       ONLY: NL_FINE, MAX_LINE, Nz_LEV, Z_LEV, Zl_step
  USE GT_POLYN,    ONLY: NLEGEN
  USE HYDROSOLS,   ONLY: N_HPC, OUT_H_SCM
  USE INFO,        ONLY: TG_INFO, AER_INFO, PAR_INFO, CLD_INFO
  USE INTERN_DIMS, ONLY: Nvs, Nm_vs, NNv, NL_pla, NN_pla, LS_pla, NL_FINE_pla, &
                         Nf_pla, Ng1_brf, Ng2_brf, Ns_brf, Nh_brf
  USE IRRAD,       ONLY: IRRAD_FLAG, FILENAME_SOLSPEC, EXTR_FLUX, WL_IRRAD_DIM,&
                         Fbe, SCALE_SS, NO_SUN
  USE LBL,         ONLY: DO_LBL, LBL_WING_CUTOFF, StEm_MaxWn, OptLineSum,&
                         LineSumAcc
  USE NODES,       ONLY: FILE_NODES, READ_NODES, NVA, NAz, ModeNodes, USE_AIN, &
                         N_Va, N_Az, USE_HIN, NVA_HIN, NAz_HIN
  USE OutInf,      ONLY: LUNIT, C_UNIT, EU, L_S, L_E, Work_Dir,N_NSO, N_SSO, &
                         L_ER, OUT_FOR, L_U, LOG_LEVEL, LUF, SurUNIT,  &
                         IS1, IS2, TO_REFL_FUNC, OUT_REPR, &
                         Mult_WL_Form, ONE_WL, FORMAT_FLAG, DIR_OUT, &
                         TRC_FLG
  USE PHOTOCHEM,   ONLY: DO_PHOTOCHEM, N_PC_INP, DO_TROP, CONST_PROF, &
                         ALT_GRID_NAME_PC, PROFILE_NAME_PC, GAS_IDX_PC, &
                         CONST_SZA, Z_TP
  USE PROFILES,    ONLY: DO_SCA_PRE, DO_SCA_O3, DO_SCA_H2O, SCA_PRE,  &
                         SCA_H2O, O3_TOTAL_COLUMN, DO_SCA_NO2, SCA_NO2
  USE REFRACT_VARS,ONLY: Refr_HiRes
  USE RAMAN,       ONLY: DEL_RAM, NR_LINES, RRS_ADJ, RRS_DO, DOM_API, ESR_Split, &
                         RRS_NAM_ET, RRS_NAM_PT
  USE RTM_OUTPUT,  ONLY: WF_INTEGR, Wup, MAX_AER_WF, MES_OUT_LS, MES_OUT_SOL, &
                         ALB_OUT, TRANS_OUT, OWF_FLG_ARR
  Use SRF_Mod,     Only: SRF_Init, SRF
  USE ST_INPUT,    ONLY: CIRA_DIR, CIRA_ZMIN, Inp_Pars, PT_FILENAME, PROF_FILES,&
                         PROF_UNITS, PROF_NCV, PROF_NCZ, PROF_LABELS, &
                         DO_PROFILES_AKIMA, DO_PT_MPI_PROFILE, AER_PAR_TYPE, &
                         BAND_NUM, BRO_MIPAS_FILE, BAND_START, BAND_STEP, N_REPL,&
                         MAX_LAY, NET_NAME, NC_PTZ, NC_P, NC_T, APH_TYPE, &
                         PATH_AER_DB, ALBEDO_FILENAME, TPH_DB_PATH, CLIM_LABEL, &
                         YEAR, CLIM_PATH, ALBEDO_DB_PATH, &
                         WL_UNITS, DAY_OF_YEAR, BRO_MIPAS_FLAG,&
                         HOME_DIR, S_N_D, SND_WL, SND_NAME, PT_CDF, PROF_CDF, WL_CDF, &
                         SOL_CDF, AER_CDF, ALB_CDF, AER_ZMIN, AER_ZMAX
  USE ST_VARS,     ONLY: RAY_SCATT_IDX, WF_FLAG, RRS_TEST, APPR_RRS, &
                         DO_AEROSOL, RING_FLAG, BRDF_FLAG, SPECULAR, &
                         GROUND_HEIGHT, FLUX_MIN_ZZZ, ANG_INT, TSM, &
                         FLUX_MAX_ZZZ, SCATT_MODE, SS_MS_BOUNDARY, DIFB, &
                         CONVOL_FLAG, Nwl_RR, CONVOL_ALL, &
                         LA_WINS, HR_SEG_WL, VHL, Nc_der, NSEGS, Ellip, &
                         HR_NSEG, STEP_INP, DO_PC, LATITUDE, WL_RR,&
                         LONGITUDE, ADAPTIVE_GRID, CRIT_AG, RTM_MODE, &
                         RTM_TYPE, RTM_CORE, Enhance_acc, Vec_Sca, IDM, LDM, &
                         M_PLA, LL_factor, Refr_index, King_factor, PVC, &
                         CS_ANALYTIC, PSAB, RAD_FIELD, Interp_RF, RIN_OUT,&
                         VST, Use_Sym, C_SYS, &
                         OWF_FLAG, Gauss_Field, INT_OUT, Finc, Ainc, Kvs, &
                         VS_HC, NS_wf, D_sol, F_LGI_SCR, F_LGI_SCA, &
                         F_LGI_EXT, CIRA_FLG, OWF_Chl, OWF_Ks, OWF_Kl, &
                         OWF_Ray, OWF_Use, PreCalcAngs, LSA_MODE, CONV_Z, &
                         PREC_FLAG, SURF_TYPE, AKIMA_FLG, AG_aer, Mh_AG, &
                         CRIT_AG_Mh, Ray_to_WF, SSC_RF, AA_BRF, ACCUR, &
                         DO_AZIMUTH, DO_RAMAN, DO_PLANCK, NSTRMS, ND_ANG,&
                         USE_PSM, DISCR_M, Sec_Order, Short_los, Sel_los, &
                         Cr_Short_los, Cr_Sel_los, MSF_INT, PreCalcRtMatr, &
                         PreCalcGeom
  USE SPHER_PARS,  ONLY: N_ITER, NN, Z_F, N_FINE_TH, N_FINE_ST, PE_Mode, &
                         NBE_INP, NAF_INP, DEL_INP, Z_SOL_F, &
                         Check_STA, Crit_STA, Const_ang, SolGrid
  USE THERMAL_VAR, ONLY: BRIGHT_TEMP, OUT_PLANCK, INTEGR_PLANCK, SET_SOL_USR, &
                         BTEM, VMAX, EPSIL, WNUMLO, WNUMHI, SOL_FLUX_USR, &
                         Path_for_PLANCK, Pla_acc, Emi_FILE, Emi_NAME, &
                         Sur_Emis, Emi_akima
  USE TOOLS,       ONLY: FIND_MATCHES, FIND_IDX, UPPER_LOWER_CASE, CHK_STAT, &
                         CUT_STR, INQ_WF, SET_PATH, SPLIT_STRING, Read_Input, &
                         Join, Read_OptCDF, WriteOut, NotFound
  USE TYPES,       ONLY: KND, DYN_CHAR, ArrChar, TE_TYPE
  USE SLAB_2L,     ONLY: TES_2L_SLAB
  USE X_SECTS,     ONLY: ABS_COEFF_NTEMP, ABS_COEFF_TEMP, N_TEMP,&
                         X_SECTION_FILE, X_SECTION_PATH, O3_UV_START, &
                         O3_UV_CS_FILE, DO_O3TEMP_GOMEFM, O3_UV_END, &
                         DO_XSECTION_AKIMA, RAY_EXT
  USE VECT_VARS,   ONLY: INC_POL
  USE VRS,         ONLY: Add_TRS
  USE WATER,       ONLY: UWT, NLAYERS_UW, N_ABS_UW, NSTR_W, NSZA_W, NNv_W, &
                         Ref_ind, OUT_WLR, INCL_INEL, Sol_off, INEL_DO,  &
                         INEL_ADJ, UIT
  USE WATER_ICE,   ONLY: IWS, N_IW, IWT, LoIW

  LOGICAL   DO_NEAR_NADIR, WL_GRID_FLAG
  INTEGER   N_COL_WL
  CHARACTER (LEN=:), ALLOCATABLE :: HITRAN_DIR, WL_DATA_FILE
  REAL (KND)  NEAR_NADIR_DEFINITION
  
  ! Local parameters
  CHARACTER (LEN=*), PARAMETER :: R_NAME = 'GT_FILEREAD'

  LOGICAL  DO_PROFILE_LAT_INTERP, DO_GEOLOCATION, DO_STOP_GEOLOCATION, OUT_SPEC,&
           CONVOL_LA_ONLY, REPL_FLAG, AC_FLAG, RAY_FLAG, ADV_PROF, &
           WF_READ, Interp_Fi, FLG
  LOGICAL  TMP_FLG(N_CIA_G)

  INTEGER  I, J, K, II, LL, ASCII_POS, DAY, MONTH, N_INP, KK, I1, I2,&
       LAN, NAC  !, Nz_LEV
  INTEGER, PARAMETER :: N_OWF_GEN = 5, IUNIT = 33
      
  CHARACTER (LEN=100) Msgs(10)
  CHARACTER (LEN=3)   CC_INP
  CHARACTER (LEN=22), ALLOCATABLE ::  STG_ARR(:)
  CHARACTER (LEN=4),  ALLOCATABLE :: GAS_LABELS_PC(:)
  CHARACTER (LEN=:), ALLOCATABLE :: MSG, STR, PATH_TO_CLIMATOLOGY_DB, STR_INP, &
       X_CORE, CHAR_3, STR_LOC, AER_TOP, TAU_FLAG, DATE_MODE, HGI, &
       ALT_PATH, WL_PATH, DIR_PATH, SR_TYPE, GAS_NAME, PAR_STRING, STG, SCHEME, &
       Ill_Mode
  LOGICAL, ALLOCATABLE :: CS_FLAG(:), Lo_rrs(:)
  REAL (KND)  Rinc(4), WL_S, PAR_1, PAR_2, PAR_3, MATTHEWS_ALBEDO, ALBEDO_MTS,&
              VMR_VAL, DU2, DU3, DU4
  REAL (KND),  ALLOCATABLE :: ADD_OT(:)
  TYPE (DYN_CHAR), ALLOCATABLE :: READ_ARR(:), STR_ARR(:), STR_ARR_1(:) 
  TYPE (ArrChar), ALLOCATABLE :: ReadStc(:)
  TYPE (TE_type)  :: TE     ! Thermal emission
  !==================================================================

!*************************************************************************
!************************ START OF CODE **********************************
!*************************************************************************
  CALL ST_TRACK (R_NAME, 3, 'I')

  CALL DEALLOCATE_ARRAYS ! All arrays allocated below must be 
                         ! conditionally deallocated here
  CALL INFO_INIT (*880)

  RT_AG = 'user'
  
!  Use_Dim = .FALSE.
  Use_Dim = .TRUE.

  Sec_Order = .FALSE.
  
! ... Specific option for Rayleigh scattering cross-section (N2,O2,CO2,Ar)
!  RAY_EXT = .TRUE.
  RAY_EXT = .FALSE.

! ... Specific option in order to calculate angular averaged BRF
!  AA_BRF = .TRUE.
  AA_BRF = .FALSE.
  
! ... Use option "diffuse illumination from below"
  DIFB = .FALSE.

  Ray_to_WF = .FALSE.
  ! Angstrom parameterization for aerosol extinction
  Use_AP = .FALSE.
  ! Use MODIS aerosol parameterization
  MODIS_AP = .FALSE.
  ! Aerosol like cloud layer
  SHARP_EDGES = .FALSE.
  ! Flag TRANS_OUT to calculate diffuse and direct transmissions 
  ! will be set to .TRUE. in "read_ret_main.f90" if 
  ! RET_MODE was set to 'aer-hom' or to 'aer-ratio'
  TRANS_OUT = .FALSE.
  SURF_TYPE = 'none'

  Gauss_Field = .FALSE. ;  OUT_WLR     = .FALSE. ;  Ref_type  = 'non'
  WF_READ     = .FALSE. ;  ADV_PROF    = .FALSE. ;  Nc_ALB    = 1
  MES_OUT_LS  = .TRUE.  ;  MES_OUT_SOL = .TRUE.   ;  Nder     = 0
  Sep_IR     = .FALSE.  ;  USE_PSM     = .FALSE.  ;  N_HPC    = 0
  OUT_H_SCM  = .FALSE.

  STR_INP = 'Perform IPRT comparison'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S,*,ERR=101) IPRT, IPRT_ALIN
  IF( .NOT.IPRT ) IPRT_ALIN = .FALSE.

  ALIN_FLAG = .FALSE. 
  ! Alternative input for IPRT-comparison only
  IF( IPRT_ALIN )  ALIN_FLAG = .TRUE. 
  ALIN_ACT(:) = .FALSE.
  ! Read all optical parameters from input files
  IF( ALIN_FLAG ) CALL READ_ALIN(*880)

  DO I = L_S, L_E
     Call WriteOut (L_U(I), '', LUF(I))
     Call WriteOut (L_U(I), '  ******************************************', LUF(I))
     Call WriteOut (L_U(I), '  ***  General settings:                    ', LUF(I))
     Call WriteOut (L_U(I), '  ***       control.inp & control_ac.inp    ', LUF(I))
     Call WriteOut (L_U(I), '  ******************************************', LUF(I))
  END DO

  STR_INP = 'Home directory'
  CALL Read_Input (STR_INP, READ_ARR, *880, LocF=.True.)
  If(Allocated(READ_ARR)) HOME_DIR = CUT_STR(READ_ARR(1)%S)

  !*************************************************************************
  !************************ Overall algorithm control **********************
  !*************************************************************************
  RAD_FIELD = .FALSE. ; VHL = .FALSE. ; SCAL_ALB = 1.d0
  Interp_RF = .TRUE.  ; Use_Sym = .FALSE. ;  Short_los = .FALSE.
  Sel_los = .FALSE.
  SSC_RF    = .FALSE.
  STR_INP = 'RTM_TYPE'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  RTM_TYPE = CUT_STR(READ_ARR(1)%S)
  SELECT CASE (TRIM(RTM_TYPE))
  CASE('pp_scat', 'ps_scat', 'transmission')
  CASE('vhl')
     VHL = .TRUE. ; RTM_TYPE = 'pp_scat'
  CASE('spher_scat','sps_scat','spp_scat')
     Gauss_Field = .TRUE.
  CASE DEFAULT
     CALL NOT_FOUND (R_NAME, STR_INP, RTM_TYPE, *880)
  END SELECT

  SELECT CASE (RTM_TYPE)
  CASE('pp_scat')
     ! Set additional grid dimensions for the plane-parallel medium
     NL_FINE = 1 ;  MAX_LINE = 1
  CASE DEFAULT
     !  The additional grid dimensions will be set in "rtm_main.f"
  END SELECT

!  write(*,*) '     before ocean '
  
  STR_INP = 'Include radiative transfer within ocean or ice'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  IF(SIZE(READ_ARR) > 0) THEN
     C_SYS = CUT_STR(READ_ARR(1)%S)
     ! Check reading of C_SYS parameter
     IWT = .FALSE. ;  UWT = .TRUE. ;  UIT = .TRUE.
     LoIW(:) = .FALSE.
     N_IW = 1
     SELECT CASE( C_SYS )
     CASE('ice')     ; LoIW(1) = .TRUE.
     CASE('ocean')   ; LoIW(2) = .TRUE.  ; UIT = .FALSE.  
     CASE('sea_ice') ; LoIW(:) = .TRUE.  ; IWT = .TRUE.
     CASE DEFAULT
        CALL NOT_FOUND (R_NAME, STR_INP, C_SYS, *880)
     END SELECT
     IF( IWT ) N_IW = 2
     If(Allocated(IWS)) Then
        Do II = 1, Size(IWS)
           if(allocated(IWS(II)%HSOL_PHAS_VS)) DeAllocate(IWS(II)%HSOL_PHAS_VS)
        End Do
        DeAllocate(IWS)
     End If
     ALLOCATE( IWS(2) )
     IWS(1)%Name_IW = 'Ice-'
     IWS(2)%Name_IW = 'Water'
  ELSE
     IWT = .FALSE. ;  UWT = .FALSE. ;  UIT = .FALSE.
  END IF

!  write(*,*) '     after ocean '
  
  IF( ALIN_FLAG .OR. VHL ) THEN
     IWT = .FALSE. ;  UWT = .FALSE. ;  UIT = .FALSE.
  ENDIF

  STR_INP = 'Include land fluorescence'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
  CALL UPPER_LOWER_CASE (STR_ARR(1)%S  ,'U2L')  
  SELECT CASE( STR_ARR(1)%S )
  CASE('file')
     FLU_L = .TRUE. ; USE_DGF = .FALSE.
     FLU_NAME = SET_PATH(STR_ARR(2)%S)
     READ(STR_ARR(3)%S, *, ERR = 101)  FLU_SCAL
  CASE('double-gaussian')
     FLU_L = .TRUE. ; USE_DGF = .TRUE. ; FLU_SCAL = 1.d0
     ALLOCATE( DGF_PAR(2) )
     READ(STR_ARR(2)%S,*,ERR=101)  DGF_PAR(1)%Amp
     READ(STR_ARR(3)%S,*,ERR=101)  DGF_PAR(1)%Wlm
     READ(STR_ARR(4)%S,*,ERR=101)  DGF_PAR(1)%Hwhm
     READ(STR_ARR(5)%S,*,ERR=101)  DGF_PAR(2)%Amp 
     READ(STR_ARR(6)%S,*,ERR=101)  DGF_PAR(2)%Wlm 
     READ(STR_ARR(7)%S,*,ERR=101)  DGF_PAR(2)%Hwhm
  CASE('off')
     FLU_L = .FALSE. ; USE_DGF = .FALSE.
  CASE DEFAULT
        CALL NOT_FOUND (R_NAME,STR_INP,STR_ARR(1)%S, *880)
  END SELECT

  SPECULAR = .FALSE. ;  OWF_FLAG = .FALSE.

  IF( UWT ) THEN
     CALL READ_UWT(*880)
  ELSE  ! ----- No radiative transfer in water --------
     INCL_INEL(:) = .FALSE. ; Sol_off  = .FALSE. ; Add_TRS = .FALSE.
     INEL_DO      = .FALSE. ; INEL_ADJ = .FALSE.
     TES_2L_SLAB  = .FALSE.
     NSZA_W = 0  ;  NLAYERS_UW = 1  ;  N_ABS_UW = 1  ;  NSTR_W = 1
     NNv_W  = 1
     ! Preliminary for the initialization if "SPECULAR"
     ! will be set .TRUE. in the case of ocean surface
     Ref_ind = 1.34d0
  ENDIF

  CloudInit: Block
    DO_CLOUD= .False.
    If( ALIN_ACT(4) ) THEN
       DO_CLOUD   = .TRUE.
       Red_WL_Ydb = .FALSE.
       Exit CloudInit
    End If
    If (VHL) Exit CloudInit
    If (TES_2L_SLAB) Exit CloudInit
    STR_INP = 'Clouds present?'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) DO_CLOUD
  End Block CloudInit
  
  Vec_Sca = 'scal_rte'
  LSA_MODE = 'DEFAULT'
  IF(RTM_TYPE /=  'transmission') THEN
     STR_INP = 'RTM-CORE'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     X_CORE = CUT_STR(READ_ARR(1)%S)
     SELECT CASE( TRIM(X_CORE) )
     CASE('DOM_S')
        RTM_CORE = 'DOM'
        Select Case (RTM_TYPE)
        Case ('ps_scat', 'pp_scat')
           LSA_MODE = 'DOM_NS'
        Case ('sps_scat')
           LSA_MODE = 'CDI_PS'
           RTM_TYPE = 'spher_scat'
        Case ('spp_scat')
           LSA_MODE = 'CDI_PP'
           RTM_TYPE = 'spher_scat'
        End Select
     CASE('DOM_V')
        RTM_CORE = 'DOM'   ; Vec_Sca = 'vect_rte' 
        IF(RTM_TYPE == 'ps_scat'.or.RTM_TYPE == 'pp_scat') LSA_MODE = 'DOM_NS'
        Select Case (RTM_TYPE)
        Case ('ps_scat', 'pp_scat')
           LSA_MODE = 'DOM_NS'
        Case ('sps_scat')
           LSA_MODE = 'CDI_PS'
           RTM_TYPE = 'spher_scat'
        Case ('spp_scat')
           LSA_MODE = 'CDI_PP'
           RTM_TYPE = 'spher_scat'
        End Select
     CASE('CDI', 'ASYMP', 'TRN')
        RTM_CORE = X_CORE
        IF(RTM_TYPE == 'ps_scat') LSA_MODE = 'CDI_PS'
          
        IF( VHL ) THEN
           CALL WRITE_MESSAGE(R_NAME, 'ERROR',' ')
           WRITE(EU,*) '    "'//X_CORE//'" mode is not supported the light'
           WRITE(EU,*) '     scattering in homogeneous layer.'
           WRITE(EU,*) '     Check "RTM_TYPE" in "control.inp".'
           RETURN 1
        ENDIF
     CASE DEFAULT
        CALL NOT_FOUND (R_NAME,STR_INP,X_CORE, *880)
     END SELECT
  ELSE
     RTM_CORE = 'TRN'
  END IF

  NS_wf = 1
  SELECT CASE (Vec_Sca)
  CASE('scal_rte')
     INC_POL = .FALSE.
     Nm_vs = 1 ; Nvs = 1
     VST = 1.d0 ; VS_HC = 2.d0  ! scalar case 
     ALLOCATE( IDM(1),LDM(1), Finc(1,1), Nc_der(1), Ainc(1,1) )  
     IDM(1) = 0 ; LDM(1) = 0
     Finc(1,1) = 1.d0 ; Nc_der(1) = 1 ; Ainc(1,1) = 1.d0
     Kvs = 1 
     D_sol(:) = .TRUE.

  CASE('vect_rte')
     ! INC_POL is introduced to describe the polarization state of the
     ! incident light. The value .FALSE. is acceptable for this version.
     ! The polarization state of the incident light is not yet implemented.
     INC_POL = .FALSE.
     Nm_vs = 6 ; Nvs = 4
     VST = 2.d0 ; VS_HC = 1.d0  ! vector case
     ALLOCATE( IDM(6),LDM(6) )
     IDM(1) = 1 ; IDM(2) = 5 ; IDM(3) = 5
     IDM(4) = 2 ; IDM(5) = 2 ; IDM(6) = 2
     
     LDM(1) = 3 ; LDM(2) = 3 ; LDM(3) = 3
     LDM(4) = 6 ; LDM(5) = 6 ; LDM(6) = 4

     STR_INP = 'Stokes vector of incident beam'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) Rinc

!    ... Integer Kvs defins either 1 or 2 specific discrete-ordinates 
!        solution should be used to construct complect solution
     Kvs = 1
     DO I = 3,4
        ! Array Rinc(1:4) defines polarization state of the incident light.
        IF( Rinc(I) /= 0.d0 ) THEN
           Kvs = Kvs + 1  ;  EXIT
        ENDIF
     ENDDO
     IF( Kvs > 2 ) STOP ' Kvs in "gt_fileread.f90" > 2 !'

!     IF( UWT.AND.Vec_sca=='vect_rte' ) Kvs = 2
     
     ALLOCATE( Finc(2,4) ) ;  Finc = 0.d0
     Finc(1,1:2) = Rinc(1:2)
     IF( Kvs == 2 ) Finc(2,3:4) = Rinc(3:4)

!!     Test calculation
!     Kvs = 2
!     WRITE(*,*) '  Kvs = ', Kvs
!     WRITE(*,'(A,2x,*(1x,f4.1))') '  Finc 1 : ', Finc(1,:)
!     WRITE(*,'(A,2x,*(1x,f4.1))') '  Finc 2 : ', Finc(2,:)
!     pause
     
     D_sol(:) = .TRUE.
     ! In the case F=|0,0,a,b| the first DO-solution should
     ! not be accounted for
     IF( Finc(1,1)==0.d0.AND.Finc(1,2)==0.d0 ) D_sol(1) = .FALSE.

     !   .... Test with mode "solv_asi"
!     NS_wf = 3
!     ALLOCATE( Nc_der(NS_wf), Ainc(NS_wf,4) )
!     Ainc = 0.d0 
!     Nc_der(1) = 1  ;  Ainc(1,1) = 1.d0
!     Nc_der(2) = 2  ;  Ainc(2,2) = 1.d0
!     Nc_der(3) = 3  ;  Ainc(3,3) = 1.d0
!     WRITE(*,*) '   Set polarization state for adjoint equation '
!     DO K = 1, NS_wf
!        WRITE(*,'(A,1x,4(1x,F4.1))') ' Ainc : ', Ainc(K,:)
!     ENDDO
     !   End test

  END SELECT ! Vec_Sca

  STR_INP = 'RTM Mode'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
  RTM_MODE = CUT_STR(STR_ARR(1)%S)
  IF( RTM_MODE == 'spher_alb' ) THEN
!     WRITE(*,*) ' SIZE(STR_ARR)   ', SIZE(STR_ARR) 
     IF( SIZE(STR_ARR) < 2 ) THEN
        CALL WRITE_MESSAGE(R_NAME, 'ERROR', ' ')
        WRITE(EU,*) ' The second entry in the ' &
             //'input line "RTM Mode" can not be empty'
        WRITE(EU,*) '    in the case of "spher_alb" mode.'
        RETURN 1
     ENDIF
     CALL UPPER_LOWER_CASE (STR_ARR(2)%S  ,'U2L')
     Ill_Mode =  CUT_STR(STR_ARR(2)%S)
     IF( Ill_Mode=='iifb' ) THEN
        DIFB = .TRUE. ;  RTM_MODE = 'flux'
     ENDIF
  ENDIF
  IF( VHL ) THEN
     IF( RTM_MODE =='raman' ) THEN
        Msgs(1)='Raman scattering is not implemented'
        Msgs(2)='  for the "vhl" mode.'
        Msgs(3)='Check "RTM_TYPE" input parameter in'
        Msgs(4)='  "control.inp" file.'
        CALL WRITE_MSG(R_NAME,'ERROR',Msgs,4,*880)
     ENDIF                  ! 'vhl' mode
     RTM_MODE = 'int'
  ENDIF

  Fbe = 1.d0
  IF( DIFB ) THEN
     Fbe = 0.d0  ! solar illumination
     FLU_L = .TRUE. ; USE_DGF = .FALSE.
  ENDIF

!!   Test run with isotropic illumination from below
!  DIFB = .TRUE. ; Fbe = 0.d0 ;  FLU_L = .TRUE. ; USE_DGF = .FALSE.
  
  IF( RTM_MODE =='block_amf' ) THEN
     IF( SIZE(STR_ARR) < 2 ) THEN
        CALL WRITE_MESSAGE(R_NAME, 'ERROR', ' ')
        WRITE(EU,*) ' The second entry in the ' &
             //'input line "RTM Mode" can not be empty'
        WRITE(EU,*) '    in the case of "block_amf" mode.'
        RETURN 1
     ENDIF
     CONV_Z =  CUT_STR(STR_ARR(2)%S)
  ELSE
     CONV_Z = 'default' 
  ENDIF
 
  IF(RTM_MODE == 'vod') RTM_CORE = 'VOD'

  DO_RAMAN = .FALSE. ;  RING_FLAG =.FALSE. ;  RRS_ADJ  = .FALSE. ;
  RRS_DO   = .FALSE. ;  RET_FLAG = .FALSE. ;  DOM_API  = .FALSE.
  WF_FLAG = .FALSE.  ;  RRS_TEST = .FALSE.
!  write(*,*) '     RTM_MODE = ', RTM_MODE
!  PAUSE

  SELECT CASE (RTM_MODE)
  CASE('int', 'amf', 'slant_col', 'vod', 'num_pert')
  CASE('int_flux')
     Gauss_Field = .TRUE.
  CASE('flux')
     Gauss_Field = .TRUE. ;  OUT_WLR = .FALSE.
  CASE('spher_alb')
     Gauss_Field = .TRUE.
     If (RTM_CORE == "CDI") Then
        CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'The spherical ' &
             //'albedo cannot be calculated using CDI solver')
        RETURN 1
     End If
  CASE('wf','block_amf')     
     WF_FLAG = .TRUE.
  CASE('ret')
     WF_FLAG  = .TRUE.
     RET_FLAG = .TRUE.
  CASE('raman')
     CALL READ_RRS(*880)
     RING_FLAG =.TRUE. ;  DO_RAMAN  =.TRUE.
     IF(RRS_ADJ) Gauss_Field = .TRUE.
  CASE DEFAULT
     CALL NOT_FOUND (R_NAME, 'RTM Mode', RTM_MODE, *880)
  END SELECT

  IF( TRIM(RTM_TYPE)=='transmission' ) THEN
     SELECT CASE (RTM_MODE)
     CASE('flux', 'int_flux', 'vod', 'raman', 'spher_alb')
        CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'The RTM mode '//ACHAR(39)//RTM_MODE &
             //ACHAR(39)//' cannot be combined with the transmission mode')
        RETURN 1
     END SELECT
  ENDIF

  STR_INP = 'Advanced accuracy control'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S, *, ERR = 101) AC_FLAG
  IF( VHL ) AC_FLAG = .TRUE.

  ANG_INT = 'sfi' ;  DO_SSRCA = .FALSE. ;  N_ITER = 1
  DO_AZIMUTH = .FALSE. ; READ_NODES = .FALSE.
  PreCalcAngs  = .FALSE. ; PreCalcRtMatr  = .FALSE.
  Refr_HiRes  = .FALSE. ; PreCalcGeom  = .TRUE.

  SELECT CASE (RTM_CORE)
  CASE ('ASYMP')
     IF(RTM_MODE /= 'ret') RTM_MODE = 'asymp'
     WF_FLAG = .FALSE.
     IF(TRIM(RTM_TYPE) /= 'pp_scat') GOTO 210

  CASE ('DOM') 
     ANG_INT = 'sfi'
     WF_INTEGR = 'numeric'
     Wup = 0.5d0

     IF( AC_FLAG ) THEN

        STR_INP = 'Adaptive grid (aerosol, cloud)'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) AG_aer
!        AG_aer = .FALSE.        
        
        STR_INP = 'Adaptive grid'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        CALL UPPER_LOWER_CASE (STR_ARR(1)%S  ,'U2L')
        CHAR_3 = CUT_STR(STR_ARR(1)%S)        
        SELECT CASE( CHAR_3 )
        CASE('on')
           ADAPTIVE_GRID  = .TRUE. 
           READ(STR_ARR(2)%S, *, ERR=101)  CRIT_AG
           IF( SIZE(STR_ARR) > 2 ) THEN
              READ(STR_ARR(3)%S, *, ERR=101)  Mh_AG
              READ(STR_ARR(4)%S, *, ERR=101)  CRIT_AG_Mh
           ELSE
              Mh_AG = 0 ;  CRIT_AG_Mh = 0.d0
           ENDIF
        CASE('off')
           ADAPTIVE_GRID = .FALSE. ;  CRIT_AG = 0.d0
        CASE DEFAULT
           CALL NOT_FOUND (R_NAME,STR_INP,STR_ARR(1)%S, *880)
        END SELECT
        Enhance_acc = .FALSE.

!        WRITE(*,*) '   ADAPTIVE_GRID ', ADAPTIVE_GRID
!        WRITE(*,*) CRIT_AG, Mh_AG, CRIT_AG_Mh
!        Pause
!        STR_INP = 'Adaptive grid'
!        CALL Read_Input (STR_INP, READ_ARR, *880)
!        CRIT_AG = 0.d0
!        READ(READ_ARR(1)%S, *, ERR = 101) ADAPTIVE_GRID
!        IF(ADAPTIVE_GRID) THEN
!           STR_INP = 'Homogeneity criterion'
!           CALL Read_Input (STR_INP, READ_ARR, *880)
!           READ(READ_ARR(1)%S, *, ERR = 101) CRIT_AG
!           Enhance_acc = .FALSE.
!        END IF

        IF( TRIM(RTM_TYPE) == 'spher_scat' ) Then
           DO_SSRCA = .FALSE.
           STR_INP = 'Integration over L-of-S in Fourier space?'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           CHAR_3 = CUT_STR(READ_ARR(1)%S)
           SELECT CASE( CHAR_3 )
           CASE('yes')
           CASE('no')
           ! Calculation of first guess of full radiation field
           !    in spherical atmosphere
              RAD_FIELD = .TRUE.
           CASE DEFAULT
              CALL NOT_FOUND (R_NAME, STR_INP, CHAR_3, *880)
           END SELECT
! -------------------------------------------------------------------
           IF( RAD_FIELD ) THEN ! read some option as in CDI option
              STR_INP = 'Initialization of radiation field'
              CALL Read_Input (STR_INP, READ_ARR, *880)
              CHAR_3 = CUT_STR(READ_ARR(1)%S)
              SELECT CASE( CHAR_3 )
              CASE('RF_Interp') ; Interp_RF = .TRUE.
              CASE('RF_SFI')    ; Interp_RF = .FALSE. 
              CASE DEFAULT
                 CALL NOT_FOUND (R_NAME, STR_INP, CHAR_3, *880)
              END SELECT
!             ----------------------------------------------------------
              IF( .NOT.Interp_RF ) THEN
                 STR_INP = 'Single scattering correction (RF)'
                 CALL Read_Input (STR_INP, READ_ARR, *880)
                 READ(READ_ARR(1)%S, *, ERR = 101) SSC_RF
              ENDIF
              STR_INP = 'Use symmetry of radiation field'
              CALL Read_Input (STR_INP, READ_ARR, *880)
              READ(READ_ARR(1)%S, *, ERR = 101) Use_Sym
!             ----------------------------------------------------------
              STR_INP = 'Use precalculated scattering matrix'
              CALL Read_Input (STR_INP, READ_ARR, *880)
              CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
              CALL UPPER_LOWER_CASE (STR_ARR(1)%S  ,'U2L')
              CHAR_3 = CUT_STR(STR_ARR(1)%S)        
              SELECT CASE( CHAR_3 )
              CASE('on')
                 DISCR_M = ' '
                 USE_PSM  = .TRUE. 
                 READ(STR_ARR(2)%S, *, ERR=101)  ND_ANG
                 READ(STR_ARR(3)%S, *, ERR=101)  DISCR_M
                 SELECT CASE( DISCR_M )
                 CASE('G','E') 
                 CASE DEFAULT
                    GOTO 230
                 END SELECT   
              CASE('off')
                 USE_PSM  = .FALSE.
              CASE DEFAULT
                 CALL NOT_FOUND (R_NAME,STR_INP,STR_ARR(1)%S, *880)
              END SELECT
!              WRITE(*,*) ' -------  ', USE_PSM, ND_ANG
           ENDIF
! -------------------------------------------------------------------
        ELSE
           STR_INP = 'Single scattering correction'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           READ(READ_ARR(1)%S, *, ERR = 101) DO_SSRCA
        ENDIF

        STR_INP = 'Precision mode for eigenvalue problem'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) PREC_FLAG
        SELECT CASE( PREC_FLAG )
        CASE('sngl','doub')
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, STR_LOC, *880)
        END SELECT
        
        STR_INP = 'Analytic for conservative scattering'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        READ(STR_ARR(1)%S, *, ERR = 101) CS_ANALYTIC
        READ(STR_ARR(2)%S, *, ERR = 101) PSAB

        SELECT CASE (TRIM(RTM_MODE))
        CASE('flux', 'vod', 'spher_alb')
        CASE DEFAULT
           STR_INP = 'Azimuth series flag'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           READ(READ_ARR(1)%S, *, ERR = 101) DO_AZIMUTH
        END SELECT

        STR_INP = 'Accuracy criterion'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) ACCUR

        STR_INP = 'Number of streams'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) NSTRMS

        STR_INP = 'Number of Legendre moments'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) NLEGEN

        SELECT CASE (TRIM(RTM_TYPE))
        CASE('spher_scat','transmission')
           Interp_Fi = .FALSE.
        CASE DEFAULT
           STR_INP = 'Post-processing type'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           STR_LOC = CUT_STR(READ_ARR(1)%S)
           SELECT CASE( STR_LOC )
           CASE('Interp')
              Interp_Fi = .TRUE.
           CASE('Int_SF')
              Interp_Fi = .FALSE.
           CASE DEFAULT
              CALL NOT_FOUND(R_NAME, STR_INP, STR_LOC, *880)
           END SELECT
        END SELECT

        ! Additional angle corresponding to the zenith direction, with
        ! the ZERO weight will be introduced in the routine "gt_hi_wi.f"
        ! (array AG) to avoid extrapolation at the air-water interface
        ! for line-of-sight angles near and at nadir or zenith directions
        ! as well as in the case if 'Post-processing type' is set to
        ! 'Interp'
        IF( UWT.OR.Interp_Fi ) NSTRMS = NSTRMS + 1
        NNv = NSTRMS*Nvs

        IF(DO_AZIMUTH) THEN
           STR_INP = 'Do only 0th harmonic for near nadir'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           READ(READ_ARR(1)%S, *, ERR = 101) DO_NEAR_NADIR
           STR_INP = 'Near nadir definition [deg]'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           READ(READ_ARR(1)%S, *, ERR = 101) NEAR_NADIR_DEFINITION
        ELSE
           DO_NEAR_NADIR = .FALSE.
        END IF
     ELSE ! AC_FLAC
        ! Default setting of main accuracy control parameters
        Interp_Fi = .FALSE. ; ADAPTIVE_GRID = .FALSE. 
        CRIT_AG = 0.d0 ; Mh_AG = 0 ;  CRIT_AG_Mh = 0.d0 
        Enhance_acc   = .FALSE. ; DO_SSRCA    = .FALSE.
        DO_AZIMUTH    = .TRUE. ; CS_ANALYTIC  = .FALSE. ; PSAB = 1.d-04
        PREC_FLAG = 'sngl'
        ACCUR = 0.001d0 ; NSTRMS = 16
        IF( UWT ) NSTRMS = NSTRMS + 1
        NNv = NSTRMS*Nvs
        NLEGEN = 35
        DO_NEAR_NADIR = .TRUE.
        NEAR_NADIR_DEFINITION = 0.01d0
     ENDIF

     IF( UWT ) THEN
        ! The number of streams in the Fresnel cone is set to 
        ! be equal of streams number in the atmosphere:
        NSTR_W = NSTRMS
        NNv_W = Nvs*NSTR_W
     ENDIF

     ! Logical INT_OUT is set to .TRUE. if the post-processing
     ! technique can not be used. In this case the angular
     ! interpolation will be performed to obtain intensity at
     ! desired using-defined zenith angles
     INT_OUT = Interp_Fi.AND.(RTM_MODE == 'int'.OR. RTM_MODE == 'raman')
     ! Do not use azimuthal harmonics for calculation of
     ! flux and spherical albedo
     SELECT CASE (TRIM(RTM_MODE))
     CASE('flux', 'spher_alb')
        DO_AZIMUTH = .FALSE.
        IF( RAD_FIELD ) DO_AZIMUTH = .TRUE.
     END SELECT
     
  CASE ("TRN")
     If (DO_CLOUD) Then
        STR_INP = 'Number of streams'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) NSTRMS

        STR_INP = 'Number of Legendre moments'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) NLEGEN
     End If

  CASE ('CDI')
     SELECT CASE (RTM_TYPE)
     CASE('spher_scat')
     CASE('ps_scat')
        ! Phase function should be saved into array Greek_aer
        ! in the case of the "mie" mode within option "CDI"
        DO_SSRCA = .TRUE.
     CASE DEFAULT
        GOTO 211
     END SELECT

  CASE ('VOD')

  CASE DEFAULT
     CALL NOT_FOUND (R_NAME, 'RTM-CORE', RTM_CORE, *880)
  END SELECT

  SpherPars: Block
    N_ITER = 1 ;  READ_NODES = .FALSE. ;  ModeNodes = 'Std'
    USE_AIN = .FALSE. ;  USE_HIN = .FALSE.
    IF(.Not.AC_FLAG ) Exit SpherPars
    STR_INP = 'High resolution calculations for the refraction'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) Refr_HiRes
    Select Case (RTM_CORE)
    Case('DOM')
       IF( RTM_TYPE /= 'spher_scat' ) Exit SpherPars
       IF( .Not.RAD_FIELD ) Exit SpherPars
    Case ("VOD", "TRN")
       Exit SpherPars
    End Select
    STR_INP = 'The number of iterations'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) N_ITER
    STR_INP = 'Integration nodes'
    CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange = .True.)
    Call Upper_Lower_Case (READ_ARR(1)%S,'U2L')
    Select Case (READ_ARR(1)%S)
    Case ("def")
    Case ("read")
       READ_NODES = .True.
       FILE_NODES = SET_PATH(READ_ARR(2)%S)
       ModeNodes = 'Std'
    Case ("eqd")   
       READ(READ_ARR(2)%S, *, ERR = 101) NVA
       READ(READ_ARR(3)%S, *, ERR = 101) NAz               
       ModeNodes = 'eqd'
       STR_INP = 'BRDF integration nodes'
       CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange = .True., ULC = 'L')
       IF( READ_ARR(1)%S =='on' ) THEN
          USE_AIN = .TRUE.
          READ(READ_ARR(2)%S, *, ERR = 101) N_Va
          READ(READ_ARR(3)%S, *, ERR = 101) N_Az
       ENDIF
       STR_INP = 'RF integration nodes'
       CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange = .True., ULC = 'L')
       IF( READ_ARR(1)%S =='on' ) THEN
          USE_HIN = .TRUE.
          READ(READ_ARR(2)%S, *, ERR = 101) NVa_HIN
          READ(READ_ARR(3)%S, *, ERR = 101) NAz_HIN
       ENDIF
     Case Default
       Call Not_Found (R_NAME, STR_INP, STR_ARR(1)%S, *880)
    End Select
    STR_INP = 'Short characteristics'
    CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange = .True., ULC = 'L')
    SELECT CASE( CUT_STR(READ_ARR(1)%S) )
    CASE('on')
       Short_los = .TRUE.
       READ(READ_ARR(2)%S, *, ERR=101)  Cr_Short_los
    CASE('off')
       Cr_Short_los = -1.0
    CASE DEFAULT
       CALL NOT_FOUND (R_NAME, STR_INP, CHAR_3, *880)
    End SELECT
    STR_INP = 'Select LoS'
    CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange = .True., ULC = 'L')
    SELECT CASE( READ_ARR(1)%S )
    CASE('on')
       Sel_los = .TRUE.
       READ(READ_ARR(2)%S, *, ERR=101)  Cr_Sel_los
    CASE('off')  ;  Cr_Sel_los = 1.d0
    CASE DEFAULT
       CALL NOT_FOUND (R_NAME, STR_INP, CHAR_3, *880)
    END SELECT
  End Block SpherPars
  
  If( AC_FLAG ) Then
     STR_INP = 'Pre-calculate line-of-sight geometry'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
     ! This setting cannot be used with Fourier integration module
     If(RAD_FIELD.or.RTM_CORE == 'CDI') &
          READ(STR_ARR(1)%S, *, ERR = 101) PreCalcGeom
     If(RTM_CORE == 'CDI' .and. .Not.PreCalcGeom) GoTo 235
     If(Size(STR_ARR) > 1) Then
        READ(STR_ARR(2)%S, *, ERR = 101) PreCalcAngs
        If(PreCalcAngs .and. LSA_MODE == "CDI_PP") GoTo 233
     End If
     If(Size(STR_ARR) > 2 .and. Nvs > 1) Then
        READ(STR_ARR(3)%S, *, ERR = 101) PreCalcRtMatr
     End If
     STR_INP = 'Altitude interpolation type'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     Select Case (READ_ARR(1)%S)
     Case('A','a')
        AKIMA_FLG = .TRUE.
     Case('L','l')
        AKIMA_FLG = .FALSE.
     Case Default
        Call Not_Found(R_NAME,STR_INP,READ_ARR(1)%S, *880)
     End Select
     STR_INP = 'Logarithmic interpolation in altitude'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) F_LGI_SCR, F_LGI_SCA, F_LGI_EXT
!     STR_INP = 'Multiple scattering field interpolation'
!     CALL Read_Input (STR_INP, READ_ARR, *880)
!     READ_ARR(1)%S = CUT_STR(READ_ARR(1)%S)
!     CALL UPPER_LOWER_CASE (READ_ARR(1)%S  ,'U2L')
!     Select Case (READ_ARR(1)%S)
!     Case('akima')
!        MSF_INT = "Akima"
!     Case('loglin')
!        MSF_INT = "LogLin"
!     Case Default
!        Call Not_Found(R_NAME,STR_INP,READ_ARR(1)%S, *880)
!     End Select
     MSF_INT = "Akima"
!     MSF_INT = "Spline"
  Else
     F_LGI_SCR = .FALSE. ;   F_LGI_SCA = .FALSE. ;  F_LGI_EXT = .FALSE.
     AKIMA_FLG = .FALSE. ;   MSF_INT = "Akima"
  End If

!  STR_INP = 'High resolution calculations for the refraction'
!  CALL Read_Input (STR_INP, READ_ARR, *880)
!  READ(READ_ARR(1)%S, *, ERR = 101) Refr_HiRes
 
  IF(TRC_FLG(1)) THEN
     PE_Mode = 'OFF'
  ELSE
!    STR_INP = 'Parallel wavelength loop'
!    CALL Read_Input (STR_INP, READ_ARR, *880)
!    READ(READ_ARR(1)%S, *, ERR = 101) PARALLEL_WL
     STR_INP = 'Parallel execution'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     PE_Mode = CUT_STR(READ_ARR(1)%S)
     CALL UPPER_LOWER_CASE (PE_Mode,'L2U')
     Select Case (PE_Mode)
     Case ('WL', 'LOS', 'OFF')
     Case Default
        Call Not_Found(R_Name, STR_INP, PE_Mode, *880)
     End Select
  END IF

  IF( DIFB ) THEN
     EXTR_FLUX = 'Unity'
  ELSE
     STR_INP = 'Extra-terrestrial solar flux'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     EXTR_FLUX = CUT_STR(READ_ARR(1)%S)
     SELECT CASE( EXTR_FLUX )
     CASE('Pi','Unity')
        IF( RTM_MODE == 'raman' ) GOTO 225
     CASE('File')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, EXTR_FLUX, *880)
     END SELECT
  ENDIF
!*************************************************************************
!************************ Planck calculations ****************************
!*************************************************************************
  STR_INP = 'Thermal emission'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S, *, ERR = 101) DO_PLANCK
  IF( VHL ) DO_PLANCK = .FALSE.
  SET_SOL_USR = .FALSE.  ;  BRIGHT_TEMP = .FALSE.

  IF( TRIM(RTM_CORE)=='VOD' ) DO_PLANCK = .FALSE.

  TE%NO_SUN = .FALSE. ;  NO_SUN = .FALSE.
  IF( DO_PLANCK ) THEN
     EXTR_FLUX = 'File'
     VMAX  = DLOG( HUGE(1.0D0) )
     EPSIL = TINY(1.0D0)

     STR_INP = 'Scale the extra-terrestrial solar flux'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) Fbe

     STR_INP = 'Switch off solar light'
     CALL Read_Input (STR_INP, READ_ARR, *880)
!     READ(READ_ARR(1)%S, *, ERR = 101) TE%NO_SUN
     READ(READ_ARR(1)%S, *, ERR = 101) NO_SUN

     STR_INP = 'Set solar flux'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     READ(STR_ARR(1)%S, *, ERR = 101) SET_SOL_USR
     IF(SET_SOL_USR) READ(STR_ARR(2)%S, *, ERR = 101) SOL_FLUX_USR
     
     STR_INP = 'Surface temperature'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) BTEM

!    ... Start input emissivity     
     STR_INP = 'Surface emissivity'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     IF( SIZE(STR_ARR) == 1 ) THEN
        Emi_FILE = .FALSE.  ;  ALLOCATE( Sur_Emis(1) )
        READ(STR_ARR(1)%S,*,ERR=101) Sur_Emis(1)
     ELSE
        Emi_FILE = .TRUE.
        Emi_NAME = SET_PATH(STR_ARR(1)%S)
        SELECT CASE( STR_ARR(2)%S )
        CASE('Linear')    ;  Emi_akima = .FALSE.
        CASE('Akima')     ;  Emi_akima = .TRUE.
        CASE DEFAULT
           CALL NOT_FOUND (R_NAME, STR_INP, STR_ARR(2)%S, *880)
        END SELECT
     ENDIF
!    ... End input emissivity     
     
     STR_INP = 'Spectral integration of Planck function'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     READ(STR_ARR(1)%S, *, ERR = 101) INTEGR_PLANCK
     IF(INTEGR_PLANCK) THEN
        READ(STR_ARR(2)%S, *, ERR = 101) WNUMLO
        READ(STR_ARR(3)%S, *, ERR = 101) WNUMHI
     END IF
     
     STR_INP = 'Accuracy of Planck function approximation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) Pla_acc
     
     STR_INP = 'Output in brightness temperature'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) BRIGHT_TEMP

     If(PE_Mode /= 'WL') Then
        STR_INP = 'Planck output control'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        READ(STR_ARR(1)%S, *, ERR = 101) OUT_PLANCK
        IF(OUT_PLANCK) Path_for_PLANCK = SET_PATH(STR_ARR(2)%S)
     Else
        OUT_PLANCK = .False.
     End If
     
     ! Internal dimension of arrays belonging to the thermal emission
     ! will be set in "rtm_main.f"
  ELSE
     ! Internal dimension of arrays belonging to the thermal emission
     NL_pla = 2  ;  NN_pla = 1  ;  LS_pla = 1
     NL_FINE_pla = 1            ;  Nf_pla = 1
  ENDIF
  
  ! Check extraterrestrial solar flag
  ! ---------------------------------
  IRRAD_FLAG = .FALSE.
!  IF(RTM_MODE =='ret' .AND. (.NOT.DO_PLANCK)) EXTR_FLUX = 'Unity'
  IF(EXTR_FLUX == 'File') IRRAD_FLAG = .TRUE.

  IF( RTM_CORE =='VOD' ) THEN
     IRRAD_FLAG = .FALSE. ; EXTR_FLUX  = 'Pi'
  ENDIF

  IF( Vec_Sca == 'vect_rte' ) DO_NEAR_NADIR = .FALSE.
      
!*************************************************************************
!************************ SCATTERING MODE SELECTION **********************
!*************************************************************************
  ScatterMode: Block
    SCATT_MODE = 'ms' ; SS_MS_BOUNDARY = 300.0d0
    If(RTM_TYPE == 'transmission') Then
       SCATT_MODE = 'ss' 
       Exit ScatterMode
    End If
    If(.not.AC_FLAG) Exit ScatterMode
    STR_INP = 'Scattering mode'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    SCATT_MODE = CUT_STR(READ_ARR(1)%S)
    IF( TRIM(SCATT_MODE) == 'so' ) THEN
       Sec_Order = .TRUE.
       SCATT_MODE = 'ms'
    ENDIF
    Select Case (SCATT_MODE)
    Case("ss", "dir_ref")
       DO_SSRCA = .FALSE.
    End Select

    ! In the case of single scattering mode the rotational Raman
    ! in the atmosphere should be performed using mode RRS_ADJ
    IF( SCATT_MODE =='ss' .AND. DO_RAMAN ) THEN
       RRS_ADJ  = .TRUE. ;  RRS_DO   = .FALSE.
    ENDIF
  
    STR_INP = 'SS/MS wavelength boundary'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) SS_MS_BOUNDARY
  End Block ScatterMode

  STR_INP = 'Advanced Rayleigh settings'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S, *, ERR = 101) RAY_FLAG
  IF( VHL ) RAY_FLAG = .TRUE.
!*************************************************************************
!******************** Rayleigh scattering settings ***********************
!*************************************************************************
  IF( RAY_FLAG ) THEN
     STR_INP = 'Rayleigh optical thickness'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     READ(STR_ARR(1)%S, *, ERR = 101) DO_RAY_TAU
     IF(DO_RAY_TAU) READ(STR_ARR(2)%S, *, ERR = 101) RAY_TAU_INP
     IF( VHL ) THEN
        DO_RAY_TAU = .TRUE. ;  RAY_TAU_INP = 0.d0
     END IF
     
     IF( DO_RAY_TAU .OR. TES_2L_SLAB) THEN
        DO_RAY_DEP = .FALSE.
     ELSE
        STR_INP = 'Rayleigh scattering scaling'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        READ(STR_ARR(1)%S, *, ERR = 101) DO_RAY_DEP
        IF(DO_RAY_DEP) READ(STR_ARR(2)%S, *, ERR = 101) RAY_DEP
     END IF
        
     STR_INP = 'Rayleigh scattering index'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) RAY_SCATT_IDX
     STR_INP = 'Percent volume concentration'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) (PVC(I), I=1,4)
     PVC(:) = 1.d-2*PVC(:)
     STR_INP = 'Wavelength grid for Rayleigh scattering output'
     CALL Read_Input (STR_INP, READ_ARR, *880, JOIN = .TRUE.)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     Nwl_RR = SIZE(STR_ARR) ;  ALLOCATE( WL_RR(Nwl_RR) )
     DO II = 1, Nwl_RR
        !        READ(STR_ARR(1)%S, *, ERR = 101) WL_RR(II)
        READ(STR_ARR(II)%S, *, ERR = 101) WL_RR(II)
     END DO

     SELECT CASE (RAY_SCATT_IDX)
     CASE(1)
        King_factor = 'effective' ! used for Bates
        Refr_index  = 'Bates84'
     CASE(2)
        King_factor = 'effective' ! used for Bucholtz
        Refr_index  = 'Peck_Reeder72'
     CASE(3)
        King_factor = 'weighted' ! for Bodhaine
        Refr_index  = 'Peck_Reeder72'
     END SELECT

     ! Rayleigh cross-section according to "User_defined" mode
     DO_DEPOL_WAVELENGTH = .FALSE.
     IF( RAY_SCATT_IDX == 4 ) THEN
        STR_INP = 'Lorentz-Lorenz factor'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        LL_factor = CUT_STR(READ_ARR(1)%S)
        SELECT CASE( LL_factor )
        CASE('a','b','c','t')
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, LL_factor, *880)
        END SELECT

        STR_INP = 'Refractive index'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        Refr_index = CUT_STR(READ_ARR(1)%S)
        SELECT CASE( Refr_index )
        CASE('Edlen53','Edlen66','Peck_Reeder72','Bates84')
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, Refr_index, *880)
        END SELECT

        STR_INP = 'King factor'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        King_factor = CUT_STR(READ_ARR(1)%S)
        SELECT CASE( King_factor )
        CASE('constant')
           IF( DO_RAMAN ) GOTO 223
           STR_INP = 'Rayleigh depolarisation value'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           READ(READ_ARR(1)%S, *, ERR = 101) DEPOL_INPUT
        CASE('weighted','effective')
           IF( DO_RAMAN ) GOTO 223
        CASE('from file')
           STR_INP = 'Rayleigh depolarisation filename'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           DEPOL_FILENAME = SET_PATH(READ_ARR(1)%S)
           DO_DEPOL_WAVELENGTH = .TRUE.
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, King_factor, *880)
        END SELECT
     END IF
  ELSE
     IF( DO_RAMAN ) GOTO 224
     DO_RAY_TAU = .FALSE.
     RAY_SCATT_IDX = 1 ;  King_factor = 'effective'
     Refr_index  = 'Bates84' ;  DO_DEPOL_WAVELENGTH = .FALSE.
     ! Depolarization factor will be calculated
     ! in "KING_ACTUAL.f" (see "at_refr_king.f")
     ! DEPOL_INPUT = 0.0295d0 ! Is not used
     PVC(1) = 78.084d0 ; PVC(2) = 20.946d0
     PVC(3) = 0.934d0  ; PVC(4) =  0.036d0
     PVC(:) = 1.d-2*PVC(:)
     DO_RAY_DEP  = .FALSE.
     Nwl_RR = 1
     ALLOCATE( WL_RR(Nwl_RR) )
     WL_RR(1) = 550.d0
  ENDIF

!*************************************************************************
!************************* Trace gas selection ***************************
!*************************************************************************
  STR_INP = 'Forward model: trace gases'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  IF(SIZE(READ_ARR) > 0) &
       CALL FIND_MATCHES (*880, READ_ARR(1)%S, TG_INFO%NAME, TG_INFO%FM_FLG)

  SELECT CASE (TRIM(RTM_MODE))
  CASE('amf', 'slant_col', 'block_amf')
     STR_INP = 'Trace gas selection - AMF calculation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     STR_LOC = CUT_STR(READ_ARR(1)%S)
     AMF_IDX = FIND_IDX(STR_LOC,TG_INFO%NAME)
     
     IF(.NOT.TG_INFO(AMF_IDX)%FM_FLG) THEN
        TG_INFO(AMF_IDX)%FM_FLG = .TRUE.
        CALL WRITE_MESSAGE(R_NAME, 'ERROR', TG_INFO(AMF_IDX)%NAME// &
             ' absorption is switched on - needed to calculate AMF')
     END IF
  END SELECT

!*************************************************************************
!************************ Wavelength settings ****************************
!*************************************************************************
  STR_INP = 'Spectral segment info'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
  IF( VHL ) THEN
     NSEGS = 1 ;  WL_UNITS = 'nm'
  ELSE
     READ(STR_ARR(1)%S, *, ERR = 101) NSEGS
     WL_UNITS = CUT_STR(STR_ARR(2)%S)
  END IF
  SELECT CASE (WL_UNITS)
  CASE('nm')
  CASE('cm-1')
     IF(RET_FLAG) GOTO 226
  CASE DEFAULT
     CALL NOT_FOUND(R_NAME, STR_INP, WL_UNITS, *880)
  END SELECT
  CALL UPPER_LOWER_CASE (WL_UNITS ,'U2L')
  ALLOCATE(BAND_START(NSEGS), BAND_STEP(NSEGS), BAND_NUM(NSEGS)) ! A
  IF( VHL ) THEN ! Single wavelength only will be used for homogeneous layer model
     BAND_START = 500.d0 ; BAND_NUM = 1 ; BAND_STEP = 0.1d0
  ELSE
     DO I = 1, NSEGS
        CALL SPLIT_STRING(READ_ARR(I + 1)%S, STR_ARR )
        SCHEME = CUT_STR(STR_ARR(1)%S)
        STR_LOC = JOIN(STR_ARR, 2)
        READ(STR_LOC,*,ERR=101,END=208) PAR_1, PAR_2, PAR_3
        SELECT CASE (SCHEME)
        CASE ('1')
           BAND_START(I) = PAR_1
           BAND_NUM(I) = INT(PAR_2)
           BAND_STEP(I) = PAR_3
        CASE ('2')
           BAND_START(I) = PAR_1
           BAND_STEP(I) = PAR_3
           IF (BAND_STEP(I).LT.0.00000001) THEN
              BAND_NUM(I) = 1
              BAND_STEP(I) = 0.0D0
              CALL WRITE_MESSAGE(R_NAME, 'WARNING', 'Spectral stepsize zero '//&
                   'assumed -> one wavelength only')
           ELSE
              BAND_NUM(I) = FLOOR((PAR_2 - BAND_START(I))/BAND_STEP(I)) + 1
           ENDIF   
        CASE DEFAULT
           
           CALL NOT_FOUND(R_NAME, STR_INP, SCHEME, *880)
        END SELECT
     END DO
  END IF

  IF( ALIN_FLAG ) THEN
     WL_GRID_FLAG = .TRUE. ;  WL_DATA_FILE = DIR_PATH//WL_PATH ;  N_COL_WL = 1
  ELSE
     STR_INP = 'Wavelength grid from file'
     Call Read_OptCDF (STR_INP, 2, ReadStc, *880, Nlines=1)
     READ(ReadStc(1)%Arr(1)%S, *, ERR = 101) WL_GRID_FLAG
     IF(WL_GRID_FLAG) THEN
        WL_DATA_FILE = ReadStc(1)%Arr(2)%S 
        READ(ReadStc(1)%Arr(3)%S, *, ERR = 101) N_COL_WL
        IF(Size(ReadStc(1)%Arr) > 3) WL_CDF = ReadStc(1)%Arr(4)%S
     END IF
  END IF
  
!*************************************************************************
!************************ ESFT/Line-by-line ******************************
!*************************************************************************
  IF( ALIN_ACT(1) .OR. VHL ) THEN
     LINE_ABS_MODE = 'off'
  ELSE
     STR_INP = 'Line absorber treatment'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     LINE_ABS_MODE = CUT_STR(READ_ARR(1)%S)
  END IF
     
  HR_NSEG = 0
  IF( LINE_ABS_MODE /= 'off'.OR. &
       ANY(TG_INFO%M_TYPE == 'atom'.AND.TG_INFO%FM_FLG) )  THEN
     STR_INP = 'Select isotopes'
     CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange=.True.)
     Do II = 1, Size(READ_ARR)
        KK = FIND_IDX(READ_ARR(1)%S,TG_INFO%NAME)
        Read(READ_ARR(2)%S,*) I1
        Read(READ_ARR(3)%S,*) I2
        TG_INFO(KK)%IsoMin = Min(I1,I2)
        TG_INFO(KK)%IsoMax = Max(I1,I2)
     End Do
     
     STR_INP = 'Line absorber windows'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) LA_WINS
     IF(LA_WINS) THEN
        STR_INP = 'Spectral windows for line absorbers'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        HR_NSEG = SIZE(READ_ARR)
        ALLOCATE(HR_SEG_WL(2,HR_NSEG))
        DO K = 1, HR_NSEG
           READ(READ_ARR(K)%S, *, ERR = 101) HR_SEG_WL(1,K), HR_SEG_WL(2,K)
        END DO
     END IF

     STR_INP = 'Longest wavelength for cross sections'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     CALL SPLIT_STRING(READ_ARR(2)%S, STR_ARR_1 )
     DO J = 1, SIZE(STR_ARR)
        CALL UPPER_LOWER_CASE(STR_ARR(J)%S,'U2L')
        KK = FIND_IDX(STR_ARR(J)%S,TG_INFO%NAME)
        READ( STR_ARR_1(J)%S,* ) TG_INFO(KK)%MAX_WL_CS
     ENDDO

     STR_INP = 'Shortest wavelength to account for the stimulated emission'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) StEm_MaxWn
     StEm_MaxWn = 1.0E+7/StEm_MaxWn ! Conversion from nm to cm-1
     STR_INP = 'Optimized spectral line summation'
     CALL Read_Input (STR_INP, READ_ARR, *880, ReArrange = .True., ULC = "L")
     Str = CUT_STR(READ_ARR(1)%S)
     Select Case (Str)
     Case ("off")
        OptLineSum = .False.
     Case ("on")
        OptLineSum = .True.
        READ(READ_ARR(2)%S, *, ERR = 101) LineSumAcc
     Case Default
        CALL NOT_FOUND(R_NAME, STR_INP, Str, *880)
     End Select
  ELSE
     LA_WINS = .FALSE.
     HR_NSEG = 0
     TG_INFO(:)%MAX_WL_CS = 1.0D+10
  END IF

  SELECT CASE (LINE_ABS_MODE)
  CASE('esft')
     DO_ESFT = .TRUE. ;  DO_LBL  = .FALSE.
     STR_INP = 'Path to ESFT data base'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     ESFT_DB_PATH = SET_PATH(READ_ARR(1)%S)
     STR_INP = 'Do esft anti correlation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) DO_ESFT_ANTI_CORRELATION

  CASE('lbl')
     DO_LBL = .TRUE. ;  DO_ESFT = .FALSE.
     STR_INP = 'Path to the line parameter database'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     HITRAN_DIR = SET_PATH(READ_ARR(1)%S)
     STR_INP = 'Line wing cut-off wavenumber'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) LBL_WING_CUTOFF
     STR_INP = 'Use tables for lbl'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) table_use_table

     table_input_cnt = 0
     if(table_use_table) then
        STR_INP = 'Files for tables'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        table_input_cnt = size(READ_ARR)
        allocate(table_input_desc(table_input_cnt))
        do i=1, table_input_cnt
           table_input_desc(i) = SET_PATH(READ_ARR(I)%S)
        end do
     end if

  CASE('off')
     DO_ESFT = .FALSE. ;  DO_LBL  = .FALSE.

  CASE DEFAULT
     CALL NOT_FOUND (R_NAME, STR_INP, LINE_ABS_MODE, *880)
     RETURN 1
  END SELECT

!*************************************************************************
!********************* Collision-induced absorption **********************
!*************************************************************************
  CALL CIA_INIT
  STR_INP = 'Collision-induced absorption'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  CIA: Block
    IF(SIZE(READ_ARR) == 0) EXIT CIA
    CALL FIND_MATCHES(*880, READ_ARR(1)%S, CIA_INFO%Name, CIA_INFO%Flg)
    IF(.NOT.ANY(CIA_INFO%Flg)) EXIT CIA
    
    CIA_VMR_MODE(:) = 'D'
    STR_INP = 'Mixing ratios for CIA species'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    DO I = 1, SIZE(READ_ARR)
       CALL SPLIT_STRING(READ_ARR(I)%S, STR_ARR)
       GAS_NAME = CUT_STR(STR_ARR(1)%S)
       PAR_STRING = CUT_STR(STR_ARR(2)%S)
       CALL FIND_MATCHES(*880, GAS_NAME, CIA_GAS, TMP_FLG)
       CALL UPPER_LOWER_CASE (PAR_STRING,'U2L')
       IF(TRIM(PAR_STRING) == 'file') THEN
          WHERE(TMP_FLG) CIA_VMR_MODE(:) = 'F'
       ELSE
          READ(PAR_STRING,*,ERR=101) VMR_VAL
          WHERE(TMP_FLG) 
             CIA_VMR_MODE(:) = 'V'
             CIA_VMR_VAL(:)  = VMR_VAL
          END WHERE
       END IF
    END DO
    
    KK = FIND_IDX('o2',TG_INFO%NAME)
    IF(CIA_VMR_MODE(2) == 'F') TG_INFO(KK)%READ_FLG = .TRUE.
    KK = FIND_IDX('co2',TG_INFO%NAME)
    IF(CIA_VMR_MODE(3) == 'F') TG_INFO(KK)%READ_FLG  = .TRUE.
    
    IF(CIA_VMR_MODE(1) == 'F') THEN
       CALL WRITE_MESSAGE(R_NAME,'ERROR','No climatological data '&
            //'base is available for N2')
       RETURN 1
    END IF
    II = FIND_IDX('o4',TG_INFO%NAME)
    IF(CIA_INFO(2)%Flg.AND.TG_INFO(II)%FM_FLG) THEN
       CALL WRITE_MESSAGE(R_NAME,'ERROR','Collision induced '&
            //'absorbtion cross sections for O2-O2 must not be'&
            //'used together with O4 absorber')
       RETURN 1
    END IF
    
    STR_INP = 'Account for N2-air collisions'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101)  N2_Air_Corr
    
    STR_INP = 'Path to CIA data base'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CIA_DIR = SET_PATH(READ_ARR(1)%S)
  END Block CIA
 
!*************************************************************************
!********************** Slit function convolution ************************
!*************************************************************************
  STR_INP = 'Do convolution'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S, *, ERR = 101)  CONVOL_FLAG
  IF( VHL ) CONVOL_FLAG = .FALSE.

  Call SRF_Init(CONVOL_FLAG, *880)
     
  IF(CONVOL_FLAG) THEN
     STR_INP = 'Convolution for line absorber only'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101)  CONVOL_LA_ONLY
     
     IF(DO_ESFT.OR.LA_WINS) THEN
        CONVOL_ALL = .NOT.CONVOL_LA_ONLY
     ELSE
        CONVOL_ALL = .TRUE.
     END IF

     STR_INP = 'Internal wavelength step'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) STEP_INP
  ELSE
     CONVOL_ALL = .FALSE.
     STEP_INP = MINVAL(BAND_STEP(1:NSEGS))
  END IF

!*************************************************************************
!************************* Date and geolocation **************************
!*************************************************************************
  STR_INP = 'Date'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  DATE_MODE = CUT_STR(READ_ARR(1)%S)

  SELECT CASE (DATE_MODE)
  CASE('DMY')
     STG = CUT_STR(READ_ARR(2)%S)
     IF (LEN_TRIM(STG) /= 10) GOTO 202
     DAY = IACHAR(STG(1:1))*10 + IACHAR(STG(2:2)) - 528
     MONTH = IACHAR(STG(4:4))*10 + IACHAR(STG(5:5)) - 528
     YEAR = IACHAR(STG(7:7))*1000 + IACHAR(STG(8:8))*100 + &
          IACHAR(STG(9:9))*10 +  IACHAR(STG(10:10)) - 53328
     CALL DMT_TO_DOY(DAY, MONTH, YEAR, DAY_OF_YEAR)

  CASE('DOY')
     READ(READ_ARR(2)%S, *, ERR = 201) DAY_OF_YEAR, YEAR
  CASE DEFAULT
     GOTO 203
  END SELECT

  STR_INP = 'Latitude & longitude'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S, *, ERR = 101) LATITUDE, LONGITUDE

!*************************************************************************
!************************ Aerosol settings *******************************
!*************************************************************************
  EXA_FLG = .FALSE. ;  ECSTRA_FLAG = .FALSE. ;    Bi_PSD = .FALSE.
  Dwr_mi = .FALSE. ;  N_Dwr = 0 ; Plus_mi = .FALSE. ; MAX_AER_WF = 2
  OUT_A_SCM = .FALSE. ;  N_AOT = 0 ;  APH_TYPE = 'none'
  AER_FACT = 1.d0 ;  ZS1 = -1.d0 ;  ZS2 = -1.d0 ;  V_PAP = 1.d0
  AER_PAR_TYPE = 'none'
  
  AEROSOL_INIT: Block
    IF( VHL ) THEN
       AER_TOP = 'from sea level' ;  AER_ADD_LEV = .FALSE.
       AER_PARAM = 'advanced' ;  AER_PAR_TYPE = 'mn' ;  AER_SCALING = 1.d0 ;
       L_scal = .FALSE. ; Scal_aer = .FALSE. ;  LAY_A = 1 ; WEL_A = 1
       DO_AEROSOL = .TRUE. ;  AER_TRUNC_IDX = NLEGEN - 1
       EXIT AEROSOL_INIT
    END IF
  
    IF( TES_2L_SLAB ) THEN
       DO_AEROSOL = .FALSE.
       EXIT AEROSOL_INIT
    END IF

    ! Input of aerosol parameters
    STR_INP = 'Aerosol settings'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    AER_PARAM = CUT_STR(READ_ARR(1)%S)
    SELECT CASE( TRIM(AER_PARAM) )
    CASE('off')
       DO_AEROSOL = .FALSE. ; AER_PAR_TYPE = 'none'
    CASE('advanced','default')
       DO_AEROSOL = .TRUE. ; Rm_log = .TRUE.
    CASE DEFAULT
       CALL NOT_FOUND (R_NAME, STR_INP, AER_PARAM, *880)
    END SELECT

    IF( ALIN_ACT(3) ) DO_AEROSOL = .TRUE.
    
    IF( .NOT.DO_AEROSOL ) EXIT AEROSOL_INIT
    
    IF( AER_PARAM /= 'default' ) THEN
       STR_INP = 'Aerosol parameterization type'
       CALL Read_Input (STR_INP, READ_ARR, *880)
       AER_PAR_TYPE = CUT_STR(READ_ARR(1)%S)
       SELECT CASE (AER_PAR_TYPE)
       CASE('mn','pao')
          IF( AER_PAR_TYPE=='mn' ) THEN
             STR_INP = 'Aerosol as a cloud layer?'
          ELSE
             STR_INP = 'PAO aerosol as a cloud layer?'
          ENDIF
          CALL Read_Input (STR_INP, READ_ARR, *880)
          CC_INP = CUT_STR(READ_ARR(1)%S)
          SELECT CASE( CC_INP )
          CASE('no')    ;  SHARP_EDGES = .FALSE.
          CASE('yes')   ;  SHARP_EDGES = .TRUE.
          CASE DEFAULT
             CALL NOT_FOUND (R_NAME, STR_INP, CC_INP, *880)
          END SELECT
       CASE('aeronet')
          STR_INP = 'Directory name of input AERONET parameters'
          CALL Read_Input (STR_INP, READ_ARR, *880)
          PATH_AER_DB = SET_PATH(READ_ARR(1)%S)          
       CASE DEFAULT
          STR_INP = 'Path to aerosol data base'
          CALL Read_Input (STR_INP, READ_ARR, *880)
          PATH_AER_DB = SET_PATH(READ_ARR(1)%S)
       END SELECT
!    ELSE
!       STR_INP = 'Path to aerosol data base'
!       CALL Read_Input (STR_INP, READ_ARR, *880)
!       PATH_AER_DB = SET_PATH(READ_ARR(1)%S)
    END IF
    
    ! Default aerosol settings
    IF( AER_PARAM == 'default' ) THEN
       AER_SHIFT = .FALSE. ;  COMPAT_MODE  = .FALSE.
       SELECT CASE (Vec_Sca)
       CASE('scal_rte')
          AER_PAR_TYPE = 'lt' ;  APH_TYPE = 'h-g'
       CASE('vect_rte')
          AER_PAR_TYPE = 'wm' ;  APH_TYPE = 'mie'
       END SELECT
       PATH_AER_DB = '~/DATA_BASES/AEROSOLS'
       PATH_AER_DB = SET_PATH(PATH_AER_DB)
       AER_SCALING = 1.d0    ; Scal_aer = .FALSE. ;  NOWL_AER = 0
       AER_ADD_LEV = .FALSE. ; L_scal = .FALSE.
       S_N_D       = 'OFF'
    END IF
    
    SELECT CASE (RTM_CORE)
    CASE('CDI', 'VOD', "TRN")
       AER_DM_FLG = .FALSE.
    CASE DEFAULT
       IF( SCATT_MODE =='ss' ) Then
          AER_DM_FLG = .FALSE.
       Else
          AER_DM_FLG = .TRUE.
       End If
       D_MF_AER = 'D-MA'
       AER_TRUNC_IDX = NLEGEN - 1
    END SELECT
      
    IF(AER_PAR_TYPE /= 'mn') THEN
       SELECT CASE (AER_PAR_TYPE)
       CASE('st','st_mi')
          PATH_AER_DB = PATH_AER_DB//'/SCIA/'
       CASE('lt','lt_mi')
          PATH_AER_DB = PATH_AER_DB//'/LT/'
       CASE('wm','wm_mi')
          PATH_AER_DB = PATH_AER_DB//'/WMO/'
       CASE('merra','xb_merra')
          PATH_AER_DB = PATH_AER_DB//'/MERRA/'
          STR_INP  = 'RT altitude grid (MERRA)'
          CALL Read_Input (STR_INP, READ_ARR, *880)
          RT_AG = CUT_STR(READ_ARR(1)%S)
          SELECT CASE( RT_AG )
          CASE('merra', 'user')
          CASE DEFAULT
             CALL NotFound(R_NAME, STR_INP, RT_AG, *880)
          END SELECT
       CASE('mod-o')
          PATH_AER_DB = PATH_AER_DB//'/MODIS_OC/'
       CASE('mi','mod-l','mod-m','pao','aeronet')
       CASE DEFAULT
          CALL NOT_FOUND (R_NAME, AER_PAR_TYPE, AER_PAR_TYPE, *880)
       END SELECT
    END IF
    
    IF( AER_PARAM == 'default' ) EXIT AEROSOL_INIT
    
    STR_INP = 'Top of aerosol layers'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    AER_TOP = CUT_STR(READ_ARR(1)%S)
    SELECT CASE (AER_TOP)
    CASE('from sea level')
       AER_SHIFT = .FALSE. ; COMPAT_MODE  = .FALSE.
    CASE('from local surface')
       AER_SHIFT = .TRUE. ; COMPAT_MODE  = .FALSE.
    CASE('compatibility')
       AER_SHIFT = .FALSE. ; COMPAT_MODE  = .TRUE.
    CASE DEFAULT
       CALL NOT_FOUND (R_NAME, STR_INP, AER_TOP, *880)
    END SELECT

    IF( RT_AG=='merra' ) AER_SHIFT = .FALSE. 
    
    STR_INP = 'Add level at boudary layer top'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) AER_ADD_LEV

    STR_INP = 'Extinction coefficient wavelength interpolation technique'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    SELECT CASE( READ_ARR(1)%S )
    CASE('Linear')    ;  Aer_ext_lin = .TRUE.
    CASE('Angstrom')  ;  Aer_ext_lin = .FALSE.
    CASE DEFAULT
       CALL NOT_FOUND (R_NAME, STR_INP, READ_ARR(1)%S, *880)
    END SELECT

    STR_INP = 'Aerosol scaling parameter'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) AER_SCALING

    ! This is an alternative version to "Aerosol scaling parameter"
    STR_INP = 'Aerosol scaling factor'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
    READ(STR_ARR(1)%S, *, ERR = 101) L_scal
    IF( L_scal ) THEN
       READ(STR_ARR(2)%S,*,ERR=101) AER_FACT
       READ(STR_ARR(3)%S,*,ERR=101) V_PAP
       READ(STR_ARR(4)%S,*,ERR=101) ZS1
       READ(STR_ARR(5)%S,*,ERR=101) ZS2
    END IF

    SELECT CASE (AER_PAR_TYPE)
    CASE('mod-l','mod-m')
       IF( AER_SCALING /= 1.d0 ) GOTO 234
    END SELECT

    STR_INP = 'Aerosol OT at reference wavelength'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
    READ(STR_ARR(1)%S, *, ERR = 101) Scal_aer
    IF( Scal_aer ) THEN
       READ(STR_ARR(2)%S,*,ERR=101) Rtau_aer
       READ(STR_ARR(3)%S,*,ERR=101) Rwl_aer
       ! Multiple aerosol OT
       STR_INP = 'Additional aerosol OT'
       CALL Read_Input (STR_INP, READ_ARR, *880)
       CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
       READ(STR_ARR(1)%S, *, ERR = 101) N_AOT
       IF( N_AOT > 0 ) THEN
          ALLOCATE( ADD_OT(N_AOT),AOT_MAL(N_AOT) )
          DO II = 1, N_AOT
             READ(STR_ARR(II + 1)%S, *, ERR = 101) ADD_OT(II)
             IF(II == 1) THEN
                AOT_MAL(II) = ADD_OT(II)/Rtau_aer
             ELSE
                AOT_MAL(II) = ADD_OT(II)/ADD_OT(II - 1)
             END IF
          END DO
       ENDIF
    ENDIF

    STR_INP = 'Use reference extinction coefficient profile'
    Call Read_OptCDF (STR_INP, 5, ReadStc, *880)
    If(Allocated(READ_ARR)) Then
       CALL SPLIT_STRING(ReadStc(1)%Arr(1)%S, STR_ARR)
       S_N_D = CUT_STR(ReadStc(1)%Arr(1)%S)
       CALL UPPER_LOWER_CASE (S_N_D,'L2U')
       AER_CDF = ''
       SELECT CASE (S_N_D)
       CASE ('SCIA_3D', 'FILE')
          READ(ReadStc(1)%Arr(2)%S,*,ERR=101) SND_WL
          READ(ReadStc(1)%Arr(3)%S,*,ERR=101) AER_ZMIN
          READ(ReadStc(1)%Arr(4)%S,*,ERR=101) AER_ZMAX
          SND_NAME = ReadStc(1)%Arr(5)%S
          IF(Size(ReadStc(1)%Arr) > 5) AER_CDF = ReadStc(1)%Arr(6)%S
          IF(S_N_D == 'SCIA_3D') Call Scia_Aer_ExC (.False., *880)
       END SELECT
    End If
    
    STR_INP = 'Use ECSTRA model'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
    READ(STR_ARR(1)%S, *, ERR = 101) ECSTRA_FLAG
    IF( ECSTRA_FLAG ) THEN
       READ(STR_ARR(2)%S, *, ERR = 101) ECSTRA_DM
       STR_INP = 'Path to the tropopause height database'
       CALL Read_Input (STR_INP, READ_ARR, *880)
       TPH_DB_PATH = SET_PATH(READ_ARR(1)%S)
    END IF
    STR_INP = 'Replace aerosol extinction'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
    READ(STR_ARR(1)%S, *, ERR = 101) EXA_FLG
    IF( EXA_FLG ) EXA_NAME = SET_PATH(STR_ARR(2)%S)

    STR_INP = 'Aerosol scattering matrix output'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) OUT_A_SCM
    IF( OUT_A_SCM ) THEN
       READ(READ_ARR(2)%S, *, ERR = 101) LAY_A, WEL_A, NSCA_A, GE_A
       PATH_TO_SCM = SET_PATH(READ_ARR(3)%S)
    ELSE
      PATH_TO_SCM = './' 
    ENDIF
    
    ! MODIS aerosol parameterization will be used
    MODIS_LO = 'non'
    IF(INDEX(AER_PAR_TYPE,'mod') /= 0) THEN
       MODIS_AP = .TRUE. ;  Bi_PSD = .TRUE.
       SELECT CASE( AER_PAR_TYPE )
       CASE('mod-l') 
          MODIS_LO = 'land'; M_AC = 4
       CASE('mod-o')
          MODIS_LO = 'ocean'; M_AC = 2
        CASE('mod-m')
          MODIS_LO = 'man'; M_AC = 2
       END SELECT
    ENDIF
    
    IF(INDEX(AER_PAR_TYPE,'mi') > 1) Plus_mi = .TRUE.
    
    STR_INP = 'Use Henyey-Greenstein parameterization of scattering function?'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    HGI = CUT_STR(READ_ARR(1)%S)
    SELECT CASE( HGI )
    CASE('yes')
       APH_TYPE = 'h-g'
    CASE('no')
       APH_TYPE = 'mie'
    CASE DEFAULT
       CALL NOT_FOUND (R_NAME, STR_INP, HGI, *880)
    END SELECT
    
    STR_INP = 'Output of aerosol OT'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
    READ(STR_ARR(1)%S, *, ERR = 101) NOWL_AER
    IF( NOWL_AER > 0 ) THEN
       ALLOCATE( OWL_AER(NOWL_AER) )
       DO II = 1, NOWL_AER
          READ(STR_ARR(II + 1)%S, *, ERR = 101) OWL_AER(II)
       END DO
    ENDIF
    
    IF(INDEX(AER_PAR_TYPE,'mi') == 0) EXIT AEROSOL_INIT
    
    STR_INP = 'Use bimodal'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101)  Bi_PSD
    
    ! Define maximal number of aerosol components in the case of "mi"-mode
    STR_INP = 'Mie aerosol layers'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    CALL SPLIT_STRING (READ_ARR(1)%S, STR_ARR)
    LAN = SIZE(STR_ARR) - 1
    STR_INP = 'Aerosol type definition (Mie)'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    KK = 2 ;  M_AC = 0
    DO I = 1, LAN
       !  Read number of aerosol components for each layer
       READ(READ_ARR(KK)%S,*) NAC
       IF (NAC > M_AC) M_AC = NAC
       KK = KK + NAC + 2
    END DO  ! over aerosol layers (I)
  END Block AEROSOL_INIT

!*************************************************************************
!************************ Clouds *****************************************
!*************************************************************************
  CALL GT_CLOUD_INPUT(.FALSE., *880)

!!*************************************************************************
!!************************ WEIGHTING FUNCTIONS ****************************
!!*************************************************************************
!  IF(WF_FLAG .OR. RTM_MODE == 'num_pert') WF_READ = .TRUE.
!
!  !! Check after
!  !  Use_der = .TRUE.
!
!  ! Initialization for the weighting functions in the ocean (needed even
!  ! if the weigthing functions are turned off)
!  IF(ALLOCATED(OWF_FLG_ARR)) DeAllocate(OWF_FLG_ARR)
!  ALLOCATE(OWF_FLG_ARR(N_OWF_GEN)) ! A
!  OWF_FLG_ARR(:) = .FALSE.
!  OWF_Chl => OWF_FLG_ARR(1)
!  OWF_Ray => OWF_FLG_ARR(2) ;  OWF_Use => OWF_FLG_ARR(3)
!  OWF_Ks  => OWF_FLG_ARR(4) ;  OWF_Kl  => OWF_FLG_ARR(5)
!
!  IF( WF_READ ) CALL READ_RTM_WF (*880)
!      
!*************************************************************************
!************************ Surface settings *******************************
!*************************************************************************
  ALBEDO_const = 0.d0 ;  DO_SPECTRAL_ALBEDO = .FALSE. ;  BRDF_FLAG = .FALSE.

  IF( UWT .OR. RTM_CORE == 'VOD' ) THEN
     ! SR_TYPE does not impact the radiative transfer in
     ! the case of the coupled ocean-atmosphere and option "vod"
     ! Therefore, it is set to "alb_const" to avoid possible 
     ! initialization errors.
     SR_TYPE = 'alb_const'
  ELSE     
     STR_INP = 'Surface reflection type'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     SR_TYPE = CUT_STR(READ_ARR(1)%S)
  END IF

  SELECT CASE( TRIM(SR_TYPE) )
  CASE('alb_const')
     STR_INP = 'Albedo'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) ALBEDO_const
     IF(ALBEDO_const < 0.0D0 .OR. ALBEDO_const > 1.0D0) GOTO 222

  CASE('alb_spec')
     DO_SPECTRAL_ALBEDO = .TRUE.
     STR_INP = 'Path to the albedo database'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     ALBEDO_DB_PATH = SET_PATH(READ_ARR(1)%S)
     STR_INP = 'Spectral albedo filename'
     Call Read_OptCDF (STR_INP, 1, ReadStc, *880, Nlines=1)
     ALBEDO_FILENAME = ReadStc(1)%Arr(1)%S
     IF (SIZE(ReadStc(1)%Arr) > 1) THEN
        READ(ReadStc(1)%Arr(2)%S, *, ERR = 101) Nc_ALB
     ELSE
        Nc_ALB = 1
     END IF
     IF(Size(ReadStc(1)%Arr) > 2) Then
        ALB_CDF = ReadStc(1)%Arr(3)%S
     Else
        ALB_CDF = '' 
        ALBEDO_FILENAME = ALBEDO_DB_PATH//ALBEDO_FILENAME
     End If
     ALLOCATE( ALB_WEI(10,Nc_ALB) ) ! A
     IF( Nc_ALB > 1 ) THEN
        STR_INP = 'Weights of albedo components'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S,*,ERR=101) (ALB_WEI(1,K), K=1,Nc_ALB)
        DO K = 1,Nc_ALB
           ALB_WEI(2:10,K) = ALB_WEI(1,K)
        ENDDO
     ELSE
        ALB_WEI(:,1) = 1.d0
     ENDIF

     ! Spectral albedo is given as linear combination of A and B
     ! spectral coefficients
     INF_ALB(:) = 0
     IF( Nc_ALB == 2 ) THEN
        STR_INP = 'Convert ratio to albedo'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S,*,ERR=101) (INF_ALB(K), K=1,3)            
     ENDIF

  CASE('alb_db_mts')
     STR_INP = 'Path to the albedo database'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     ALBEDO_DB_PATH = SET_PATH(READ_ARR(1)%S)
     ALBEDO_MTS = MATTHEWS_ALBEDO(LATITUDE,LONGITUDE,DAY_OF_YEAR)
     SR_TYPE = 'alb_const'
     IF (ALBEDO_MTS.LT.1.0D-4) THEN
        STR_INP = 'Replacement for water'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        READ(STR_ARR(1)%S,'(L1)',ERR = 101) REPL_FLAG
        IF(REPL_FLAG) THEN
           READ(STR_ARR(2)%S,*,ERR = 333) ALBEDO_MTS
           GOTO 334
333        ALBEDO_FILENAME = CUT_STR(STR_ARR(2)%S)
           SR_TYPE = 'alb_spec'
334        CONTINUE
        END IF
     ENDIF
     ALBEDO_const = ALBEDO_MTS
  CASE('brdf')
     BRDF_FLAG = .TRUE.
  CASE DEFAULT
     CALL NOT_FOUND (R_NAME, STR_INP, SR_TYPE, *880)
  END SELECT

! Input data for BRDF of a surface will be used from
! the input file "control_brdf.inp"
  IF( BRDF_FLAG ) THEN
     CALL READ_BRDF(*880)
  ELSE
! Internal dimension for BRDF arrays
     Ng1_brf = 1 ; Ng2_brf = 1 ; Ns_brf  = 1 ; Nh_brf = 1
  END IF

!*************************************************************************
!************************ WEIGHTING FUNCTIONS ****************************
!*************************************************************************
  IF(WF_FLAG .OR. RTM_MODE == 'num_pert') WF_READ = .TRUE.

  !! Check after
  !  Use_der = .TRUE.

  ! Initialization for the weighting functions in the ocean (needed even
  ! if the weigthing functions are turned off)
  IF(ALLOCATED(OWF_FLG_ARR)) DeAllocate(OWF_FLG_ARR)
  ALLOCATE(OWF_FLG_ARR(N_OWF_GEN)) ! A
  OWF_FLG_ARR(:) = .FALSE.
  OWF_Chl => OWF_FLG_ARR(1)
  OWF_Ray => OWF_FLG_ARR(2) ;  OWF_Use => OWF_FLG_ARR(3)
  OWF_Ks  => OWF_FLG_ARR(4) ;  OWF_Kl  => OWF_FLG_ARR(5)

  IF( WF_READ ) CALL READ_RTM_WF (*880)

!*************************************************************************
!************************ Height grid settings ***************************
!*************************************************************************
  Nz_LEV = 0
  IF( VHL ) THEN
     !NET_NAME = SET_PATH('~/DATA_BASES/HEIGHT_GRIDS/NET_0-1.VHL')
     NET_NAME = ""
     GROUND_HEIGHT = 0.0d0
  ELSE
     IF( ALIN_FLAG ) THEN
        NET_NAME = DIR_PATH//ALT_PATH
     ELSE
        STR_INP = 'Altitude grid'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        IF( SIZE(STR_ARR) == 1 ) THEN
            NET_NAME = SET_PATH(READ_ARR(1)%S)
        ELSE
           Nz_LEV = SIZE(STR_ARR)
           IF(ALLOCATED(Z_LEV)) DeAllocate (Z_LEV)
           ALLOCATE(Z_LEV(Nz_LEV))
           READ(READ_ARR(1)%S,*,ERR=101) (Z_LEV(K),K=1,Nz_LEV)
           IF(Size(READ_ARR) > 1) Then
              ALLOCATE(Zl_STEP(Nz_LEV-1))
              READ(READ_ARR(2)%S,*,ERR=101) (Zl_STEP(K),K=1,Nz_LEV-1)
           End If
        ENDIF
     ENDIF
     STR_INP = 'Height above sea level'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) GROUND_HEIGHT
  ENDIF

!*************************************************************************
!************************ Profile information ****************************
!*************************************************************************
  IF( VHL ) THEN
     ADV_PROF = .FALSE.
  ELSE
     STR_INP = 'Advanced profile settings'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) ADV_PROF
  END IF
      
  IF( ANY((TG_INFO%M_TYPE == 'atom').AND.TG_INFO%FM_FLG) ) THEN
     IF( .NOT.ADV_PROF)  GOTO 229
  ENDIF

  IF( ADV_PROF ) THEN
     STR_INP = 'Trace gas replacement profiles'
     Call Read_OptCDF (STR_INP, 1, ReadStc, *880, NSkip = 1)
     READ(ReadStc(1)%Arr(1)%S, *, ERR = 101) N_REPL
     if(SIZE(ReadStc) <  N_REPL + 1) GOTO 102
     ALLOCATE(PROF_FILES(N_REPL + 2), PROF_CDF(N_REPL + 2)) ! A
     FORALL(II = 1:SIZE(PROF_CDF)) PROF_CDF(II)%S = ''
     IF(N_REPL > 0) THEN
        ALLOCATE(PROF_LABELS(N_REPL), PROF_UNITS(N_REPL), & ! A
             PROF_NCZ(N_REPL), PROF_NCV(N_REPL)) ! A
        DO I = 1,N_REPL
           PROF_FILES(I + 2) = ReadStc(I + 1)%Arr(1)%S
           PROF_LABELS(I)%S = CUT_STR(ReadStc(I + 1)%Arr(2)%S)
           PROF_UNITS(I)%S = CUT_STR(ReadStc(I + 1)%Arr(3)%S)
           READ(ReadStc(I + 1)%Arr(4)%S, *, ERR = 101) PROF_NCZ(I)
           READ(ReadStc(I + 1)%Arr(5)%S, *, ERR = 101) PROF_NCV(I)
           IF(Size(ReadStc(I + 1)%Arr) > 5) &
                PROF_CDF(I + 2)%S = ReadStc(I + 1)%Arr(6)%S
        End Do
     END IF
  ELSE
     N_REPL = 0
     ALLOCATE(PROF_FILES(2)) ! A
  END IF
  
  STR_INP = 'Standard profile scenario file name'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  PROF_FILES(1) = SET_PATH(READ_ARR(1)%S)
  STR_INP = 'Standard profile scenario for line absorbers'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  PROF_FILES(2) = SET_PATH(READ_ARR(1)%S)
 
! Advanced gaseous absorber profile settings
! ------------------------------------------
  DO_PROFILES_AKIMA  = .FALSE. ;  DO_PT_MPI_PROFILE = .TRUE.
  DO_SCA_PRE = .FALSE. ;  DO_SCA_O3 = .FALSE. ;  DO_SCA_H2O = .FALSE.
  BRO_MIPAS_FLAG = .FALSE. ;  CLIM_LABEL = 'NONE' ;  SOUT_FLAG = .FALSE.

  IF( ADV_PROF ) THEN
     STR_INP = 'Do profiles akima interpolation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) DO_PROFILES_AKIMA

     STR_INP = 'Do P and T from standard profile file'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) DO_PT_MPI_PROFILE
     PT_CDF = '' 
     IF(.NOT.DO_PT_MPI_PROFILE) THEN
        STR_INP = 'Pressure and temperature file name'
        Call Read_OptCDF (STR_INP, 1, ReadStc, *880, Nlines=1)
        PT_FILENAME = ReadStc(1)%Arr(1)%S
        READ(ReadStc(1)%Arr(2)%S, *, ERR = 101) NC_PTZ
        READ(ReadStc(1)%Arr(3)%S, *, ERR = 101) NC_P
        READ(ReadStc(1)%Arr(4)%S, *, ERR = 101) NC_T
        IF(Size(ReadStc(1)%Arr) > 4) PT_CDF = ReadStc(1)%Arr(5)%S
     END IF

     STR_INP = 'Use CIRA model'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
     READ(STR_ARR(1)%S, '(L1)',ERR = 101) CIRA_FLG
     IF(CIRA_FLG) THEN
        IF(SIZE(STR_ARR) < 3) GOTO 102
        CIRA_DIR = SET_PATH(STR_ARR(2)%S)
        READ(STR_ARR(3)%S, *,ERR = 101) CIRA_ZMIN
     END IF
         
     ! *****************************************************************
     ! ********  Scaling of P(z), O3(z), and H2O(z)   ******************
     ! *****************************************************************
     STR_INP = 'Pressure profile scaling'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) DO_SCA_PRE, SCA_PRE
     STR_INP = 'Ozone profile scaling'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) DO_SCA_O3
     STR_INP = 'Water vapor profile scaling'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) DO_SCA_H2O, SCA_H2O
     STR_INP = 'NO2 profile scaling'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR = 101) DO_SCA_NO2, SCA_NO2

     ! *****************************************************************
     ! *************** MIPAS BrO climatology ***************************
     ! *****************************************************************
     IF(CHK_STAT('bro',TG_INFO%NAME,TG_INFO%FM_FLG)) THEN
        STR_INP = 'BrO climatology'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) BRO_MIPAS_FLAG
        
        IF(BRO_MIPAS_FLAG) THEN
           STR_INP = 'BrO climatology file'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           BRO_MIPAS_FILE = SET_PATH(READ_ARR(1)%S)
        END IF
     END IF

     ! *****************************************************************
     ! ******** Parameters of atoms and ions vertical profiles *********
     ! *****************************************************************
     DO II = 1, SIZE(TG_INFO)
        IF(TG_INFO(II)%M_TYPE /= 'atom' .OR. .NOT.TG_INFO(II)%FM_FLG) CYCLE
        STR_LOC = TG_INFO(II)%NAME
        CALL UPPER_LOWER_CASE (STR_LOC,'L2U',1,1)
        ALLOCATE( TG_INFO(II)%GVPP(3) )
        STR_INP = 'Parameters for '//STR_LOC
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S,*,ERR = 101) (TG_INFO(II)%GVPP(I), I = 1,3)
     END DO

     ! *****************************************************************
     ! **************** Ozone climatologies ****************************
     ! *****************************************************************
     O3_Clim: Block 
       CLIM_LABEL = 'NONE'
       IF(.NOT.CHK_STAT('o3',TG_INFO%NAME,TG_INFO%FM_FLG)) EXIT O3_Clim

       STR_INP = 'Ozone climatology'
       CALL Read_Input (STR_INP, READ_ARR, *880)
       IF(SIZE(READ_ARR) == 0) EXIT O3_Clim
       CLIM_LABEL = CUT_STR(READ_ARR(1)%S)
       CALL UPPER_LOWER_CASE (CLIM_LABEL,'L2U')
       
       SELECT CASE (CLIM_LABEL)
       CASE ('NONE')
       CASE ('KNMI','TOMS_M','UGAMP')
          STR_INP = 'Path to ozone climatology'
          CALL Read_Input (STR_INP, READ_ARR, *880)
          CLIM_PATH = SET_PATH(READ_ARR(1)%S)
       CASE ('TOMS_V7', 'TOMS_V8', 'IUP_BREMEN','IUP_2018')
          STR_INP = 'Path to ozone climatology'
          CALL Read_Input (STR_INP, READ_ARR, *880)
          CLIM_PATH = SET_PATH(READ_ARR(1)%S)
          DO_SCA_O3 = .TRUE.
       CASE DEFAULT
          CALL NOT_FOUND (R_NAME, STR_INP, CLIM_LABEL, *880)    
       END SELECT
     END Block O3_Clim

     If(DO_SCA_O3) THEN
        STR_INP = 'Ozone total column'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) O3_TOTAL_COLUMN
     END IF
 
  END IF
  
!*************************************************************************
!************** Photochemistry (in spherical geometry only) **************
!*************************************************************************
  Photo_chem: Block 
    DO_PC = .FALSE. ;  DO_PHOTOCHEM = .FALSE.
    IF( VHL ) EXIT Photo_chem

    STR_INP = 'Photochemical calculations'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) DO_PC
    IF(.NOT.DO_PC) EXIT Photo_chem

   ! Input data for the photochemical calculations will be used from
   ! the input file "control_pas.inp"
    SELECT CASE (RTM_CORE)
    CASE('CDI','VOD')
    CASE DEFAULT
       GOTO 209
    END SELECT
   
    STR_INP = 'Number of photochemically active species'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    READ(READ_ARR(1)%S, *, ERR = 101) N_PC_INP
    
    ALLOCATE(GAS_LABELS_PC(N_PC_INP), GAS_IDX_PC(N_PC_INP), &!A
         ALT_GRID_NAME_PC(N_PC_INP), PROFILE_NAME_PC(N_PC_INP), &! A
         DO_TROP(N_PC_INP), CONST_PROF(N_PC_INP)) !A
    STR_INP = 'Trace gas selection - photochemistry'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    DO I = 1,N_PC_INP
       GAS_LABELS_PC(I) = CUT_STR(READ_ARR(I)%S)
    END DO
    
    DO I = 1, N_PC_INP
       CALL FIND_GAS (GAS_LABELS_PC(I), GAS_IDX_PC(I), *880)
       IF(TG_INFO(GAS_IDX_PC(I))%FM_FLG) &
            DO_PHOTOCHEM(GAS_IDX_PC(I)) = .TRUE.
    END DO
    
    STR_INP = 'Altitude grids for photochemically active species'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    IF(SIZE(READ_ARR) < N_PC_INP) GOTO 102
    DO I = 1, N_PC_INP
       ALT_GRID_NAME_PC(I) = SET_PATH(READ_ARR(I)%S)
    END DO
    
    STR_INP = 'Profiles for photochemically active species'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    IF(SIZE(READ_ARR) < N_PC_INP) GOTO 102
    DO I = 1, N_PC_INP
       PROFILE_NAME_PC(I) = SET_PATH(READ_ARR(I)%S)
    END DO
    
    STR_INP = 'Replace tropospheric concentrations'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    IF(SIZE(READ_ARR) < N_PC_INP) GOTO 102
    READ(READ_ARR(1)%S, *, ERR=101) (DO_TROP(I), I = 1,N_PC_INP)
    
    IF(ANY(DO_TROP)) THEN
       STR_INP = 'Tropopause height'
       CALL Read_Input (STR_INP, READ_ARR, *880)
       READ(READ_ARR(1)%S, *, ERR=101) Z_TP
    END IF
    
    STR_INP = 'Use constant profile'
    CALL Read_Input (STR_INP, READ_ARR, *880)
    IF(SIZE(READ_ARR) < N_PC_INP) GOTO 102
    READ(READ_ARR(1)%S, *, ERR=101) (CONST_PROF(I), I = 1, N_PC_INP)
    
    IF(ANY(CONST_PROF)) THEN
       STR_INP = 'Solar zenith angle for constant profile'
       CALL Read_Input (STR_INP, READ_ARR, *880)
       READ(READ_ARR(1)%S, *, ERR=101) CONST_SZA
    END IF
  END Block Photo_chem

  DO_PC = .FALSE.
  IF(ANY(DO_PHOTOCHEM)) DO_PC = .TRUE.
  
  !*************************************************************************
  !************************ X-section spectra ******************************
  !*************************************************************************
  STR_INP = 'X-section path'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  X_SECTION_PATH = SET_PATH(READ_ARR(1)%S)
  
  STR_INP = 'Do x-sections akima interpolation'
  CALL Read_Input (STR_INP, READ_ARR, *880)
  READ(READ_ARR(1)%S,*,ERR=101) DO_XSECTION_AKIMA
  
  IF(CHK_STAT('o3',TG_INFO%NAME, TG_INFO%FM_FLG)) THEN
     STR_INP = 'Do O3 UV GOME FM'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) DO_O3TEMP_GOMEFM
     IF( DO_O3TEMP_GOMEFM ) THEN
        STR_INP = 'X-section: o3_uv, GOME FM'
     ELSE
        STR_INP = 'X-section: o3_uv, Bass'
     ENDIF
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) O3_UV_CS_FILE, O3_UV_START, O3_UV_END
  ELSE
     O3_UV_START = 0.0D0 ;  O3_UV_END = 0.0D0
  END IF

  ALLOCATE( STG_ARR(N_XSEC_MOL + 3), CS_FLAG(N_XSEC_MOL + 3) )

  STG_ARR = [&
       'X-section: bro        ', 'X-section: no3        ',&
       'X-section: oclo       ', 'X-section: o4         ',&
       'X-section: o3 UV-NIR  ', 'X-section: no2        ',&
       'X-section: so2        ', 'X-section: clo        ',&
       'X-section: hcho       ', 'X-section: o3 < 240 nm',&
       'X-section: o2 UV      ', 'X-section: o2 Herzberg']
  CS_FLAG = .TRUE.
  CS_FLAG(1:N_XSEC_MOL) = TG_INFO(1:N_XSEC_MOL)%FM_FLG

  IF(CONVOL_FLAG) THEN
     WL_S = SRF(1)%SWB(BAND_START(1))
  ELSE
     WL_S = BAND_START(1) - 0.1D0
  END IF
  II = FIND_IDX('o3',TG_INFO%NAME)
  IF(WL_S >= O3_UV_START.OR..NOT.TG_INFO(II)%FM_FLG) CS_FLAG(N_XSEC_MOL + 1) = .FALSE.
  II = FIND_IDX('o2',TG_INFO%NAME)
  IF(WL_S >= 1.0D+7/4.9D+4.OR..NOT.TG_INFO(II)%FM_FLG) CS_FLAG(N_XSEC_MOL + 2) = .FALSE.
  IF(WL_S >= 240.0D0.OR..NOT.TG_INFO(II)%FM_FLG) CS_FLAG(N_XSEC_MOL + 3) = .FALSE.

  ABS_COEFF_NTEMP = 0
  DO I = 1, N_XSEC_MOL + 3
     IF(.NOT.CS_FLAG(I)) CYCLE
     STR_INP = TRIM(STG_ARR(I))
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) ABS_COEFF_NTEMP(I)
  END DO

  N_TEMP = MAXVAL(ABS_COEFF_NTEMP(:),CS_FLAG(:))
  ALLOCATE(ABS_COEFF_TEMP(N_XSEC_MOL + 3,N_TEMP), &! A
       X_SECTION_FILE(N_XSEC_MOL + 3,N_TEMP)) ! A

  DO I = 1, N_XSEC_MOL + 3
     IF(.NOT.CS_FLAG(I)) CYCLE
     STR_INP = TRIM(STG_ARR(I))
     CALL Read_Input (STR_INP, READ_ARR, *880, OutputType = 'none')
     DO K = 1, ABS_COEFF_NTEMP(I)
        CALL SPLIT_STRING(READ_ARR(K + 1)%S, STR_ARR)
        X_SECTION_FILE(I,K) = CUT_STR(STR_ARR(1)%S)
        READ(STR_ARR(2)%S, *, ERR=101) ABS_COEFF_TEMP(I,K)
     END DO
  END DO

  !*************************************************************************
  !********************************* Sub-layers ****************************
  !*************************************************************************
  IF(TRIM(RTM_TYPE) /= 'pp_scat'.AND.TRIM(RTM_MODE) /= 'vod') THEN
     IF( AC_FLAG ) THEN
        STR_INP = 'The layering of line-of-sight'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) NBE_INP, NAF_INP, DEL_INP
        STR_INP = 'The number of fine grid layers'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) NN
        STR_INP = 'Fine grid start'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) N_FINE_ST
        STR_INP = 'Fine grid tangent'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) N_FINE_TH
        STR_INP = 'Fine grid height'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) Z_F
        STR_INP = 'Solar fine grid height'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) Z_SOL_F
        STR_INP = 'Accuracy of STA'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) Crit_STA
        STR_INP = 'Check STA'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) Check_STA

        STR_INP = 'Use constant angles along line-of-sight'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR = 101) Const_ang 

        STR_INP = 'Solar grid'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
        IF( RTM_MODE=='spher_alb'.AND.(.NOT.DIFB) ) THEN
           SolGrid%Type = 'full_db'
        ELSE
           SolGrid%Type = CUT_STR(STR_ARR(1)%S)
        ENDIF
        CALL UPPER_LOWER_CASE (SolGrid%Type,'U2L')
        SELECT CASE( SolGrid%Type )
        CASE('full_db', 'opt_db', 'one')
        CASE('uda', 'udc', 'udg', 'uda_th')
           READ(STR_ARR(2)%S, *, ERR = 101) SolGrid%NAng
           SolGrid%PR = 1.4D0
        CASE('ura', 'urc', 'urg')
           READ(STR_ARR(2)%S, *, ERR = 101) SolGrid%NAng
           READ(STR_ARR(3)%S, *, ERR = 101) SolGrid%AngMin
           READ(STR_ARR(4)%S, *, ERR = 101) SolGrid%AngMax
           if(Size(STR_ARR) > 4) Then
              READ(STR_ARR(5)%S, *, ERR = 101) SolGrid%PR
           Else
              SolGrid%PR = 1.4D0
           End if
        CASE DEFAULT
           CALL NOT_FOUND (R_NAME, STR_INP, SolGrid%Type, *880)
        END SELECT
        SELECT CASE( SolGrid%Type )
        Case ('full_db', 'ura', 'urc', 'urg')
        case Default
           If(N_ITER > 1) GoTo 231
           If(.Not.PreCalcGeom) GoTo 232
        End Select
     ELSE
        NN = 5
        NBE_INP = 2   ;  NAF_INP   = 1     ;  DEL_INP = 1.d0
        N_FINE_ST = 1 ;  N_FINE_TH = 5     ;  Z_F = 3.d0
        Z_SOL_F = Z_F ;  Crit_STA  = 0.1d0 ;  Check_STA = .FALSE.
        Const_ang  = .FALSE. ;  SolGrid%Type = 'full_db'
     ENDIF
  ELSE
     NN = 1
  END IF

!*************************************************************************
!************************ Solar spectrum *********************************
!*************************************************************************
  IF(RTM_MODE == 'raman' .OR. IRRAD_FLAG) THEN
     STR_INP = 'Filename user provided solar spectrum'
     Call Read_OptCDF (STR_INP, 1, ReadStc, *880, Nlines=1)
     FILENAME_SOLSPEC = ReadStc(1)%Arr(1)%S
     IF(Size(ReadStc(1)%Arr) > 1) SOL_CDF = ReadStc(1)%Arr(2)%S
    

     STR_INP = 'Dimension of extra-terrestrial solar flux'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     WL_IRRAD_DIM(1) = CUT_STR(STR_ARR(1)%S)
     DO KK = 2,4
        WL_IRRAD_DIM(KK) = CUT_STR(STR_ARR(KK+1)%S)
     ENDDO
     ! Input wavelength grid in solar spectrum 'air' or 'vac'
     WL_IRRAD_DIM(5) = CUT_STR(STR_ARR(2)%S)
     ! Set scaling factor for solar spectrum
     IF( SIZE(STR_ARR) > 5 ) THEN
        READ(STR_ARR(6)%S,*) SCALE_SS
     ELSE
        SCALE_SS = 1.d0
     ENDIF

     ! Wavelength dimwnsion:
     SELECT CASE( TRIM(WL_IRRAD_DIM(1)) )
     CASE('nm','micron','angstrom')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, WL_IRRAD_DIM(1), *880)
     END SELECT
     ! Power dimwnsion:
     SELECT CASE( TRIM(WL_IRRAD_DIM(2)) )
     CASE('W','phot/s')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, WL_IRRAD_DIM(2), *880)
     END SELECT
     ! Area dimwnsion:
     SELECT CASE( TRIM(WL_IRRAD_DIM(3)) )
     CASE('m^2','cm^2')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, WL_IRRAD_DIM(3), *880)
     END SELECT
     ! Wavelength interval:
     SELECT CASE( TRIM(WL_IRRAD_DIM(4)) )
     CASE('nm','micron')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, WL_IRRAD_DIM(4), *880)
     END SELECT

     ! Prepare Planck function multiplier (M_PLA)
     M_PLA = 1.D0
     ! To convert Planck function originally calculated pro area [1/m^2] into:
     IF( TRIM(WL_IRRAD_DIM(3))=='cm^2' ) M_PLA = M_PLA*1.D-4 ! [1/cm^2]

     ! To convert Planck function originally calculated pro
     ! spectral interval [1/m] into:
     SELECT CASE( TRIM(WL_IRRAD_DIM(4)) )
     CASE('nm')      ;  M_PLA = M_PLA*1.D-9  ! [1/nm]
     CASE('micron')  ;  M_PLA = M_PLA*1.D-6  ! [1/micron]
     END SELECT
  ELSE
     WL_IRRAD_DIM(1) = 'nm'
     WL_IRRAD_DIM(2) = 'phot/s'
     WL_IRRAD_DIM(3) = 'cm^2'
     WL_IRRAD_DIM(4) = 'nm'
  END IF

!*************************************************************************
!************************ Output formats *********************************
!*************************************************************************
  Ellip = .FALSE.
  IF( VHL ) THEN
     OUT_SPEC = .TRUE.
  ELSE
     STR_INP = 'Output format specification'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) OUT_SPEC
  END IF
  
  IF( OUT_SPEC ) THEN
     STR_INP = 'Output of following Stokes components'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) IS1, IS2

     IF( Vec_sca == 'vect_rte' ) THEN
        STR_INP = 'Output of ellipsometric parameters'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        STR_LOC = CUT_STR(READ_ARR(1)%S)
        SELECT CASE( STR_LOC )
        CASE('yes')
           Ellip = .TRUE.
        CASE('no')
           Ellip = .FALSE.
        CASE DEFAULT
           CALL NOT_FOUND (R_NAME, STR_INP, STR_LOC, *880)
        END SELECT
     ENDIF

     STR_INP = 'Fluxes for path representation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     STR_LOC = CUT_STR(READ_ARR(1)%S)
     SELECT CASE( STR_LOC )
     CASE('yes')
        TRANS_OUT = .TRUE.
        IF(.NOT.WF_FLAG) GOTO 228
     CASE('no')
        TRANS_OUT = .FALSE.
     CASE DEFAULT
        CALL NOT_FOUND (R_NAME, STR_INP, STR_LOC, *880)
     END SELECT

     STR_INP = 'Output of surface albedo'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     STR_LOC = CUT_STR(READ_ARR(1)%S)
     SELECT CASE( STR_LOC )
     CASE('yes') ;  ALB_OUT = .TRUE.
     CASE('no')  ;  ALB_OUT = .FALSE.
     CASE DEFAULT
        CALL NOT_FOUND (R_NAME, STR_INP, STR_INP, *880)
     END SELECT

     SELECT CASE( RTM_MODE )
     CASE('vod','spher_alb','flux')
        TO_REFL_FUNC = .FALSE.
     CASE DEFAULT
        STR_INP = 'Transform to reflection function?'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S,*,ERR=101) TO_REFL_FUNC
     END SELECT

     STR_INP = 'Put AOT into output file'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) AOT_out_LOG

     STR_INP = 'Write local optical parameters'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
     READ(STR_ARR(1)%S, *, ERR=101) SOUT_FLAG
     IF(SOUT_FLAG) THEN
        TAU_FLAG = CUT_STR(STR_ARR(2)%S)
        DIR_SOUT = CUT_STR(STR_ARR(3)%S)
        SELECT CASE (TRIM(TAU_FLAG))
        CASE ('opt_th')
           SOUT_TAU = .TRUE.
        CASE ('as_c')
           SOUT_TAU = .FALSE.
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, TAU_FLAG, *880)
        END SELECT
     END IF

     SELECT CASE (RTM_MODE)
     CASE ('flux', 'spher_alb')
        STR_INP = 'Lower and upper boundary of flux results'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR=101) FLUX_MIN_ZZZ, FLUX_MAX_ZZZ
        IF( UWT ) FLUX_MIN_ZZZ = 0.d0
        STR_INP = 'Output format for multiple wavelengths'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        Mult_WL_Form = CUT_STR(READ_ARR(1)%S)
        SELECT CASE (Mult_WL_Form)
        CASE ('wl_in_line','wl_in_colm')
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, Mult_WL_Form, *880)
        END SELECT
        ! Preliminary
        OUT_REPR = 'default'

     CASE ('int','int_flux','wf','asymp')
        STR_INP = 'Lower and upper boundary of flux results'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR=101) FLUX_MIN_ZZZ, FLUX_MAX_ZZZ
        IF( UWT ) FLUX_MIN_ZZZ = 0.d0

        STR_INP = 'Intensity representation in output file'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        OUT_REPR = CUT_STR(READ_ARR(1)%S)

        IF( TRIM(RTM_MODE)=='wf' ) THEN
           OUT_REPR = 'default'
           CALL WRITE_MESSAGE(R_NAME, 'WARNING',  &
                'Intensity representation in output file '&
                //'is switched to the "default" mode' )
        ENDIF
        
        SELECT CASE (OUT_REPR)
        CASE ('|Zen\Azm|','|Azm\Zen|','|SZA\Azm|','|Azm\SZA|',&
             '|SZA\Zen|','|Zen\SZA|','dynamic')
           ONE_WL = 'optimal'
        CASE ('default')
           ONE_WL = 'unchanged'
        CASE DEFAULT
           CALL NOT_FOUND (R_NAME, STR_INP, OUT_REPR, *880)
        END SELECT
        
        IF( AOT_out_LOG ) THEN
           Mult_WL_Form = 'wl_in_line'
        ELSE
           STR_INP = 'Output format for multiple wavelengths'
           CALL Read_Input (STR_INP, READ_ARR, *880)
           Mult_WL_Form = CUT_STR(READ_ARR(1)%S)
        END IF

        SELECT CASE (Mult_WL_Form)
        CASE ('wl_in_line','wl_in_colm')
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, Mult_WL_Form, *880)
        END SELECT
     CASE DEFAULT
        ONE_WL = 'unchanged' ; OUT_REPR = 'default'
        Mult_WL_Form = 'wl_in_colm'
     END SELECT

     STR_INP = 'Intensity or Stokes vector output format'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     OUT_FOR = CUT_STR(READ_ARR(1)%S)

     IF(TRIM(OUT_FOR) == 'default') then
        FORMAT_FLAG = 'default'
     ELSE
        FORMAT_FLAG = 'user'
     END IF
  ELSE
     ! Default output format and structure
     ONE_WL = 'unchanged' ;  AOT_out_LOG = .FALSE.
     FORMAT_FLAG = 'default' ;  OUT_REPR    = 'default'
     TO_REFL_FUNC = .FALSE. ;  IS1 = 1 ;  IS2 = 4
     Mult_WL_Form = 'wl_in_colm'
     OUT_FOR = 'default'
     SELECT CASE (TRIM(RTM_MODE))
     CASE ('flux', 'spher_alb')
        FLUX_MIN_ZZZ = 0.d0 ;  FLUX_MAX_ZZZ = 120.d0
     END SELECT
  ENDIF

!*************************************************************************
!************************ Optional climatology specification *************
!*************************************************************************
  IF( VHL ) THEN
     DO_GEOLOCATION = .FALSE.
  ELSE
     STR_INP = 'Do specification by geolocation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) DO_GEOLOCATION
  END IF

  IF(DO_GEOLOCATION) THEN
     IF(DO_CLOUD) GOTO 206
     STR_INP = 'Stop after generating CLIMATOLOGY.OUT'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) DO_STOP_GEOLOCATION
     STR_INP = 'Do profile latitude interpolation'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S,*,ERR=101) DO_PROFILE_LAT_INTERP
     STR_INP = 'Path to climatology data base'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     PATH_TO_CLIMATOLOGY_DB = SET_PATH(READ_ARR(1)%S)
     ! =================
     ! Climatology setup
     ! =================
     CALL GT_CLIMATOLOGY_INPUT (PATH_TO_CLIMATOLOGY_DB,&
          DO_PROFILE_LAT_INTERP, PROF_FILES(1), C_UNIT, *880)
     IF (DO_STOP_GEOLOCATION) THEN
        IF (LOG_LEVEL(1)  > N_NSO) THEN
           WRITE(LUNIT,*)
           WRITE(LUNIT,*) '****** Program stopped after generation of ******'
           WRITE(LUNIT,*) '********** '//DIR_OUT//'CLIMATOLOGY.OUT ***********'
           WRITE(LUNIT,*) '**** No radiative transfer calculations done ****'
           WRITE(LUNIT,*)
        ELSE
           WRITE(LUNIT,*) ' *** '//TRIM(DIR_OUT)//&
                'CLIMATOLOGY.OUT generated (no RT calc.!)'
        ENDIF
        STOP
     ENDIF
  END IF

  !**************************************************************************
  IF(LOG_LEVEL(1) >= N_SSO) THEN
     write(LUNIT,*) ' ******************************************'
     write(LUNIT,*) ' *** End of general settings section'
     write(LUNIT,*) ' ******************************************'
     write(LUNIT,*)
  END IF
  !**************************************************************************

  CALL ST_TRACK (R_NAME, 3, 'O')
  
  RETURN

101 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Reading error')
  WRITE(EU,*) '    Parameter to read: ', TRIM(STR_INP)
  RETURN 1

102 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Too few values in the field')
  WRITE(EU,*) '    Parameter to read: ', TRIM(STR_INP)
  RETURN 1

201 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Wrong input in in DOY mode')
  RETURN 1
  
202 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Wrong date format')
  WRITE(EU,*) '    Date read (DD.MM.YYYY): ', TRIM(STG)
  RETURN 1

203 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Wrong date mode')
  WRITE(EU,*) '    Selected value: ', TRIM(DATE_MODE)
  RETURN 1

206 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Cloud parameters '&
         // 'can not be set by geolocation')
  RETURN 1
  
208 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Four input values are required:')
      WRITE(EU,*) '    Parameter to read: ', STR_INP
      WRITE(EU,*) '    Input line       : ', READ_ARR(I + 1)%S
  RETURN 1

209   CALL WRITE_MESSAGE(R_NAME, 'ERROR', &
           'Photochemical calculations can only be done '//&
           'if RTM-CORE control parameter is set to "CDI"')
  RETURN 1

210 CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Asymptotic solution'&
         // ' can be used in a plane-parallel atmosphere only')
   RETURN 1
   
211 CALL WRITE_MESSAGE(R_NAME, 'ERROR', '"RTM-CORE" control '&
         // ' parameter can not be set to "CDI" for this RTM_TYPE')
   RETURN 1

222 CALL WRITE_MESSAGE(R_NAME,'ERROR',&
         'Surface albedo must be between 0 and 1')
   RETURN 1

223 CALL WRITE_MESSAGE(R_NAME,'ERROR','')
   WRITE(EU,*) '     The calculation of Raman scattering requires'
   WRITE(EU,*) '     that "King factor" control parameter        '
   WRITE(EU,*) '     is set to "from file" in the file '
   WRITE(EU,*) '     "control_ray.inp".'
   RETURN 1
   
224 CALL WRITE_MESSAGE(R_NAME,'ERROR','')
   WRITE(EU,*) '     The calculation of Raman scattering requires'
   WRITE(EU,*) '     that "Advanced Rayleigh settings" control'
   WRITE(EU,*) '     parameter is set to "true" in the file '
   WRITE(EU,*) '     "control.inp".'
   RETURN 1

225 CALL WRITE_MESSAGE(R_NAME,'ERROR','')
   WRITE(EU,*) '     The calculation of Raman scattering requires'
   WRITE(EU,*) '     an extra-terrestrial solar spectra in physical'
   WRITE(EU,*) '     units. Set "Extra-terrestrial solar flux" '
   WRITE(EU,*) '     control parameter to "File", set filename in'
   WRITE(EU,*) '     "Filename user provided solar spectrum", and '
   WRITE(EU,*) '     check units dimension in control parameter '
   WRITE(EU,*) '     "Dimension of extra-terrestrial solar flux"'
   WRITE(EU,*) '     in "control.inp" file.'
   RETURN 1

226 CALL WRITE_MESSAGE(R_NAME,'ERROR','Retrieval mode supports only' &
         // ' wavelength grid in [nm]')
   RETURN 1

227 CALL WRITE_MESSAGE(R_NAME,'ERROR','Mixing ratios for CIA species' &
         // ' can be read from file only if the species is included '&
         // ' in the forward model')
   RETURN 1

228 CALL WRITE_MESSAGE(R_NAME,'ERROR',' ')
   WRITE(EU,*) '     In order to use "Fluxes for path representation" option,'
   WRITE(EU,*) '     RTM_MODE parameter should be set to "wf".'
   WRITE(EU,*) '     Check "control_out.inp" and "control.inp" files'
   RETURN 1
   
229 CALL WRITE_MESSAGE(R_NAME,'ERROR',' ')
   WRITE(EU,*) '     Calculation of atom/ion emission requires'
   WRITE(EU,*) '     that "Advanced profile settings" control '
   WRITE(EU,*) '     parameter is set to "true" in the file '
   WRITE(EU,*) '     "control.inp".'
   RETURN 1

230 CALL WRITE_MESSAGE(R_NAME,'ERROR',' ')
   WRITE(EU,'(a)')      '  Wrong type of discretization shema'
   WRITE(EU,'(a,2x,a)') '     As input :', DISCR_M
   WRITE(EU,'(a)')      "     Accepted 'G' or 'E' only"
   WRITE(EU,*)          '  Check "Use precalculated scattering matrix" '
   WRITE(EU,*)          '     control parameter in "control_ac.inp" file'
   RETURN 1   
   
231 CALL WRITE_MESSAGE(R_NAME, 'ERROR', '')
   WRITE(EU,*) '    If more than 1 spherical iterations are selected'
   WRITE(EU,*) '    the "Solor grid" parameter must be set to "Full_DB"'
   WRITE(EU,*) '    Check "control_ac.inp" file.'
   RETURN 1

232 CALL WRITE_MESSAGE(R_NAME, 'ERROR', '')
   WRITE(EU,*) '    If the first input field of the control parameter'
   WRITE(EU,*) '    "Pre-calculate line-of-sight geometry" is set to "F"'
   WRITE(EU,*) '    the "Solor grid" parameter must be set to "Full_DB"'
   WRITE(EU,*) '    Check "control_ac.inp" file.'
   RETURN 1

233 CALL WRITE_MESSAGE(R_NAME, 'ERROR', '')
   WRITE(EU,*) '    Error in the "Pre-calculate line-of-sight geometry" '
   WRITE(EU,*) '    the control parameter. Second input value cannot be'
   WRITE(EU,*) '    set to "T" if "RTM_TYPE" control parameter in "control.inp"'
   WRITE(EU,*) '    file is set to "spp_scatt"'

234 CALL WRITE_MESSAGE(R_NAME, 'ERROR', '')
   WRITE(EU,*) &
        '    Scaling is not allowed for MODIS-land and MODIS-man aerosol types.'
   WRITE(EU,*) '    Check "Aerosol scaling parameter" in "control_aer.inp" file.'
   WRITE(EU,'(A,F6.3)') '      Your setting is AER_SCALING = ', AER_SCALING

235 CALL WRITE_MESSAGE(R_NAME, 'ERROR', '')
   WRITE(EU,*) '    For "DOM" solver the first parameter in the "Pre-calculate '//&
   'line-of-sight geometry" input field must be set to "T" '

880 WRITE(EU, *) ' ---> Called by '//R_NAME
   RETURN 1
   
 CONTAINS
   !**************************************************************************
   SUBROUTINE READ_RRS(*)
     CHARACTER (LEN = *), PARAMETER :: R_NAME = 'READ_RRS'
     CHARACTER (LEN=:), ALLOCATABLE :: DOM_ADJ
     !------------------------------------------------------------------
     
     STR_INP = 'Test with single model Fraunhofer line'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) RRS_TEST

     STR_INP = 'Numerical technique used for RRS'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     DOM_ADJ = CUT_STR(READ_ARR(1)%S)
! Check input value
     SELECT CASE( DOM_ADJ )
     CASE('dom')
        RRS_ADJ = .FALSE. ; RRS_DO = .TRUE. ; DOM_API  = .FALSE.
     CASE('dom_api')
        RRS_ADJ = .FALSE. ; RRS_DO = .TRUE. ; DOM_API  = .TRUE.
     CASE('adj')
        RRS_ADJ = .TRUE.  ; RRS_DO = .FALSE.
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, DOM_ADJ, *880)
     END SELECT

     IF( Vec_Sca=='vect_rte' ) THEN
        ALLOCATE( Lo_rrs(Nvs) )
        STR_INP = 'Ring spectrum for Stokes component'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR=101) (Lo_rrs(II),II=1,4)
        ! Number of Stokes components for which Ring
        ! spectrum should be calculated. NS_wf and Nc_der(:)
        ! are the same as used in the "wf" mode.
        NS_wf = COUNT( Lo_rrs(:) )
        ALLOCATE( Nc_der(NS_wf), Ainc(NS_wf,4)   )
        Ainc = 0.d0
        ! Elements of Nc_der(:) show for which Stokes component
        ! Ring spectrum should be calculated
        K = 1
        DO II = 1,4
           IF( Lo_rrs(II) ) THEN
              Nc_der(K) = II  ;  Ainc(K,II) = 1.d0  ;  K = K + 1
           ENDIF
        ENDDO
        IF( NS_wf == 0 ) GOTO 103
     ENDIF

     STR_INP = 'Maximum rotational number'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) NR_LINES
     IF( MOD(NR_LINES,2) == 0 ) GOTO 102

     STR_INP = 'Use spin-rotational splitting'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR )
     READ(STR_ARR(1)%S,*,ERR=101) ESR_Split
     IF( ESR_Split ) THEN
        RRS_NAM_ET = SET_PATH( STR_ARR(2)%S ) 
        RRS_NAM_PT = SET_PATH( STR_ARR(3)%S )
     ENDIF

     STR_INP = 'Approach to calculate contribution of Raman lines'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     APPR_RRS = CUT_STR(READ_ARR(1)%S)
     SELECT CASE( TRIM(APPR_RRS) )
     CASE('exact matching','simple binning')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, APPR_RRS, *880)
     END SELECT

     STR_INP = 'Ring spectra output mode'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     RIN_OUT = CUT_STR(READ_ARR(1)%S)
     SELECT CASE( RIN_OUT )
     CASE('rel','log','abs-sn')
     CASE DEFAULT
        CALL NOT_FOUND(R_NAME, STR_INP, RIN_OUT, *880)
     END SELECT

     STR_INP = 'Raman binning step'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) DEL_RAM

     IF( TRIM(APPR_RRS)=='exact matching' ) THEN
        TSM = 'memory'
     ELSE
        STR_INP = 'Tradeoff speed/memory'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        TSM = CUT_STR(READ_ARR(1)%S)
        SELECT CASE( TSM ) 
        CASE('speed','memory')
        CASE DEFAULT
           CALL NOT_FOUND(R_NAME, STR_INP, TSM, *880)
        END SELECT
     END IF

     RETURN

101  CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Reading error')
     WRITE(EU,*) '    Parameter to read: ', TRIM(STR_INP)
     RETURN 1

102  CALL WRITE_MESSAGE(R_NAME, 'ERROR', '')
     WRITE(EU,*) '    Maximal number of Raman lines has to be odd.'
     WRITE(EU,*) '    Check input file "control_rrs.inp".'
     RETURN 1

103  CALL WRITE_MESSAGE(R_NAME, 'ERROR', ' ')
     WRITE(EU,'(a)') '     For which Stokes component should be calculated'
     WRITE(EU,'(a)') '     the Ring spectrum?'
     WRITE(EU,'(a,2x,I3)') '     Check "Ring spectrum for Stokes component"'
     WRITE(EU,'(a,2x,I3)') '     control parameter in "control_rrs.inp" file.'
     RETURN 1
     
880  WRITE(EU, *) ' ---> Called by '//TRIM(R_NAME)
     RETURN 1
   END SUBROUTINE READ_RRS
   !**************************************************************************

   SUBROUTINE READ_ALIN(*)

     CHARACTER (LEN = *), PARAMETER :: R_NAME = 'READ_ALIN'
     CHARACTER (LEN=80) FN, FILE_GAS_KA, FILE_RAY(2), FILE_AER(3), FILE_CLD(3)
     CHARACTER (LEN=:), ALLOCATABLE :: OT_CO
     CHARACTER (LEN=7)  WL_ALT
     LOGICAL  INV_Z, INV_WL, PLUS
     INTEGER  NZ, NeC, NaC, NWL, NZ_C, NC, NVE, D1, D2
     INTEGER  I, J, K
     INTEGER, PARAMETER :: MAX_READ=10000
     REAL (KND), ALLOCATABLE :: Z_READ(:), TMP_Z_WL(:,:)
     !==================================================================

     CALL ST_TRACK (R_NAME, 3, 'I')
     ! Input files contain optical thickness of all layers 
     ! starting from the top of atmosphere
     OT_CO = 'optical depth'

     ! Wavelengths in columns, Altitudes in rows:
     WL_ALT = 'Col_Row'
!     ... Wavelengths in rows, Altitudes in columns:
!      WL_ALT = 'Row_Col'

     STR_INP = 'Logical flag'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     READ(READ_ARR(1)%S, *, ERR=101) (ALIN_ACT(I), I=1,4)

     STR_INP = 'Path'
     CALL Read_Input (STR_INP, READ_ARR, *880)
     DIR_PATH = CUT_STR(READ_ARR(1)%S)

     STR_INP = 'Altitude and wavelength grid'
     CALL Read_Input (STR_INP, READ_ARR, *880, JOIN=.TRUE.)
     CALL SPLIT_STRING(READ_ARR(1)%S, STR_ARR)
     ALT_PATH = CUT_STR(STR_ARR(1)%S) ;  WL_PATH = CUT_STR(STR_ARR(2)%S)

     IF( ALIN_ACT(1) ) THEN
        STR_INP = 'Absorber filename'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        FILE_GAS_KA = CUT_STR(READ_ARR(1)%S)
     ENDIF
     IF( ALIN_ACT(2) ) THEN
        STR_INP = 'Rayleigh'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR=101) (FILE_RAY(I), I=1,2)
     ENDIF
     IF( ALIN_ACT(3) ) THEN
        STR_INP = 'Aerosol'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR=101) (FILE_AER(I), I=1,3)
     ENDIF
     IF( ALIN_ACT(4) ) THEN
        STR_INP = 'Cloud'
        CALL Read_Input (STR_INP, READ_ARR, *880)
        READ(READ_ARR(1)%S, *, ERR=101) (FILE_CLD(I), I=1,3)
     ENDIF
     
     ALLOCATE( Z_READ(MAX_READ) ) ! A
     INV_Z = .FALSE.
     FN = DIR_PATH//ALT_PATH
! Reading altitude grid
! -------------------------------------------
     OPEN(C_UNIT, FILE = FN, STATUS = 'OLD')
     CALL SKIP_HEADER (C_UNIT)
     DO I = 1, MAX_READ
        READ(C_UNIT,*,ERR=300,END=33) Z_READ(I)
     END DO
33   CONTINUE
     NZ = I - 1
     IF( NZ > MAX_READ ) GOTO 301
     IF( Z_READ(2) > Z_READ(1) ) INV_Z = .TRUE.
     CLOSE (C_UNIT)
     !-------------------------------------------

     ALIN_NZ = NZ
     ALLOCATE ( ALIN_Z(NZ) )

! Altitude grid within SCIATARN is ordered from the top
! to the bottom of the atmosphere
     IF( INV_Z ) THEN
        ALIN_Z(1:NZ) = Z_READ(NZ:1:-1)
     ELSE
        ALIN_Z(1:NZ) = Z_READ(1:NZ)
     ENDIF

     ! WRITE(*,*) '   Top and bottom of the atmosphere'
     ! WRITE(*,'(A,1x,f7.2)') '   base :', ALIN_Z(ALIN_NZ)
     ! WRITE(*,'(A,1x,f7.2)') '    top :', ALIN_Z(1)

     FN = DIR_PATH//WL_PATH
     INV_WL = .TRUE.
     ! Reading wavelength grid
     ! -------------------------------------------
     OPEN(C_UNIT, FILE = FN,STATUS = 'OLD')
     CALL SKIP_HEADER (C_UNIT)
     DO I = 1, MAX_READ
        READ(C_UNIT,*,ERR=300,END=34) Z_READ(I)
        ! WRITE(*,'(2x,I5,2x,E12.4)') I, Z_READ(I)
     END DO
34   CONTINUE
     NWL = I - 1
     IF( NWL > MAX_READ ) GOTO 301
     IF( Z_READ(2) > Z_READ(1).OR.NWL==1 ) INV_WL = .FALSE.
     CLOSE (C_UNIT)
     ! ---------------------------------------------

     ALIN_NWL = NWL
     ALLOCATE( ALIN_WL(1:NWL) )
     IF( INV_WL ) THEN
        ALIN_WL(1:NWL) = Z_READ(NWL:1:-1)
     ELSE
        ALIN_WL(1:NWL) = Z_READ(1:NWL)
     ENDIF
     
     ! WRITE(*,'(A,2x,I5)') '   Number of wavelengths:', NWL
     ! WRITE(*,'(A,2(2x,F8.3))') '   Wavelengths:', ALIN_WL(1), ALIN_WL(NWL)
     
     NZ_C = NZ  ;  NaC = 1  ;  NeC = NZ
     ! In the case of cloud two additional levels will be
     ! added automatically in the subroutine "gt_layer.f"
     PLUS = .FALSE.
     !      IF( ALIN_ACT(4) ) THEN
     !         PLUS = .TRUE.  ;  NZ_C = NZ + 2
     !         NaC = 2  ;  NeC = NZ_C - 1
     !      ENDIF
     
     ALLOCATE( TMP_Z_WL(1:NWL,1:NZ) )
     
     ! Reading gaseous absorption coefficient
     ! --------------------------------------
     IF( ALIN_ACT(1) ) THEN
        FN = DIR_PATH//TRIM(FILE_GAS_KA)
        OPEN(C_UNIT, FILE=TRIM(FN), STATUS='OLD')
        CALL SKIP_HEADER (C_UNIT)
        READ(C_UNIT,*,ERR=300) D1, D2
        ! Check that the same altitude and wavelength grids are used
        IF( D1 /= NZ .OR. D2 /= NWL ) GOTO 302
        ALLOCATE( ALIN_ABS(1:NWL,1:NZ_C) )
        SELECT CASE( WL_ALT )
        CASE('Row_Col')
           DO I = 1,NWL
              READ(C_UNIT,*,ERR=300) (TMP_Z_WL(I,J),J = 1,NZ)
           ENDDO
        CASE('Col_Row')
           DO J = 1,NZ
              READ(C_UNIT,*,ERR=300) (TMP_Z_WL(I,J),I = 1,NWL)
           ENDDO
        END SELECT
        CLOSE(C_UNIT)
        
        ALIN_ABS(:,NaC:NeC) = TMP_Z_WL(:,:)
        !         IF( PLUS ) THEN
        !            ALIN_ABS(:,1)    = ALIN_ABS(:,2)
        !            ALIN_ABS(:,NZ_C) = ALIN_ABS(:,NZ_C-1)
        !          ENDIF
        IF( INV_Z ) THEN
           DO I = 1,NWL
              ALIN_ABS(I,1:NZ_C) = ALIN_ABS(I,NZ_C:1:-1)
           ENDDO
        ENDIF
        IF( INV_WL ) THEN
           DO I = 1,NZ_C
              ALIN_ABS(1:NWL,I) = ALIN_ABS(NWL:1:-1,I)
           ENDDO
        ENDIF
        
        ! Convert optical depth into coefficients
        IF( OT_CO == 'optical depth' ) &
             CALL OT_to_COEF(NWL, NZ_C, ALIN_ABS, ALIN_Z)
        
        DO I = 1, NWL
           IF(ALIN_ABS(I,1) < 0.d0 .OR. ALIN_ABS(I,NZ_C-1) < 0.d0) THEN
              WRITE(LUNIT,*) '  Gas for wavelength :', I
              WRITE(LUNIT,*) ALIN_ABS(I,1), ALIN_ABS(I,NZ_C-1)
              WRITE(LUNIT,*) ALIN_ABS(I,2), ALIN_ABS(I,NZ_C)
           ENDIF
        ENDDO
        
     ENDIF  ! Reading gaseous absorption 
     
     !        Test
     !      WRITE(*,'(2x,3(2x,e15.7))')
     !     $     ALIN_Z(1), ALIN_Z(2), ALIN_Z(3)
     !      WRITE(*,*) '  --------- gas ------------------- '
     !      DO I = 1,20
     !         WRITE(*,'(2x,3(2x,e15.7))')
     !     $        ALIN_ABS(I,1), ALIN_ABS(I,2), ALIN_ABS(I,3)
     !      ENDDO
     
     ! Rayleigh
     ! ========
     IF( ALIN_ACT(2) ) THEN
        ! Reading scattering coefficient
        ! ------------------------------
        FN = DIR_PATH//TRIM(FILE_RAY(1))
        CALL READ_COMP (NWL, NZ, TMP_Z_WL, FN, NZ, NWL, INV_Z, WL_ALT, *880)
        ALLOCATE( ALIN_RAY(1:NWL,1:NZ_C) )
        ALIN_RAY(:,NaC:NeC) = TMP_Z_WL(:,:)
        !         IF( PLUS ) THEN
        !            ALIN_RAY(:,1)    = ALIN_RAY(:,2)
        !            ALIN_RAY(:,NZ_C) = ALIN_RAY(:,NZ_C-1)
        !          ENDIF
        !          WRITE(*,*) ALIN_RAY(1,1), ALIN_RAY(1,NZ_C)
        
        ! Reading expansion coefficients of scattering matrix 
        ! ---------------------------------------------------
        FN = DIR_PATH//TRIM(FILE_RAY(2))
        OPEN(C_UNIT, FILE=FN, STATUS='OLD')
        CALL SKIP_HEADER (C_UNIT)
        READ(C_UNIT,*,ERR=300) NVE, NC
        ! NC  - number of expansion coefficients
        ! NVE - 1 or 6 for scalar or vector case, respectively
        ALLOCATE( ALIN_RAY_EC(1:NC,1:NVE) )
        DO I = 1,NC
           READ(C_UNIT,*,ERR=300) (ALIN_RAY_EC(I,J),J = 1,NVE)
        ENDDO
        IF( NVE > 1 ) ALIN_RAY_EC(:,5:6) = -ALIN_RAY_EC(:,5:6)
        CLOSE(C_UNIT)
        !---------------------------------------------------------------
        IF( INV_WL ) THEN
           DO I = 1,NZ_C
              ALIN_RAY(1:NWL,I) = ALIN_RAY(NWL:1:-1,I)
           ENDDO
        ENDIF
        ! Calculate the scattering coefficients [km-1] 
        ! from the top to the bottom 
        IF( OT_CO == 'optical depth' ) &
             CALL OT_to_COEF(NWL, NZ, ALIN_RAY, ALIN_Z)
        
        DO I = 1, NWL
           IF(ALIN_RAY(I,1) < 0.d0 .OR. ALIN_RAY(I,NZ_C-1) < 0.d0) THEN
              WRITE(LUNIT,*) '  Rayleigh for wavelength :', I
              WRITE(LUNIT,*) ALIN_RAY(I,1), ALIN_RAY(I,NZ_C-1)
              WRITE(LUNIT,*) ALIN_RAY(I,2), ALIN_RAY(I,NZ_C)
           ENDIF
        ENDDO
     ENDIF  ! Reading Rayleigh
     
     !     WRITE(*,*) '  --------- Ray ------------------- '
     !      DO I = 1,20
     !         WRITE(*,'(2x,3(2x,e15.7))')
     !     $        ALIN_RAY(I,1), ALIN_RAY(I,2), ALIN_RAY(I,3)
     !      ENDDO
     !      DO I = 1,NZ
     !         WRITE(*,'(2x,F6.2,2x,e12.4)') ALIN_Z(I),  ALIN_RAY(1,I)
     !      ENDDO
     !      STOP '  STOP after Rayleigh'
     
     ! Aerosol
     ! =======
     IF( ALIN_ACT(3) ) THEN
        ! Reading of scattering coefficient
        ! ---------------------------------
        FN = DIR_PATH//TRIM(FILE_AER(1))
        CALL READ_COMP &
             (NWL, NZ, TMP_Z_WL, FN, NZ, NWL, INV_Z, WL_ALT,*880)
        ALLOCATE( ALIN_AER_S(1:NWL,1:NZ_C) )
        ALIN_AER_S(:,NaC:NeC) = TMP_Z_WL(:,:)
        
        ! Reading of absorption coefficient
        ! ---------------------------------
        FN = DIR_PATH//TRIM(FILE_AER(2))
        CALL READ_COMP &
             (NWL, NZ, TMP_Z_WL, FN, NZ, NWL, INV_Z, WL_ALT,*880)
        ALLOCATE( ALIN_AER_A(1:NWL,1:NZ_C) )
        ALIN_AER_A(:,NaC:NeC) = TMP_Z_WL(:,:)
        !         IF( PLUS ) THEN
        !            ALIN_AER_S(:,1)    = ALIN_AER_S(:,2)
        !            ALIN_AER_S(:,NZ_C) = ALIN_AER_S(:,NZ_C-1)
        !            ALIN_AER_A(:,1)    = ALIN_AER_A(:,2)
        !            ALIN_AER_A(:,NZ_C) = ALIN_AER_A(:,NZ_C-1)
        !          ENDIF
        
        !          WRITE(*,*) '  -----------> Aerosol :'
        !          WRITE(*,*) '  Scatt', ALIN_AER_S(1,1), ALIN_AER_S(1,NZ_C)
        !          WRITE(*,*) '  Abs  ', ALIN_AER_A(1,1), ALIN_AER_A(1,NZ_C)
        
        ! Reading scattering matrix expansion coefficients
        ! ------------------------------------------------
        FN = DIR_PATH//TRIM(FILE_AER(3))
        OPEN(C_UNIT, FILE=TRIM(FN), STATUS='OLD')
        CALL SKIP_HEADER (C_UNIT)
        READ(C_UNIT,*,ERR=300) NVE, NC_AER
        ALLOCATE( ALIN_AER_EC(1:NC_AER,1:NVE) )
        DO I = 1,NC_AER
           READ(C_UNIT,*,ERR=300) (ALIN_AER_EC(I,J),J = 1,NVE)
        ENDDO
        IF( NVE > 1 ) ALIN_AER_EC(:,5:6) = -ALIN_AER_EC(:,5:6)
        CLOSE(C_UNIT)
        !-------------------------------------------------
        
        IF( INV_WL ) THEN
           DO I = 1, NZ_C
              ALIN_AER_S(1:NWL,I) = ALIN_AER_S(NWL:1:-1,I)
              ALIN_AER_A(1:NWL,I) = ALIN_AER_A(NWL:1:-1,I)
           ENDDO
        ENDIF
        IF( OT_CO == 'optical depth' ) THEN
           CALL OT_to_COEF(NWL, NZ_C, ALIN_AER_S, ALIN_Z)
           CALL OT_to_COEF(NWL, NZ_C, ALIN_AER_A, ALIN_Z)
        ENDIF
        
        !         WRITE(*,*) '   Selected moments of aerosol phase matrix'
        !         WRITE(*,'(6(1x,e12.4))') (ALIN_AER_EC(1,J),J = 1,NVE)
        !         WRITE(*,'(6(1x,e12.4))') (ALIN_AER_EC(NC_AER,J),J=1,NVE)
     ENDIF   ! Reading aerosol
     
     !      WRITE(*,*) '  --------- Aer S ------------------- '
     !      DO I = 1,20
     !         WRITE(*,'(2x,3(2x,e15.7))')
     !     $        ALIN_AER_S(I,1), ALIN_AER_S(I,2), ALIN_AER_S(I,3)
     !      ENDDO
     !      WRITE(*,*) '  --------- Aer A ------------------- '
     !      DO I = 1,20
     !         WRITE(*,'(2x,3(2x,e15.7))')
     !     $        ALIN_AER_A(I,1), ALIN_AER_A(I,2), ALIN_AER_A(I,3)
     !      ENDDO
     
     ! Cloud
     ! =====
     IF( ALIN_ACT(4) ) THEN
        ! Reading scattering coefficient
        ! ------------------------------
        FN = DIR_PATH//TRIM(FILE_CLD(1))
        CALL READ_COMP &
             (NWL, NZ, TMP_Z_WL, FN, NZ, NWL, INV_Z, WL_ALT, *880)
        ALLOCATE( ALIN_CLD_S(1:NWL,1:NZ_C) )
        ALIN_CLD_S(:,NaC:NeC) = TMP_Z_WL(:,:)
        
        ! Reading absorption coefficient
        ! -------------------------------
        FN = DIR_PATH//TRIM(FILE_CLD(2))
        CALL READ_COMP  &
             (NWL, NZ, TMP_Z_WL, FN, NZ, NWL, INV_Z, WL_ALT, *880)
        ALLOCATE( ALIN_CLD_A(1:NWL,1:NZ_C) )
        ALIN_CLD_A(:,NaC:NeC) = TMP_Z_WL(:,:)
        !         IF( PLUS ) THEN
        !            ALIN_CLD_S(:,1)    = 0.d0
        !            ALIN_CLD_S(:,NZ_C) = 0.d0
        !            ALIN_CLD_A(:,1)    = 0.d0
        !            ALIN_CLD_A(:,NZ_C) = 0.d0
        !!           ... Is introduced to avoid instable solution within
        !!               upper infinitesimal sub-layer.
        !            ALIN_CLD_A(:,1)    = 1.d-9
        !          ENDIF
        !          WRITE(*,*) '  -----------> Cloud :'
        !          WRITE(*,*) '  Scatt',ALIN_CLD_S(1,1), ALIN_CLD_S(1,NZ_C)
        !          WRITE(*,*) '  Abs  ',ALIN_CLD_A(1,1), ALIN_CLD_A(1,NZ_C)
        
        !  Reading scattering matrix expansion coefficients
        !  ------------------------------------------------
        FN = DIR_PATH//TRIM(FILE_CLD(3))
        OPEN(C_UNIT, FILE=FN, STATUS='OLD')
        CALL SKIP_HEADER (C_UNIT)
        READ(C_UNIT,*,ERR=300) NVE, NC_CLD
        !           WRITE(*,*) '   NVE    =  ', NVE
        !           WRITE(*,*) '   NC_CLD =  ', NC_CLD
        ALLOCATE( ALIN_CLD_EC(1:NC_CLD,1:NVE) )
        DO I = 1,NC_CLD
           READ(C_UNIT,*,ERR=300) (ALIN_CLD_EC(I,J),J = 1,NVE)
        ENDDO
        IF( NVE > 1 ) ALIN_CLD_EC(:,5:6) = -ALIN_CLD_EC(:,5:6)
        CLOSE(C_UNIT)
        !----------------------------------------------------
        IF( INV_WL ) THEN
           DO I = 1,NZ_C
              ALIN_CLD_S(1:NWL,I) = ALIN_CLD_S(NWL:1:-1,I)
              ALIN_CLD_A(1:NWL,I) = ALIN_CLD_A(NWL:1:-1,I)
           ENDDO
        ENDIF
        !         WRITE(*,*) '   First and last moments of cloud phase matrix'
        !         WRITE(*,'(6(1x,e12.4))') (ALIN_CLD_EC(1,J),J = 1,NVE)
        !         WRITE(*,'(6(1x,e12.4))') (ALIN_CLD_EC(NC_CLD,J),J = 1,NVE)
        
        DO I = 1, NWL
           IF(ALIN_CLD_S(I,1) < 0.d0 .OR. &
                ALIN_CLD_S(I,NZ_C-1) < 0.d0) THEN
              WRITE(LUNIT,*) '   CLD_S for wavelength :', I
              WRITE(LUNIT,*) ALIN_CLD_S(I,1), ALIN_CLD_S(I,NZ_C-1)
              WRITE(LUNIT,*) ALIN_CLD_S(I,2), ALIN_CLD_S(I,NZ_C)
           ENDIF
        ENDDO
        DO I = 1, NWL
           IF(ALIN_CLD_A(I,1) < 0.d0 .OR. &
                ALIN_CLD_A(I,NZ_C-1) < 0.d0) THEN
              WRITE(LUNIT,*) '   CLD_A for wavelength :', I
              WRITE(LUNIT,*) ALIN_CLD_A(I,1), ALIN_CLD_A(I,NZ_C-1)
              WRITE(LUNIT,*) ALIN_CLD_A(I,2), ALIN_CLD_A(I,NZ_C)
           ENDIF
        ENDDO
     ENDIF  ! Reading cloud
     
!           WRITE(*,*) '  --------- CLD S ------------------- '
!           DO I = 1, Nz_C
!              IF( ALIN_CLD_S(1,I) == 0.d0 ) CYCLE
!              WRITE(*,'(2x,F8.3,*(2x,e15.7))') &
!                   ALIN_Z(I), ALIN_CLD_S(:,I)
!           ENDDO
!           WRITE(*,*) '  --------- CLD A ------------------- '
!           DO I = 1, Nz_C
!              IF( ALIN_CLD_A(1,I) == 0.d0 ) CYCLE
!              WRITE(*,'(2x,F8.3,*(2x,e15.7))') &
!                   ALIN_Z(I), ALIN_CLD_A(:,I)
!           ENDDO
!           PAUSE
     !      STOP 'STOP in "READ_ALIN.F"'
     
     CALL ST_TRACK (R_NAME, 1, 'O')
     RETURN
     
101  CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Reading error')
     WRITE(EU,*) '    Parameter to read: ', STR_INP
     RETURN 1
     
300  CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Error reading data file')
     WRITE(EU,*) '    File: ', FN
     RETURN 1
     
301  CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Error reading data file')
     WRITE(EU,*) '    File: ', FN
     WRITE(EU,*) '    Number of elements in this file is '
     WRITE(EU,'(A,1x,I5)') '    greater than ', MAX_READ
     WRITE(EU,*) '    Enhance number of parameter MAX_READ'
     WRITE(EU,*) '    in file "read_alin.f" (see "gt_fileread.f")'
     RETURN 1
     
302  CALL WRITE_MESSAGE(R_NAME,'ERROR','Error in data file')
     WRITE(EU,*) '    File: ', TRIM(FN)
     WRITE(EU,*) '    Number of altitudes or wavelengths in this file '
     WRITE(EU,*) '    does not match these in previous ones. '
     RETURN 1
     
880  WRITE(EU, *) ' ---> Called by '//TRIM(R_NAME)
     RETURN 1
   END SUBROUTINE READ_ALIN
   !***********************************************************************

   SUBROUTINE OT_to_COEF(NWL, NZ, AIO, ZZZ)
     USE TYPES, ONLY: KND
     
     INTEGER, INTENT(IN) :: NWL, NZ
     REAL (KND)  AIO(NWL,NZ), ZZZ(NZ)
     ! Local parameters
     INTEGER I, J
     REAL (KND)  HH(NZ)
     ! ------------------------------------------------------------------
     DO I = 1, NWL
        HH(:) = AIO(I,:)
        ! HH(2) = 2.d0*ALIN_RAY(I,2)/(ALIN_Z(1) - ALIN_Z(2))
        ! HH(1) = 0.d0
        HH(1) = 2.d0*AIO(I,2)/(ZZZ(1) - ZZZ(2))/2.d0
        HH(2) = HH(1)
        DO J = 3, NZ
           HH(J) = 2.d0*AIO(I,J)/(ZZZ(J-1) - ZZZ(J)) - HH(J-1)
        ENDDO                  !  over altitude (J)
        AIO(I,:) = HH(:)
     ENDDO                     ! over wavelengths (I)
   END SUBROUTINE OT_to_COEF
   ! **********************************************************************
   
   SUBROUTINE READ_COMP(N1, N2, ARR, FN, NZ, NWL, INV, WL_ALT, *)

     USE TYPES, ONLY: KND

     INTEGER, INTENT(IN) :: N1, N2, NZ, NWL
     CHARACTER (LEN=*) FN, WL_ALT
     LOGICAL  INV
     REAL (KND) ARR(N1,N2)
     ! Local variables
     CHARACTER (LEN = *), PARAMETER :: R_NAME = 'READ_COMP'
     INTEGER  D1, D2
     
     OPEN(C_UNIT, FILE=TRIM(FN), STATUS='OLD')
     CALL SKIP_HEADER (C_UNIT)
!         READ(C_UNIT,*,ERR=300) 
     READ(C_UNIT,*,ERR=300) D1, D2
     !         WRITE(*,*)  D1, D2
     IF( D1 /= NZ .OR. D2 /= NWL ) GOTO 302
     SELECT CASE( WL_ALT )
     CASE('Row_Col')
        DO I = 1,NWL
           READ(C_UNIT,*,ERR=300) (ARR(I,J),J = 1,NZ)
        ENDDO
     CASE('Col_Row')
        DO J = 1,NZ
           READ(C_UNIT,*,ERR=300) (ARR(I,J),I = 1,NWL)
        ENDDO
     END SELECT

     IF( INV ) THEN
        DO I = 1,NWL
           ARR(I,1:NZ) = ARR(I,NZ:1:-1)
        ENDDO
     ENDIF
     CLOSE(C_UNIT)
     
     RETURN

300  CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Error reading data file')
     WRITE(EU,*) '    File: ', FN
     RETURN 1
     
302  CALL WRITE_MESSAGE(R_NAME,'ERROR','Error in data file')
     WRITE(EU,*) '    File: ', FN
     WRITE(EU,*) '    Number of altitudes or wavelengths in this file '
     WRITE(EU,*) '    does not match these in previous ones. '
     RETURN 1

   END SUBROUTINE READ_COMP
   !***********************************************************************
   SUBROUTINE DEALLOCATE_ARRAYS
      
     IF(ALLOCATED(BAND_START)) DEALLOCATE(BAND_START, BAND_STEP, BAND_NUM)
     IF(ALLOCATED(WL_RR)) DEALLOCATE(WL_RR)
     IF(ALLOCATED(PROF_FILES)) DEALLOCATE(PROF_FILES)
     IF(ALLOCATED(PROF_CDF)) DEALLOCATE(PROF_CDF)
     IF(ALLOCATED(ABS_COEFF_TEMP)) DEALLOCATE(ABS_COEFF_TEMP, X_SECTION_FILE)
     IF(ALLOCATED(IDM)) DEALLOCATE(IDM, LDM, Finc)
     IF(ALLOCATED(HR_SEG_WL)) DEALLOCATE(HR_SEG_WL)
     IF(ALLOCATED(ADD_OT)) DEALLOCATE(ADD_OT, AOT_MAL)
     IF(ALLOCATED(OWL_AER)) DEALLOCATE(OWL_AER)
     IF(ALLOCATED(Nc_der)) DEALLOCATE(Nc_der, Ainc)
     IF(ALLOCATED(ALB_WEI)) DEALLOCATE(ALB_WEI)
     IF(ALLOCATED(PROF_LABELS)) DEALLOCATE(PROF_LABELS, PROF_UNITS, PROF_NCZ,&
          PROF_NCV)
     IF(ALLOCATED(GAS_LABELS_PC)) DEALLOCATE(GAS_LABELS_PC, DO_TROP, &
          GAS_IDX_PC, ALT_GRID_NAME_PC, PROFILE_NAME_PC, CONST_PROF)
     IF(ALLOCATED(ALIN_Z)) DEALLOCATE(ALIN_Z, ALIN_WL)
     IF(ALLOCATED(ALIN_ABS)) DEALLOCATE(ALIN_ABS)
     IF(ALLOCATED(ALIN_RAY)) DEALLOCATE(ALIN_RAY)
     IF(ALLOCATED(ALIN_RAY_EC)) DEALLOCATE(ALIN_RAY_EC)
     IF(ALLOCATED(ALIN_AER_S)) DEALLOCATE(ALIN_AER_S)
     IF(ALLOCATED(ALIN_AER_A)) DEALLOCATE(ALIN_AER_A)
     IF(ALLOCATED(ALIN_AER_EC)) DEALLOCATE(ALIN_AER_EC)
     IF(ALLOCATED(ALIN_CLD_S)) DEALLOCATE(ALIN_CLD_S)
     IF(ALLOCATED(ALIN_CLD_A)) DEALLOCATE(ALIN_CLD_A)
     IF(ALLOCATED(ALIN_CLD_EC)) DEALLOCATE(ALIN_CLD_EC)
     IF(ALLOCATED(DGF_PAR)) DEALLOCATE(DGF_PAR)
     IF(ALLOCATED(Sur_Emis)) DEALLOCATE(Sur_Emis)

     RETURN
   END SUBROUTINE DEALLOCATE_ARRAYS

   !***********************************************************************
 END SUBROUTINE 
 !***********************************************************************

SUBROUTINE FIND_GAS (INPUT_LABEL, GAS_IDX, *)
  use Info,      Only: TG_INFO
  USE LOG_PARS,  ONLY: EU
  USE TOOLS,     ONLY: UPPER_LOWER_CASE

  INTEGER           GAS_IDX, I
  CHARACTER (LEN=*) INPUT_LABEL
  CHARACTER (LEN=*), PARAMETER :: R_NAME = 'FIND_GAS'

  CALL UPPER_LOWER_CASE (INPUT_LABEL,'U2L')
 
  GAS_IDX = 0
  DO I = 1, Size(TG_INFO)
     IF(Trim(TG_INFO(I)%Name) == TRIM(INPUT_LABEL)) THEN
        GAS_IDX = I
        RETURN
     END IF
  END DO

  CALL WRITE_MESSAGE(R_NAME, 'ERROR', 'Gas label not found')
  WRITE(EU,*) '    Selected value is: ', TRIM(INPUT_LABEL)
  
  RETURN 1
END SUBROUTINE FIND_GAS

!**************************************************************************
SUBROUTINE NOT_FOUND (R_NAME, PAR, SEL_VAL, *)
  USE LOG_PARS, ONLY : EU
  CHARACTER (LEN = *) R_NAME, PAR, SEL_VAL

  CALL WRITE_MESSAGE(R_NAME, 'ERROR', ' ')
  WRITE(EU,*) '     Input value is not recognized.'
  WRITE(EU,*) '     Input parameter : ', TRIM(PAR)
  WRITE(EU,*) '     Selected value  : ', TRIM(SEL_VAL)

  RETURN 1
END SUBROUTINE NOT_FOUND

!**************************************************************************
!     find the day of the year from the date.
SUBROUTINE DMT_TO_DOY(DAY, MONTH, YEAR, DOY)

  INTEGER  DOY, YEAR, MONTH, DAY, LP
  INTEGER  MNDYS(12)
  MNDYS = (/0,31,59,90,120,151,181,212,243,273,304,334/)

  IF ( MOD(YEAR,400) == 0 .OR. &
       (MOD(YEAR,4) == 0 .AND. MOD(YEAR,100) /= 0) ) THEN
     LP = 1
  ELSE
     LP = 0
  END IF

  DOY = MNDYS(MONTH) + DAY
  IF ( MONTH > 2 ) DOY = DOY + LP
  
  RETURN
END SUBROUTINE DMT_TO_DOY

!**************************************************************************
SUBROUTINE WRITE_STRING (STR)
  USE LOG_PARS, ONLY: L_S, L_E, L_U
  Use Tools,    Only: WriteOut
  CHARACTER (LEN = *) STR
  INTEGER             I

  DO I = L_S, L_E
     Call WriteOut (L_U(I), TRIM(STR))  
  END DO
  
  RETURN
END SUBROUTINE WRITE_STRING

!**************************************************************************
DOUBLE PRECISION FUNCTION MATTHEWS_ALBEDO(LATI, LONG, DAY_OF_YEAR)
  USE LOG_PARS, ONLY: C_UNIT
  USE ST_INPUT, ONLY: ALBEDO_DB_PATH

  CHARACTER (LEN=7)   MONTH_NAMES(4)
  CHARACTER (LEN=:), ALLOCATABLE :: FILE_NAME
  INTEGER             YEAR, MONTH, DAY, DAY_OF_YEAR
  INTEGER             IDXLON_PRE, IDXLAT, IDXLON, SEASON, I, J
  DOUBLE PRECISION    LATI, LONG
  DOUBLE PRECISION    AL(360,180)
  DATA MONTH_NAMES /'January', 'April', 'July', 'October'/
  !==================================================================

  CALL CALDAY (DAY_OF_YEAR, YEAR, MONTH, DAY )

  IDXLAT = MIN(91 + FLOOR(LATI), 180)
  IDXLON_PRE = 1 + FLOOR(LONG)
  SELECT CASE (IDXLON_PRE)
  CASE(:180)
     IDXLON = IDXLON_PRE + 180
  CASE(181:)
     IDXLON = IDXLON_PRE - 180
  END SELECT
  
  SELECT CASE(MONTH)
  CASE(1,2,12)
     SEASON = 1
  CASE(3,4,5)
     SEASON = 2
  CASE(6,7,8)
     SEASON = 3
  CASE(9,10,11)
     SEASON = 4
  END SELECT
  
  FILE_NAME = ALBEDO_DB_PATH//'Matthews_Albedo_'//&
       TRIM(MONTH_NAMES(SEASON))//'.dat'
  CALL WRITE_STRING (' *** Albedo file name')
  CALL WRITE_STRING ('     --> '//TRIM(FILE_NAME))
  OPEN(C_UNIT,FILE = FILE_NAME,STATUS='OLD')
  DO J = 1, 180
     READ(C_UNIT,'(20F6.2)') (AL(I, J), I = 1, 360)
  END DO
  CLOSE(C_UNIT)
  MATTHEWS_ALBEDO = AL(IDXLON,IDXLAT)/100.
  
  RETURN
END FUNCTION MATTHEWS_ALBEDO
!**************************************************************************

