C********************************************************************C
C
C	SCIATRAN - Version 1.2.8 - Last modification: 18 Dec 2001
C
C	Copyright (C) - Institute of Remote Sensing,
C			University of Bremen, Germany
C
C********************************************************************C
      SUBROUTINE GT_HEIGHT_GRID_PS (J_IDX, MJU_LOS, Z, NL_NEW, Z_NEW, 
     $     SELECT_IDX, ALT_FLAG, NEW_LEVEL, J_OUT)

      USE GRIDS, ONLY : NL_FINE, Z_FINE, MAX_LINE, NLAYERS
      USE SPHER_CONTROL

      LOGICAL             ALT_FLAG, NEW_LEVEL

      INTEGER             K, II, KK, NL_NEW, I_FP, K_FINE, J_IDX, J_OUT
      INTEGER             J, FL_BELOW, FL_UPPER, SELECT_IDX(MAX_LINE)
      DOUBLE PRECISION    Z, MJU_LOS, Z_NEW(MAX_LINE)

      J = J_IDX
      J_OUT = 0
      NEW_LEVEL = .FALSE.

      IF(ALT_FLAG) THEN         ! User defined altitude
         NEW_LEVEL = .TRUE.
         IF(Z.LE.Z_FINE(1)) THEN
            NEW_LEVEL = .FALSE.
            Z = Z_FINE(1)
            I_FP = NLAYERS + 1
            FL_BELOW = 0
            GOTO 555
         END IF
         IF(Z.GE.Z_FINE(NL_FINE)) THEN
            NEW_LEVEL = .FALSE.
            Z = Z_FINE(NL_FINE)
            I_FP = 2
            FL_UPPER = NL_FINE + 1
            GOTO 555
         END IF

C     Find the first original grid level below the selected altitude
         DO II = NL_FINE, 1, -NN    
            IF(Z_FINE(II).LT.Z) EXIT 
         END DO
C     The number of original grid level below the selected altitude 
         I_FP = NLAYERS - (II - 1)/NN
                      
C     Find the first fine grid level below the selected altitude
         DO FL_BELOW = II + NN, II, -1 
            IF(Z_FINE(FL_BELOW).LT.Z) EXIT 
         END DO

         FL_UPPER = FL_BELOW + 1

C    Check if selected altutude is too close to grid level
         IF(Z - Z_FINE(FL_BELOW).LT.1.0D-3) THEN
            Z = Z_FINE(FL_BELOW)
            FL_BELOW = FL_BELOW - 1
            NEW_LEVEL = .FALSE.
         END IF
         IF(Z_FINE(FL_UPPER) - Z.LT.1.0D-3) THEN
            Z = Z_FINE(FL_UPPER)
            FL_UPPER = FL_UPPER + 1
            NEW_LEVEL = .FALSE.
         END IF
                 
         J_OUT = I_FP
      END IF

 555  CONTINUE

      IF(MJU_LOS.LT.0.0D0) THEN 
        
         NL_NEW = 0  

         IF(ALT_FLAG) THEN 

            J = I_FP - 1

            IF(NEW_LEVEL) THEN
               Z_NEW(1) = Z
               SELECT_IDX(1) =  FL_BELOW
               NL_NEW = NL_NEW + 1
            END IF
            
            DO KK = FL_BELOW + 1, (NLAYERS - J)*NN
               NL_NEW = NL_NEW + 1
               Z_NEW(NL_NEW) =  Z_FINE(KK)
               SELECT_IDX(NL_NEW) = KK
            END DO
         END IF

         K_FINE = NLAYERS - MIN(I_FINE,MAX(1,J - N_FINE_ST)) + 1
         
         DO II = NLAYERS - J + 1, K_FINE - 1
            DO K = 1, NN
               NL_NEW = NL_NEW + 1
               Z_NEW(NL_NEW) =  Z_FINE((II - 1)*NN + K)
               SELECT_IDX(NL_NEW) = (II - 1)*NN + K
            END DO
         END DO
         DO II = K_FINE, NLAYERS
            NL_NEW = NL_NEW + 1
            Z_NEW(NL_NEW) =  Z_FINE((II - 1)*NN + 1)
            SELECT_IDX(NL_NEW) = (II - 1)*NN + 1
         END DO
         
         RETURN
      END IF

      NL_NEW = 0
      IF(ALT_FLAG) THEN 
         
         J = I_FP
         
         IF(NEW_LEVEL) THEN
            Z_NEW(1) = Z
            SELECT_IDX(1) = FL_BELOW 
            NL_NEW = NL_NEW + 1
            NEW_LEVEL = .TRUE.
         END IF
         
         DO KK = FL_UPPER - 1, (NLAYERS - J)*NN + 2, -1
            NL_NEW = NL_NEW + 1
            Z_NEW(NL_NEW) =  Z_FINE(KK)
            SELECT_IDX(NL_NEW) = KK
         END DO
      END IF
      
      K_FINE = MIN(I_FINE,MIN(NLAYERS,J + N_FINE_ST))
      
      NL_NEW = NL_NEW + 1
      Z_NEW(NL_NEW) =  Z_FINE(NL_FINE - (J - 1)*NN)
      SELECT_IDX(NL_NEW) = NL_FINE - (J - 1)*NN
      DO II = J, K_FINE - 1
         DO K = 1, NN
            NL_NEW = NL_NEW + 1               
            Z_NEW(NL_NEW) =  Z_FINE(NL_FINE - (II - 1)*NN - K)
            SELECT_IDX(NL_NEW) = NL_FINE - (II - 1)*NN - K
         END DO
      END DO
      DO II = MAX(J,K_FINE) + 1, MAX(J,I_FINE)
         NL_NEW = NL_NEW + 1               
         Z_NEW(NL_NEW) =  Z_FINE(NL_FINE - (II - 1)*NN)
         SELECT_IDX(NL_NEW) = NL_FINE - (II - 1)*NN
      END DO
      DO II = MAX(J,I_FINE), NLAYERS - 1
         DO K = 1, NN
            NL_NEW = NL_NEW + 1
            Z_NEW(NL_NEW) =  Z_FINE(NL_FINE - (II - 1)*NN - K)
            SELECT_IDX(NL_NEW) = NL_FINE - (II - 1)*NN - K
         END DO
      END DO
      
      Z = Z_NEW(1)

      RETURN
      END     

C     ********************************************************
