!********************************************************************C
!
!	SCIATRAN - Version 4.2 - Last modification: 12 Oct 2019
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!********************************************************************C
Subroutine Iterate_V2 (MsmtInf, XVec, RegM, RMS1, RMS2)
  ! Called by retrieval.f90
  USE DATA_RET,  ONLY: DO_IMAT, DO_CONSTRAIN, MIN_EVAL, LMD, TihRegMode
  USE INFO,      ONLY: RET_INFO
  USE OutInf,    ONLY: EU, LUNIT, LOG_LEVEL, N_RSO, N_SSO, N_SSO, N_ESO, &
                       DIR_OUT, C_UNIT
  USE RETR_ITER, ONLY: ITERATION
  Use St_Vars,   Only: RET_CORE
  Use Tools,     Only: MatrInvers, OpenOut, WriteOut, CloseOut, Find_Idx
  USE TYPES,     ONLY: KND, XVecType, RegMatrs, MeasInfo
  !------------------------------------------------------------------

  REAL (KND) RMS1, RMS2
  Type (RegMatrs) RegM
  Type (MeasInfo) MsmtInf
  Type (XVecType), Allocatable :: XVec(:)
  ! Local parameters
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'ITERATE'
  Character (Len=50000)  OutStr
  INTEGER  N_RET, N_DATA, I, J, KK, Unt, II, I_RI
  REAL*16  SUM0, SUM1
  REAL*16  KNTISY(Size(XVec),Size(MsmtInf%Ydiff))
  REAL*16, DIMENSION (Size(XVec)) :: AV, RI, KNTISYTMB, Term2
  Real*16, DIMENSION (Size(XVec),Size(XVec)) :: Term1, S_RE, KNTISYKN
  !==================================================================
  
  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE ITERATE_V2
