!****************************************************************************
!
!	SCIATRAN - Version 3.5 - Last modification: 09 Mar 2015
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!****************************************************************************
SUBROUTINE LOG_RATIO (I_DS, I_L, JSEG, J_S, J_E, PP_DAT)
  ! Called by "preprocessing.f"
      
  USE INFO,       ONLY: WF_DB
  USE RTM_OUTPUT, ONLY: SPEC_OUT
  USE TYPES,      ONLY: PREPROC_DATA

  INTEGER  I_DS, I_L, JSEG, J_S, J_E
  TYPE (PREPROC_DATA) PP_DAT

  ! Local parameters
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'LOG_RATIO'
  INTEGER  R_L,   J, NP, II, I_S, I_L, I1, I2, I3
  LOGICAL  LOG_FLG, RTH_FLG
  LOGICAL, POINTER :: MSK(:)
  !==================================================================

  CALL ST_TRACK (R_NAME, 2, 'I')

  MSK => MDS(I_DS)%MASK(:,I_L)

  IF( MDS(I_DS)%RTH_FLG(JSEG)) R_L = MDS(I_DS)%REF_NUM(JSEG)
  LOG_FLG = MDS(I_DS)%LOG_FLG(JSEG)
  RTH_FLG = MDS(I_DS)%RTH_FLG(JSEG)

  PP_DAT(I_DS)%RTM(J_S:J_E,:) = 0.0D0
  IF(RTH_FLG) THEN
     FORALL (I_S = J_S:J_E, MASK(I_S)) PP_DAT%RTM(I_S) = &
          SPEC_OUT(I_S,1,I_L)/SPEC_OUT(I_S,1,R_L)
  ELSE
     FORALL (I_S = J_S:J_E, MASK(I_S)) PP_DAT%RTM(I_S) = SPEC_OUT(I_S,1,I_L)
  END IF

      IF(LOG_FLG) FORALL (I_S = J_S:J_E, I_L = 1:NLO, MASK(I_S, I_L)) 
     $     PP_DAT(I_DS)%RTM(I_S,I_L) = DLOG(PP_DAT(I_DS)%RTM(I_S,I_L))

      FORALL(I_S = J_S:J_E, I_L = 1:NLO, MASK(I_S, I_L)) 
     $     PP_DAT(I_DS)%SY(I_S,I_L) = MDS(I_DS)%SY(I_S,I_L) 
      IF(MDS(I_DS)%RTH_FLG(JSEG).AND.MDS(I_DS)%SNR_CLS(JSEG)) 
     $     FORALL(I_S = J_S:J_E, I_L = 1:NLO, MASK(I_S, I_L)) 
     $     PP_DAT(I_DS)%SY(I_S,I_L) = 
     $     PP_DAT(I_DS)%SY(I_S,I_L) + MDS(I_DS)%SY(I_S,R_L)             
      
      DO KK = 1, UBOUND(WF_DB,1)
         IF(.NOT.ALLOCATED(WF_DB(KK)%PROC)) 
     $        ALLOCATE (WF_DB(KK)%PROC(NDS))
         IF(.NOT.ALLOCATED(WF_DB(KK)%PROC(I_DS)%WF)) THEN
            I1 = SIZE(WF_DB(KK)%WF,1) ; I2 = SIZE(WF_DB(KK)%WF,2)
            I3 = SIZE(WF_DB(KK)%WF,3)
            ALLOCATE(WF_DB(KK)%PROC(I_DS)%WF(I1,I2,I3))
         END IF
         WF_DB(KK)%PROC(I_DS)%WF(J_S:J_E,:,:) = 0.0D0
         IF(LOG_FLG.OR.MDS(I_DS)%RTH_FLG(JSEG)) THEN
            FORALL (I_S=J_S:J_E, I_L=1:NLO,MSK_RTM(I_S,I_L)) 
     $           WF_DB(KK)%PROC(I_DS)%WF(I_S,I_L,:) = 
     $           WF_DB(KK)%WF(I_S,I_L,:,1)/SPEC_OUT(I_S,1,I_L)
         ELSE
            FORALL (I_S = J_S:J_E, I_L = 1:NLO, MASK(I_S, I_L)) 
     $           WF_DB(KK)%PROC(I_DS)%WF(I_S,I_L,:) = 
     $           WF_DB(KK)%WF(I_S,I_L,:,1)
         END IF

         IF(MDS(I_DS)%RTH_FLG(JSEG)) THEN
            FORALL (I_S = J_S:J_E, I_L = 1:NLO, MASK(I_S, I_L)) 
     $           WF_DB(KK)%PROC(I_DS)%WF(I_S,I_L,:) = 
     $           WF_DB(KK)%PROC(I_DS)%WF(I_S,I_L,:) -          
     $           WF_DB(KK)%PROC(I_DS)%WF(I_S,R_L,:)
            IF(.NOT.LOG_FLG) THEN
               FORALL (I_S=J_S:J_E, I_L=1:NLO, MASK(I_S, I_L)) 
     $              WF_DB(KK)%PROC(I_DS)%WF(I_S,I_L,:) = 
     $              WF_DB(KK)%PROC(I_DS)%WF(I_S,I_L,:)*
     $              SPEC_OUT(I_S,1,I_L)/SPEC_OUT(I_S,1,R_L)
            END IF
         END IF
      END DO

C***********************************************************************
