!***************************************************************************
!
!       SCIATRAN - Version 3.5 - Last modification: 05 May 2015
!
!       Copyright (C) - Institute of Remote Sensing,
!                       University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE PREPROC_INIT (I_DS, JSEG, I_L, J_S, J_E, NP, LCD, PP_DAT, *)
  ! Called by "preprocessing.f"

  USE CLOUDS,      ONLY: J_BOT, J_TOP
  USE CLOUDS_RETR, ONLY: GCP
  USE DATA_RET,    ONLY: MDS
  USE GRIDS,       ONLY: ZZZ, NLAYERS
  USE INFO,        ONLY: WF_DB, STATE, RET_INFO
  USE LOG_PARS,    ONLY: EU
  USE ST_VARS,     ONLY: RET_MODE
  USE TOOLS,       ONLY: INQ_WF
  USE TYPES,       ONLY: KND, LOCAL_DATA, PREPROC_DATA
  
  INTEGER  I_DS, JSEG, I_L, J_S, J_E, NP
  TYPE (PREPROC_DATA), TARGET :: PP_DAT
  TYPE (LOCAL_DATA), TARGET :: LCD
  ! Local variables
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'PREPROC_INIT'
  INTEGER  I_S, I_E, JPOS, I_RI, I_ST, I_SBP, NN
  INTEGER  Ncl, Jc, Je, Js, JJ
  LOGICAL  W_FLG
  REAL (KND)  Z_t, Z_b, TMP(NLAYERS)
  REAL (KND), ALLOCATABLE :: WF_LOC(:), Z_LOC(:), WEIGHT(:)
  !==================================================================
  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE PREPROC_INIT
