!***********************************************************************
!
!	SCIATRAN - Version 4.0 - Last modification: 14 Feb 2019
!	Copyright (C) - Institute of Remote Sensing,
!		        University of Bremen, Germany
!
!********************************************************************C
SUBROUTINE QP_SOLV(N_X, N_Y, YDIFF, KN, XDIFF, XA, RMS1, SQ_RTB, *)
!     ... Called  by "retrieval.f90"
  USE LOG_PARS,  ONLY: LUNIT
  USE TYPES,     ONLY: KND
  INTEGER  N_X, N_Y
  REAL (KND) RMS1, SQ_RTB
  REAL (KND) XDIFF(N_X), YDIFF(N_Y), KN(N_Y,N_X), XA(N_X)
  !  ==================================================================

  WRITE(LUNIT,*) 'This mode requires the GALAHAD Quadratic Programming '&
       //'library, please refer to http://galahad.rl.ac.uk/galahad-www/'
  CALL WRITE_MESSAGE('SHI_SQU', 'ERROR', 'This mode requires the GALAHAD '//&
       'Quadratic Programming library, please refer to '//&
       'http://galahad.rl.ac.uk/galahad-www/')

!********************************************************************C
END SUBROUTINE QP_SOLV
! ********************************************************************
