!********************************************************************C
!
!       SCIATRAN - Version 4.2 - Last modification: 16 Oct 2019
!
!       Copyright (C) - Institute of Remote Sensing,
!                       University of Bremen, Germany
!
!********************************************************************C
SUBROUTINE READ_RET_DATA (IDS, ADD_NOISE, NOISE_AMP, N_GAUSS, *)
!     ... Called by in "read_ret_main.f90"      

  USE BRDF,        ONLY: Use_LRC
  USE CLOUDS_RETR, ONLY: RET_STATUS, CLD_SCENE, Lower_ref, RET_QUALITY
  USE DATA_RET,    ONLY: MDS, CORR_SP, WL_MDS, AVG_RTM, N_svc
  USE INFO,        ONLY: AUX_INFO
  USE IRRAD,       ONLY: SOLAR_HR, WL_SOL_HR, N_SOL_HR, SOL_HR_FILE 
  USE LOG_PARS,    ONLY: LUNIT, EU, C_UNIT
  USE ST_VARS,     ONLY: RET_MODE, RAD_TO_DEG, Pie, NSEGS, WL_SEGS, MSK_RTM
  USE SPHER_PARS,  ONLY: N_LOS_OUT, ANG_OUT, NLO => N_LOS_OUT, ANG_ORIG
  USE TOOLS,       ONLY: READ_FILE, AKIMA_INIT, AKIMA_FIN, AKIMA_VARS, &
                         AVERAGE, ErrMsg 
  USE TYPES,       ONLY: KND, Dyn_Char
  
  INTEGER  IDS, N_GAUSS
  LOGICAL  ADD_NOISE
  REAL (KND)  NOISE_AMP

  ! Local variables:
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'READ_RET_DATA'
  Character (Len=10) StrTmp
  LOGICAL  FLG
  LOGICAL, ALLOCATABLE :: IDX_SEL(:), MASK(:), MSK_LOC(:)
  INTEGER  N_READ, N_SEL, N_AV, N_WL, I, J_S, J_E, JSEG, N_LOS_READ, K, &
       N_REF, N_EXP, II, N_CRS_L, NE, NN, KK, R_L, I_SP, I_L, N_1, N_2, &
       N_INP, JI_1, JI_2, JE_1, JE_2, DIM, I_S, I_E
  REAL (KND)  Refl, cgauss, TMP, WL_S, WL_E, WL_1, WL_2, WL_AV(1), DLT
  REAL (KND), ALLOCATABLE :: WL_R(:), DATA_R(:,:), WL_OUT(:), DATA_OUT(:,:), & 
       NOISE(:), WL_SY(:), DATA_SY(:,:), AV_DAT(:), DATA_OUT_V(:,:,:)
  REAL (KND), ALLOCATABLE, TARGET ::  WL_INP(:)
  REAL (KND), POINTER :: WL_EXP(:), WL_SRC(:)
  TYPE (AKIMA_VARS), ALLOCATABLE :: AKI_DAT(:)
  Type(Dyn_Char), Allocatable :: Msg(:)

  TYPE DATA_SELECTION
     REAL (KND), ALLOCATABLE :: WL(:), VALS(:,:), SOL_SPEC(:,:)
     LOGICAL, ALLOCATABLE ::  IDX_SEL(:)
  END TYPE DATA_SELECTION
  TYPE (DATA_SELECTION), ALLOCATABLE :: D_SEL(:)

  TYPE Linked_List_Entry
     LOGICAL MSK
     REAL (KND) WL, WL_1, WL_2
     REAL (KND), ALLOCATABLE :: DATA(:)
     TYPE (LINKED_LIST_ENTRY), POINTER :: NEXT_ELEM
  END TYPE Linked_List_Entry
  TYPE (LINKED_LIST_ENTRY), POINTER :: FIRST_ELEM, ELEMENT => NULL()

  EXTERNAL  CGAUSS
  !==================================================================
  
  CALL ST_TRACK (R_NAME, 3, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE READ_RET_DATA
