!***************************************************************************
!
!	SCIATRAN - Version 4.0 - Last modification: 18 Dec 2018
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE READ_RET_MAIN (*)
! Called by "gt_iface.f" if RET_FLAG = .TRUE.

  USE AER_MIE,    ONLY: Sph_Name
  USE AEROSOLS,   ONLY: EXA_OUT_FLAG
  USE ALB_PARS,   ONLY: Nc_ALB, ALB_REF, N_Lca, WL_Lca, V_Lca, GR_Lca, F_ave
  USE CLD_RET,    ONLY: CTH_CRIT
  USE DATA_RET,   ONLY: MDS, V_INV_FLG, DOUBLET_FLAG, LER_MIN, LER_MAX, &
                        ALB_MIN, ALB_MAX, ALB_CRIT, PRE_MIN, PRE_MAX, &
                        PRE_CRIT, TEMP_MIN, TEMP_MAX, TEMP_CRIT
  USE INFO,       ONLY: AUX_INFO, PAR_INFO, TG_INFO, AER_INFO, CLD_INFO, &
                        RET_INFO
  USE OutInf,     ONLY: LOG_LEVEL, L_S, L_E, L_U, LUNIT, N_SSO, EU, Work_Dir, LUF
  USE RTM_OUTPUT, ONLY: TRANS_OUT
  USE SPHER_PARS, ONLY: NLO => N_LOS_OUT
  USE ST_VARS,    ONLY: NSEGS, WL_SEGS, RTM_MODE, WF_FLAG, RET_MODE, RTM_CORE, &
                        GROUND_HEIGHT, RTM_TYPE
  USE TOOLS,      ONLY: READ_INPUT, CUT_STR, FIND_IDX, INQ_WF, CHK_STAT, WriteOut
  USE TYPES,      ONLY: KND, DYN_CHAR 

  ! Local variables
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'READ_RET_MAIN'
  INTEGER  N_GAUSS, II, N_DS, KK, K, IDS
  LOGICAL  ADD_NOISE, FLG
  CHARACTER (LEN=:),   ALLOCATABLE :: STR_INP
  TYPE (DYN_CHAR), ALLOCATABLE :: STR_ARR(:), READ_ARR(:), STR_ARR_1(:)
  REAL (KND) NOISE_AMP
  !==================================================================
  CALL ST_TRACK (R_NAME, 3, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE READ_RET_MAIN
