!***************************************************************************
!
!	SCIATRAN - Version 4.5 - Last modification: 18 Aug 2021
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE READ_RET_SDP (NSEGS, *)

  USE DATA_RET,   ONLY: CORR_SP, MDS, DOUBLET_FLAG, AVG_RTM, FLG_OUTL, &
                        ITER_OUTL, CRIT_OUTL, LP_Mode
  USE INFO,       ONLY: AUX_INFO
  USE IRRAD,      ONLY: SOL_HR_FILE
  USE LOG_PARS,   ONLY: EU, Work_Dir
  Use Pol_Corr,   Only: PolCorrPath => Path, PolCorrFlg => Flg
  USE SPHER_PARS, ONLY: N_LOS_OUT, ANG_SEL_FLAG, N_AZ_ANG
  USE ST_VARS,    ONLY: RET_MODE
  USE TOOLS,      ONLY: FIND_MATCHES, SET_PATH, SPLIT_STRING, &
                        GET_CONTROL_PARS, UPPER_LOWER_CASE, CUT_STR, &
                        Read_Input, Read_OptCDF, Read_LineCDF
  USE TYPES,      ONLY: KND, DYN_CHAR, ArrChar

  INTEGER  NSEGS

  ! Local variables
  CHARACTER (LEN=*),     PARAMETER :: R_NAME = 'READ_RET_SDP'
  CHARACTER (LEN=:),   ALLOCATABLE :: STR_INP, AddStr
  CHARACTER (LEN=10)   NUM_STR(NSEGS)
  CHARACTER (LEN=3)    SNR_CONV
  INTEGER  II, I, KK, JJ, IX1, IX2, NN, N_DS, NP, JSEG, MM
  LOGICAL  SOL_FLAG, REF_FLAG, NOREF_FLAG, FLG, READ_AVG
  LOGICAL, ALLOCATABLE :: FLAG_TMP(:,:)
  REAL (KND), ALLOCATABLE :: WL_REJ(:,:)
  TYPE (DYN_CHAR), ALLOCATABLE :: STR_ARR(:), STR_ARR_1(:), STR_ARR_2(:) 
  TYPE (DYN_CHAR), ALLOCATABLE :: READ_ARR(:)
  TYPE (ArrChar), ALLOCATABLE :: ReadStc(:)
  TYPE (DYN_CHAR) STR_SEG(NSEGS) 
  !==================================================================
  CALL ST_TRACK (R_NAME, 3, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE READ_RET_SDP
