!***************************************************************************
!
!	SCIATRAN - Version 4.1 - Last modification: 18 Feb 2019
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE RET_CONTROL (NSEGS, ADD_NOISE, NOISE_AMP, N_GAUSS, *)
  ! Called by "scia_exp_read.f":
      
  USE AER_MIE,    ONLY: LAS_mi, ALL_PIX, Sph_Name, AOD_RET, DIF_RET, Dif_885, Ac_par
  USE ALB_PARS,   ONLY: Nc_ALB
  USE CLD_RET,    ONLY: GT_MIN, GT_MAX, Lower_ref, CTH_CRIT, GCP, Ngp_CLD, CTH_MIN, &
                        CTH_MAX, CBH_MIN, CBH_MAX
  USE DATA_RET,   ONLY: TIH_FLAG, ITERATIONS_LIMIT, DO_CONSTRAIN, MIN_EVAL, &
                        RCOR, DO_IMAT, MOD_READ_FLAG, MOD_DIR, CRIT_RMS, CRIT_PAR, &
                        MAIN_GAS, Z_CU, Z_CL, Calibr_mult, PRESET_APR_NAME, MDS, &
                        RET_FORM, DOUBLET_FLAG, KEEP_APR, APR_ADD, TR_ADD, LMD, &
                        TihRegMode
  USE GRIDS,      ONLY: ZZZ_INP
  USE INFO,       ONLY: RET_INFO, PAR_INFO, TG_INFO, AER_INFO, CLD_INFO, AUX_INFO
  USE LOG_PARS,   ONLY: LUNIT, EU, L_S, L_E, N_SSO, LOG_LEVEL, Work_Dir
  USE RETR_ITER,  ONLY: RMS_ALL, MAX_OSC, RMS_OSC, P_MIN, AOD_ITER, SCAL_APR, &
                        MIN_TAU
  USE RTM_PARS,   ONLY: MAX_ITER
  USE RTM_OUTPUT, ONLY: EXA_T_FLG
  USE ST_VARS,    ONLY: RTM_MODE, RET_MODE, WF_FLAG, WL_SEGS, RET_CORE, &
                        GROUND_HEIGHT
  USE SPHER_PARS, ONLY: N_LOS_OUT, LOS_ANG, LOS_DEF_FLAG
  USE TOOLS,      ONLY: FIND_IDX, FIND_MATCHES, CHK_STAT, UPPER_LOWER_CASE, &
                        SET_PATH, SPLIT_STRING, Read_Input, IsPar, CUT_STR
  USE TYPES,      ONLY: KND, DYN_CHAR, RET_PARAMS

  INTEGER     NSEGS, N_GAUSS
  LOGICAL     ADD_NOISE
  REAL (KND)  NOISE_AMP
  
  ! Local parameters
  CHARACTER (LEN=*), PARAMETER :: R_NAME = 'RET_CONTROL'

  INTEGER  II, NN, KK, NGP_INFO, IND, N_CHECK, N_ADD, KK_1, KK_2, KK_3, IX1,&
       NDS, IDS, I_M1, I_M2, I_M, I_RI, I_MDS, I_NXT, PAR_IDX, DIM, IK, LK, &
       I_SHIFT, I_READ, I1, I2, I_PAR
  LOGICAL  PRESET_APR_FLAG, READ_NXT, WRT_PARS
  LOGICAL, ALLOCATABLE :: TMP_FLAG(:), PAR_FLG(:), FLG_TMP(:)
  CHARACTER (LEN=:),  ALLOCATABLE :: STR_INP, STR_READ
  CHARACTER (LEN=10), POINTER :: CHECK_STR(:)
  CHARACTER (LEN=30), ALLOCATABLE :: OUT_STR(:), OUT_STR_1(:)
  REAL (KND)  Z_M
  TYPE (DYN_CHAR), ALLOCATABLE :: STR_ARR(:), STR_ARR_1(:), READ_ARR(:)
  !=========================================================================
  CALL ST_TRACK (R_NAME, 3, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE RET_CONTROL
