C********************************************************************C
C
C	SCIATRAN - Version 3.4 - Last modification: 15 Jan 2015
C
C	Copyright (C) 1995-2013, Institute of Remote Sensing,
C			         University of Bremen, Germany
C
C********************************************************************C
      SUBROUTINE RET_CTH_OUTPUT(RMS_NEW, *)

      USE ST_VARS,  ONLY: GROUND_HEIGHT, LATITUDE, LONGITUDE, RAD_TO_DEG
      USE SPHER_PARS, ONLY: ANG_OUT
      USE CLD_RET,    ONLY: CFR, RET_STATUS, CLD_SCENE, RET_QUALITY
      USE CLOUDS,     ONLY: CLD_LAYER_HEIGHTS, TAU_CLD_INP
      USE LOG_PARS,   ONLY: DIR_OUT, C_UNIT, EU
      USE ALB_PARS,   ONLY: ALBEDO_CONST

      CHARACTER (LEN = 14), 
     $     PARAMETER :: R_NAME = 'RET_CTH_OUTPUT'
      DOUBLE PRECISION    RMS_NEW, TMP1, TMP2, SUNZEN

      SUNZEN = DACOS(ANG_OUT(1,1))*RAD_TO_DEG
      write(*,*) '  .... RET_STATUS :', RET_STATUS
      IF( .NOT. RET_STATUS ) THEN
         TMP1 = 0.0d0 
         OPEN(C_UNIT,file=DIR_OUT//'/ret_parameter.dat')
             WRITE(C_UNIT,1000) LATITUDE, LONGITUDE, GROUND_HEIGHT,
     $        ALBEDO_CONST,
     $        SUNZEN, TAU_CLD_INP(1,1), TMP1, TMP1, TMP1, TMP1, TMP1,
     $        TRIM(CLD_SCENE), TRIM(RET_QUALITY)
         CLOSE(C_UNIT)
         WRITE(EU, *) ' ---> No retrieval '//TRIM(R_NAME)
         RETURN 1
      ENDIF
      
      OPEN(C_UNIT,file=DIR_OUT//'/ret_parameter.dat')
         TMP1 = CLD_LAYER_HEIGHTS(1,1)
         TMP2 = CLD_LAYER_HEIGHTS(1,2)
         WRITE(C_UNIT,1000) LATITUDE, LONGITUDE, GROUND_HEIGHT,
     $     ALBEDO_CONST,
     $     SUNZEN, TAU_CLD_INP(1,1), TMP1, TMP2, TMP2-TMP1, CFR, 
     $     RMS_NEW, TRIM(CLD_SCENE), TRIM(RET_QUALITY)
      CLOSE(C_UNIT)

      OPEN(C_UNIT,file=DIR_OUT//'/ret_cbh_cth.dat')
         WRITE(C_UNIT,'(2(2x,f7.3))')  
     $     CLD_LAYER_HEIGHTS(1,1), CLD_LAYER_HEIGHTS(1,2)
      CLOSE(C_UNIT)

c               lat     lon      gh, alb     sza      tau    cbh,cth,gt  
 1000 FORMAT(2x,f6.2, 1x,f7.2, 2(1x,f6.2), 1x,f6.2, 1x,f6.2, 3(1x,f6.2),
c            cfr       rms     scene  Discr
     $     1x,f5.2,  1x,e12.4, 1x,a, 2x,a )

       RETURN

      END
