!*********************************************************************
!
!	SCIATRAN - Version 4.5 - Last modification: 16 Feb 2022
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!*********************************************************************
SUBROUTINE RET_RESULTS (XVec, NEXT_ITER, NEW_ALT_GRID, *)
  !    ... Called by "retrieval.f90"

  USE ABSORBERS, ONLY: N_ST_MOL
  USE AEROSOLS,  ONLY: AER_RET_FACTOR, FACTOR_EXA_S, EXA_RET, EXA_RET_WL, &
                       LA_S, LA_E, LA_Ndb, LA_Nmi, Plus_mi
  USE AER_MIE,   ONLY: NAC, AOD_RET
  USE ALB_PARS,  ONLY: ALBEDO_RET, ALBEDO_CONST, Nc_ALB
  USE BRDF,      ONLY: RLC_RET
  USE CLD_RET,   ONLY: NEW_CLD
  USE DATA_RET,  ONLY: PRESET_APR_NAME, TPS_NAME, FACTOR_TPS_COL, ALLOW_END,&
                       DOUBLET_FLAG
  USE FLU_LAND,  ONLY: DGF_PAR, CONVERT_AMP
  USE GRIDS,     ONLY: NLAYERS, ZZZ
  USE INFO,      ONLY: TG_INFO, RET_INFO, STATE
  USE NODES,     ONLY: READ_NODES, NEW_NODES
  USE OutInf,    ONLY: EU, LUNIT, DIR_OUT, LOG_LEVEL, N_ZSO, N_SSO, OutMode
  USE PROFILES,  ONLY: AIR_DENSITY, PRESS, TEMP
  USE PRO_SAIL,  ONLY: LAI, Cbrown, Cm, Cab, Car, Stc, Cw, LIDFa, Psoil
  USE RETR_ITER, ONLY: TG_SCALE_FLAG, ITERATION, TG_SF, Z_PRE, GHS, NL_PRE, &
                       ELEV_END, RMS_ALL, AOD_ITER
  USE RTM_PARS,  ONLY: DATA_ITER
  USE ST_INPUT,  ONLY: AER_PAR_TYPE
  USE ST_VARS,   ONLY: GROUND_HEIGHT, TP_HEIGHT, R_GH, EARTH_RADIUS,  &
                       RET_CORE, RET_MODE, SURF_TYPE
  USE TOOLS,     ONLY: FIND_IDX, SET_PTR, OpenOut, WriteOut, CloseOut , Inq_Wf
  USE TYPES,     ONLY: KND, XVecType
  !------------------------------------------------------------------

  LOGICAL  NEXT_ITER, NEW_ALT_GRID
  Type (XVecType), Allocatable :: XVec(:)
  ! Local parameters
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'RET_RESULTS'
  Character (Len=500)  OutStr
  Logical  Flg
  INTEGER  J_1, J_2, KK, II, LL, IDX, J, I, K, I_1, I_2, I_SEG, JJ, &
           I_S, I_E, I_RI, I_ALB, I_AER, Jlow, Jhigh, LAN, CU, Unt
  REAL (KND)  ALB_NEW, GH, ELEV_MAX, DH, WL_S, WL_E, HH, FACTOR_AER_EXT
  REAL (KND)  PrcApr(Size(State),Nlayers), PrcRes(Size(State),Nlayers)
  TYPE (DATA_ITER), POINTER :: RTM_PTR, RTM_PTR_K
  !==================================================================

  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE RET_RESULTS
