!***************************************************************************
!
!	SCIATRAN - Version 4.2 - Last modification: 07 Oct 2019
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!****************************************************************************
SUBROUTINE RETR_AOD (N_X, XDIFF, PP_DAT)

  USE AEROSOLS,   ONLY: AP_Mie
  USE AER_MIE,    ONLY: T_550, Sph_Name, AOD_RET, DIF_RET, Dif_885, &
                        R_560, Ac_par, T_Black
  USE ALB_PARS,   ONLY: N_AWD => N_ALBEDO_WAVS_DB, ALBEDO_WAVS_DB, &
                        WL_Lca, AB_cof => ALBEDO_DB, Nc_ALB, GR_Lca, & 
                        Min_Lca, Max_Lca, F_ave, SDR => ALB_REF, INF_ALB
  USE DATA_RET,   ONLY: MDS
  USE LOG_PARS,   ONLY: DIR_OUT
  USE RETR_ITER,  ONLY: ITER => ITERATION
  USE RTM_OUTPUT, ONLY: SPEC_OUT, Tra_mu0, Tra_muv
  USE RTM_PARS,   ONLY: MAX_ITER
  USE SPHER_PARS, ONLY: ANG_OUT, NLO => N_LOS_OUT
  USE TYPES,      ONLY: KND, PREPROC_DATA

  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'RETR_AOD'
  CHARACTER (LEN=4) NAM_ITER
  INTEGER   I, J, Ic, II, Jv, N_TAU, N_WL, N_avg, Ws1, Ws2, N_X
  LOGICAL    Re_alb(NLO)
  INTEGER    K_MIN, KK, NSPEC, C_U, N_FIT, Nr, It_0
  REAL (KND), PARAMETER :: Ref_cr = 25.d0
  REAL (KND)  DP, S1, S2, Tra(SIZE(MDS(1)%WL),NLO), R_E(NLO), &
       DEL_TAU, Fr_b(NLO), A_Last(NLO), DUM, ADD(10), &
       AOD_est, x1, x2, y1, y2, slop, shri, AA, BB, AMP_PAR, Dref, &
       Dtau, DEL_CRIT
  REAL (KND)  XDIFF (N_X)
  REAL (KND), DIMENSION(SIZE(MDS(1)%WL)):: R_sph, DEL, Resid, TMP1
  REAL (KND), ALLOCATABLE :: T_GRID(:), WL_GRID(:), SPH_ALL(:,:), &
       R_DB(:)
  TYPE (PREPROC_DATA) PP_DAT(NLO)
  !==================================================================

  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE RETR_AOD
