!***************************************************************************
!
!	SCIATRAN - Version 3.8 - Last modification: 13 Sept 2017
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
Subroutine Scia_Aer_ExC (DelayedOutput, *)
  Use Aerosols, Only: AerExC_DB
  Use ST_Input, Only: SND_NAME, DAY_OF_YEAR, YEAR
  Use Tools,    Only: Array_From_String, Read_Text, Split_String, ErrMsg
  Use Types,    Only: DYN_CHAR, DYN_CHAR_L
  Logical DelayedOutput
  ! Local  parameters
  Character (Len=*), Parameter :: R_NAME='Scia_Aer_ExC'
  Character YY*4, MM*2
  Integer  IU, Info, KK, NN, II, MS, YS, Month, Day
  TYPE (DYN_CHAR_L), ALLOCATABLE :: ReadArr(:)
  TYPE (DYN_CHAR), ALLOCATABLE :: Msg(:), STR_ARR(:)
  !==================================================================
  CALL ST_TRACK (R_NAME, 1, 'I')

  CALL CALDAY (DAY_OF_YEAR, YEAR, MONTH, DAY )
  write(YY,'(I4)') Year
  write(MM,'(I2.2)') Month
  Call Read_Text (SND_NAME//'/'//YY//MM//'.dat', ReadArr, Info)
  If(Info /= 0) GoTo 201

  Do II = 1, Size(ReadArr)
     IF(Index(ReadArr(II)%S, 'Latitude Grid') /= 0) Then
        CALL Split_String(ReadArr(II)%S, STR_ARR, ':')
        Call Array_From_String (STR_ARR(2)%S, AerExC_DB%Lats, Info)
        If (Info /= 0) GoTo 202
        Cycle
     End If
     IF(Index(ReadArr(II)%S, 'Longitude Grid') /= 0) Then
        CALL Split_String(ReadArr(II)%S, STR_ARR, ':')
        Call Array_From_String (STR_ARR(2)%S, AerExC_DB%Lons, Info)
        If (Info /= 0) GoTo 202
        Exit
     End If
  End Do
  NN = Size(ReadArr) - II
  If(Allocated(AerExC_DB%Data)) DeAllocate(AerExC_DB%Data)
  Allocate(AerExC_DB%Data(NN))
  Do KK = 1, NN
     AerExC_DB%Data(KK)%S = ReadArr(II + KK)%S
  End Do
!  CALL Split_String(AerExC_DB%Data(1)%S, STR_ARR)
!  READ(STR_ARR(2)%S(1:4),*,ERR = 202) YS
!  READ(STR_ARR(2)%S(5:6),*,ERR = 202) MS
!  AerExC_DB%MS_2000 = (YS - 2000)*12 + MS
  
  CALL ST_TRACK (R_NAME, 1, 'O')
  Return
201 Continue
  Allocate(Msg(1))
  Msg(1)%S = 'Aerosol data base is not found: '//SND_NAME//'/'//YY//MM//'.dat'
  call ErrMsg(R_Name, 'e', Msg, DelayedOutput)
  Return 1
202 Continue
  Allocate(Msg(1))
  Msg(1)%S = 'Error reading aerosol data base: '//STR_ARR(2)%S
  call ErrMsg(R_Name, 'e', Msg, DelayedOutput)
  Return 1

!***************************************************************************
End Subroutine Scia_Aer_ExC
!***************************************************************************
