!***************************************************************************
!
!	SCIATRAN - Version 4.0 - Last modification: 09 May 2018
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
SUBROUTINE ST_TRACK (R_NAME, LL_NUM, IO_STR)
  Use OutInf,      Only: LOG_LEVEL, LUNIT, C_UNIT, TRC_FLG, OFFSET
  USE TOOLS,       ONLY: UPPER_LOWER_CASE, WriteOut
  USE TYPE_VARS,   ONLY: KND

  INTEGER, INTENT(IN) :: LL_NUM
  CHARACTER (LEN = *), INTENT(IN) :: R_NAME, IO_STR

! Local variables:
  INTEGER             LL 
  CHARACTER (LEN(IO_STR)) IO_STR_LC
  CHARACTER (LEN = :), ALLOCATABLE :: STRING, STR_IN, STR_OUT

  IF(.NOT.TRC_FLG(LL_NUM)) RETURN

  STR_IN  = '--------->  '
  STR_OUT = '<---------  '

  IO_STR_LC = IO_STR
  CALL UPPER_LOWER_CASE (IO_STR_LC,'U2L')
  SELECT CASE (TRIM(IO_STR_LC))
  CASE('i', 'inp') 
     OFFSET = OFFSET + 3
     STRING = REPEAT(' ',OFFSET)//STR_IN
  CASE('o', 'out') 
     STRING = REPEAT(' ',OFFSET)//STR_OUT
     OFFSET = OFFSET - 3
  END SELECT
  
  Call WriteOut(LUNIT,STRING//R_NAME,.True.)
  RETURN

END SUBROUTINE ST_TRACK
