!***************************************************************************
!
!	SCIATRAN - Version 3.8 - Last modification: 13 Sep 2017
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!***************************************************************************
Subroutine Write_Err_Log (*)
  Use Log_Pars, only: ErrLog, EU, Error_List, FIRST_ERR
  ! Local parameters
  Integer II, K
  Logical  ErrFlg
  !==================================================================
  ErrFlg = .False.

  If(Associated(ErrLog)) Nullify(ErrLog%next_msg)
  ErrLog => first_err
  do while (associated(ErrLog))
    SELECT CASE (ErrLog%Type)
    CASE ('ERROR', 'WARNING')
       write(eu,'(A)') &
            ' *** '//ErrLog%Type//' in '//ErrLog%SubrN//': '!//ErrLog%Msg(1)%S
       Do II = 1, Size(ErrLog%MSG)
          write(eu,'(A)') '     '//ErrLog%Msg(II)%S
       End Do
       If(ErrLog%Type == 'ERROR') ErrFlg = .TRUE.
    CASE ('TRACING')
       Write(EU, *) ' ---> Called by '//ErrLog%SubrN
    END SELECT
    ErrLog => ErrLog%next_msg
  end do

  If(ErrFlg) Return 1
  Return
!**************************************************************************
End Subroutine Write_Err_Log
!**************************************************************************
Subroutine Write_Out_Log
  Use OutInf,  Only: OutLog, L_S, L_E, L_ER, L_U, Output_List, FIRST_OUT, LUF
  Use ST_Vars, Only: CI_FLG
  Use Tools,   Only: WriteOut
  Use VersNum, Only: VERSION

  ! Local parameters
  Integer II, K
  !==================================================================

  !  DO K = L_S, L_ER
  DO K = L_S, L_E
     Call WriteOut (L_U(K),' ************************************************', LUF(K))
     Call WriteOut (L_U(K),' *************   SCIATRAN '//Version//'   ***************', LUF(K))
     Call WriteOut (L_U(K),' ************************************************', LUF(K))
  END DO

  If(Associated(OutLog)) Nullify(OutLog%next_out)
  IF(CI_FLG) Then
     DO K = L_S, L_E
        Call WriteOut (L_U(K), ' *** Global settings:', LUF(K))
     END DO
  End If
  OutLog => first_out
  do while (associated(OutLog))
     If (Index(OutLog%Head, 'Screen output') /=0) Then
        IF(CI_FLG) Then
           DO K = L_S, L_E
              Call WriteOut (L_U(K), ' *** End of global settings', LUF(K))
           END DO
        End If
     End If
        
     DO K = L_S, L_E
        Call WriteOut (L_U(K), ' '//OutLog%Head, LUF(K))       
        IF(SIZE(OutLog%Txt) == 0) Call WriteOut(L_U(K),'      --> ', LUF(K))
        DO II = 1, SIZE(OutLog%Txt)
           Call WriteOut (L_U(K), '      --> '//OutLog%Txt(II)%S, LUF(K))
        END DO
     END DO
     OutLog => OutLog%next_out
  end do

  Return
!**************************************************************************
End Subroutine Write_Out_Log
!**************************************************************************
