!*********************************************************************
!
!	SCIATRAN - Version 4.5 - Last modification: 16 Feb 2022
!
!	Copyright (C) - Institute of Remote Sensing,
!			University of Bremen, Germany
!
!*********************************************************************
SUBROUTINE WRITE_FIT (KN, XVec, NY_DS, PP_DAT)
  ! Called by "retrieval.f90"

  USE DATA_RET,   ONLY: MDS
  USE INFO,       ONLY: RET_INFO,STATE
  USE LOG_PARS,   ONLY: DIR_OUT, C_UNIT
  USE SPHER_PARS, ONLY: N_LOS_OUT
  USE RETR_ITER,  ONLY: I_MAP
  USE TYPES,      ONLY: KND, PREPROC_DATA, XVecType
  USE ST_VARS,    ONLY: NSEGS,WL_SEGS, BRDF_FLAG, SURF_TYPE
  !------------------------------------------------------------------
  REAL (KND), Allocatable :: KN(:,:)
  INTEGER  NY_DS(SIZE(MDS))
  TYPE (PREPROC_DATA) PP_DAT(SIZE(MDS), N_LOS_OUT)
  Type (XVecType), Allocatable :: XVec(:)

  ! Local parameters
  CHARACTER (LEN = *), PARAMETER :: R_NAME = 'WRITE_FIT'
  INTEGER  I, II, Isc, KK, J, LL,MM, N_PAR, IS, IL, IDS, NDS, NSPEC,JSEG 
  INTEGER  I_S(NSEGS),I_E(NSEGS)
  REAL (KND) SUM0, SUM1, SUM2
  REAL (KND), DIMENSION (Size(XVec)) ::  WF_OUT_1, WF_OUT_2
! -----------------------------------------------------------------
  INTERFACE
     SUBROUTINE RLC_TO_BRF(NSP, WL_INT)
       USE BRDF, ONLY: BRDF_PARAM, IVG_cof, WL_BRF, Nwl_BRF, Nwl_veg, &
            WL_veg
       USE BRDF_SUBRS, ONLY: BRDF_ACT_DOM
       USE DATA_RET,   ONLY: MDS
       USE I_DIMS,     ONLY: Nvs
       USE LOG_PARS,   ONLY: DIR_OUT, C_UNIT
       USE SPHER_PARS, ONLY: NSZA => N_SOL_ANG, N_AZ_ANG, NLSA => N_LOS_ANG,  &
            NLO => N_LOS_OUT, ANG_OUT 
       USE ST_VARS,    ONLY: SURF_TYPE, Pie
       USE TYPE_VARS,  ONLY: KND
       INTEGER    NSP
       REAL (KND) WL_INT(:)
       OPTIONAL :: NSP, WL_INT
     END SUBROUTINE RLC_TO_BRF
  END INTERFACE
! ==================================================================

  CALL ST_TRACK (R_NAME, 2, 'I')
  CALL WRITE_MESSAGE (R_NAME, 'ERROR', 'This routine is not a part ' &
  //'of the freely distributed software package')
 
  STOP
  RETURN
END SUBROUTINE WRITE_FIT
